#ifndef GLCLIENT_H
#define GLCLIENT_H


#include <morfwindows.h>

#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library


#include <morfclasses.h>

#include "../../domain/implementation/objectdomain.h"

/*** remove this!! should be using CFrontend.h **/
#include "../../frontend/implementation/glfe.h"

namespace APPLICATION
{

	class CGFXApp : public CWinApplication
	{
	private:
		FRONTEND::CGLFrontEnd *fe;

	public:
		
		inline CGFXApp(HINSTANCE _hInstance,LPCSTR _szClassName) : CWinApplication(_hInstance, _szClassName), fe(NULL) {};
		virtual ~CGFXApp();

		static LRESULT CALLBACK staticWindowProcedure(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
		virtual LRESULT CALLBACK WindowProcedure(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

		virtual void ExecuteSlice();
		virtual ATOM RegisterWindowClass(HINSTANCE hInstance);
		virtual void RegisterClasses();
		virtual bool Init();
		virtual int Run();

		virtual FRONTEND::CFrontEnd *GetFE();
		inline FRONTEND::CGLFrontEnd *GetFrontEnd() {return fe;};

		

	};

}





#endif