#include "objectdomainactions.h"
#include "objectdomain.h"

namespace DOMAIN
{
	CObjectDomainActions::~CObjectDomainActions()
	{
	}

	void CObjectDomainActions::Forward(SCALAR speed)
	{
		if (speed>0)
		{
			GENERAL::CVector3f vel=domain.GetControllingObj()->GetVelocity();
			GENERAL::CVector3f rot=domain.GetControllingObj()->GetRotation();
			rot*=speed;
			domain.GetControllingObj()->SetVelocity(rot);

			((DOMAIN::CMD3Object*)&domain.GetControllingObj())->feCommands.push(4); // WALK
			((DOMAIN::CMD3Object*)&domain.GetControllingObj())->SetFSMState(4);
		} else {
			GENERAL::CVector3f vel=domain.GetControllingObj()->GetVelocity();
			GENERAL::CVector3f rot=domain.GetControllingObj()->GetRotation();
			rot*=speed;
			domain.GetControllingObj()->SetVelocity(rot);

			((DOMAIN::CMD3Object*)&domain.GetControllingObj())->feCommands.push(4); // WALK
			((DOMAIN::CMD3Object*)&domain.GetControllingObj())->SetFSMState(4);
//			((DOMAIN::CMD3Object*)&domain.GetControllingObj())->Command("BACKWARD");
		}
	}


	void CObjectDomainActions::Strafe(SCALAR speed)
	{
		GENERAL::CVector3f rot=domain.GetControllingObj()->GetRotation();
		GENERAL::CVector3f up(0.0f,1.0f,0.0f);
		GENERAL::CVector3f dir=up*rot;
		domain.GetControllingObj()->SetVelocity(dir*speed);
		((DOMAIN::CMD3Object*)&domain.GetControllingObj())->feCommands.push(4); // WALK
		((DOMAIN::CMD3Object*)&domain.GetControllingObj())->SetFSMState(4);
	}

	void CObjectDomainActions::Jump(SCALAR speed)
	{
		GENERAL::CVector3f rot=domain.GetControllingObj()->GetVelocity();
		rot.y=speed;
		domain.GetControllingObj()->SetVelocity(rot);
		//((DOMAIN::CMD3Object*)&domain.GetControllingObj())->feCommands.push(4); // WALK
		//((DOMAIN::CMD3Object*)&domain.GetControllingObj())->SetFSMState(4);
	}

	void CObjectDomainActions::Stop()
	{
		GENERAL::dprintf("stop\n");
		domain.GetControllingObj()->SetVelocity(GENERAL::CVector3f(0.0f,0.0f,0.0f));
		((DOMAIN::CMD3Object*)&domain.GetControllingObj())->feCommands.push(2); // IDLE
		((DOMAIN::CMD3Object*)&domain.GetControllingObj())->SetFSMState(2);
	}

	void CObjectDomainActions::LookX(float angle)
	{
		domain.GetControllingObj()->LookX(angle);
	}

	void CObjectDomainActions::LookY(float angle)
	{
		domain.GetControllingObj()->LookY(angle);
		CMatrix4f rot;
		rot.SetRotate(angle,GENERAL::CVector3f(0.0f,1.0f,0.0f));
		domain.GetControllingObj()->SetVelocity(rot * domain.GetControllingObj()->GetVelocity());

	}

	void CObjectDomainActions::LookZ(float angle)
	{
		domain.GetControllingObj()->LookZ(angle);
	}

} // namespace DOMAIN