#ifndef OBJECTDOMAINACTIONS_H
#define OBJECTDOMAINACTIONS_H

#include <map>
#include <morfclasses.h>

namespace DOMAIN
{
	class CObjectDomain;
	class CObjectDomainActions
	{
	public:
		typedef std::map<CGameObject*,CGameObject*> TDirtyObjects;

	protected:
		CObjectDomain &domain;		
		TDirtyObjects dirtyObjects;

	public:
		inline CObjectDomainActions(CObjectDomain &_domain) : domain(_domain) {};
		virtual ~CObjectDomainActions();

		inline TDirtyObjects &GetDirtyObjects() {return dirtyObjects;};

		// Actions on Controlling Object
		virtual void Forward(SCALAR speed);
		virtual void Strafe(SCALAR speed);
		virtual void Jump(SCALAR speed);
		virtual void Stop();

		virtual void LookX(float angle);
		virtual void LookY(float angle);
		virtual void LookZ(float angle);

		

	};
}

#endif