#include "CTL2Container.h"

namespace FRONTEND
{
	CCTL2Container::CCTL2Container(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback)
		: CCTL2Window(_fe, _domainObj, _guiStyle, _userdata, _callback),
		  children(),
		  screenPos(0,0),
		  renderOfs(0,0)
	{
	}
	
	CCTL2Container::~CCTL2Container()
	{
		while (!children.empty())
		{
			wptr<CCTL2Window> c = children.front();
			{
				int blu=1;
			}
			children.pop_front();
			{
				int blu=1;
			}
		}
	}

	void CCTL2Container::Init(sptr<CRenderAble> &_self)
	{
		CCTL2Window::Init(_self);
	}

	void CCTL2Container::InsertControl(sptr<CCTL2Window> &_ctl)
	{
		children.push_front(_ctl);
		_ctl->SetParent(this);

		_ctl->CalculateSurfaces();
	}

	void CCTL2Container::RemoveControl(CCTL2Window *_ctl)
	{
		TWindowList::iterator it = children.begin();
		while (it!=children.end())
		{
			if (&(*it)==_ctl) 
			{
				sptr<CCTL2Window> ctl=*it;
				if (mouseOverControl!=NULL)
					if (mouseOverControl->HasParent((CCTL2Container*)_ctl))
					{
						mouseOverControl->MouseLeave();
						MouseEnter();
						mouseOverControl=self;
					}

				if (mouseCaptureControl!=NULL)
					if (mouseCaptureControl->HasParent((CCTL2Container*)_ctl))
						mouseCaptureControl->ReleaseMouseCapture();

				if (focusedControl!=NULL)
					if (focusedControl->HasParent((CCTL2Container*)_ctl))
					{
						SetFocus();
					}
				for (int i=0; i<CCTL2_NUM_MOUSEBUTTONS; i++)
				{
					if (mouseButtonDownControl[i]!=NULL)
						if (mouseButtonDownControl[i]->HasParent((CCTL2Container*)_ctl))
							mouseButtonDownControl[i]=0;
				}

				children.erase(it);
				break;
			}

			it++;
		}
	}

	void CCTL2Container::BringToFront(CCTL2Window *_ctl)
	{
	}

	void CCTL2Container::SendToBack(CCTL2Window *_ctl)
	{
	}

	void CCTL2Container::RenderScissor(TMorfRecti _scissor, int _dt)
	{
		CCTL2Window::RenderScissor(_scissor,_dt);

/*		TWindowList::iterator it;
		for (it=children.begin(); it!=children.end(); it++)
		{
			(*it)->RenderScissor(_scissor,_dt);
		}*/

		TWindowList::reverse_iterator it;

		for (it=children.rbegin(); it!=children.rend(); it++)
		{
			if (!(*it)->IsVisible()) continue;

			GENERAL::TMorfRecti newBox;
			newBox.x=screenPos.x+(*it)->GetPos().x;//-(GLint)GetRenderOfs().x;
			newBox.y=screenPos.y+(*it)->GetPos().y;//-(GLint)GetRenderOfs().y;
			newBox.w=(*it)->GetPos().w;
			newBox.h=(*it)->GetPos().h;

			if (newBox.x<_scissor.x)
			{
				newBox.w-=(_scissor.x-newBox.x);
				newBox.x=_scissor.x;
			}
			if (newBox.x+newBox.w>_scissor.x+_scissor.w)
			{
				newBox.w=_scissor.w-(newBox.x-_scissor.x);
			}
			if (newBox.y<_scissor.y)
			{
				newBox.h-=(_scissor.y-newBox.y);
				newBox.y=_scissor.y;
			}
			if (newBox.y+newBox.h>_scissor.y+_scissor.h)
			{
				newBox.h=_scissor.h-(newBox.y-_scissor.y);
			}

			if ((newBox.w>0)&&(newBox.h>0))
			{
				(*it)->RenderScissor(newBox, _dt);
			}
		}
	}

	void CCTL2Container::CalculateSurfaces()
	{		
		screenPos = pos.pos+renderOfs;

		if (GetParent()!=NULL)
			screenPos += GetParent()->GetScreenPos();

		CCTL2Window::CalculateSurfaces();

		TWindowList::iterator it;
		for (it=children.begin(); it!=children.end(); it++)
		{
			(*it)->CalculateSurfaces();
		}
	}

	bool CCTL2Container::MouseMove(INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys)
	{
		if (mouseCaptureControl==NULL)
		{
			TWindowList::iterator it = children.begin();
			while (it!=children.end())
			{
				if ( ((*it)->ReceivesMouseMoveEvents()) && 
					 ((*it)->IsOver(
								x-((*it)->GetPos().x),
								y-((*it)->GetPos().y)))
				   )
					return (*it)->MouseMove(x-((*it)->GetPos().x),y-((*it)->GetPos().y),z,buttons,keys);
				it++;
			}
		}
		return CCTL2Window::MouseMove(x,y,z,buttons,keys);
	}

	bool CCTL2Container::MouseDown(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys)
	{
		if (mouseCaptureControl==NULL)
		{
			TWindowList::iterator it = children.begin();
			while (it!=children.end())
			{
				if ( ((*it)->ReceivesMouseButtonEvents()) && 
					 ((*it)->IsOver(
								x-((*it)->GetPos().x),
								y-((*it)->GetPos().y)))
				   )
					return (*it)->MouseDown(button,x-((*it)->GetPos().x),y-((*it)->GetPos().y),z,buttons,keys);
				it++;
			}
		}
		return CCTL2Window::MouseDown(button,x,y,z,buttons,keys);
	}

	bool CCTL2Container::MouseUp(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys)
	{
		if (mouseCaptureControl==NULL)
		{
			TWindowList::iterator it = children.begin();
			while (it!=children.end())
			{
				if ( ((*it)->ReceivesMouseButtonEvents()) && 
					 ((*it)->IsOver(
								x-((*it)->GetPos().x),
								y-((*it)->GetPos().y)))
				   )
					return (*it)->MouseUp(button,x-((*it)->GetPos().x),y-((*it)->GetPos().y),z,buttons,keys);
				it++;
			}
		}
		return CCTL2Window::MouseUp(button,x,y,z,buttons,keys);
	}

	void CCTL2Container::SetChildPos(int _osx, int _osy, int _nsx, int _nsy, CCTL2Window *_win)
	{
		int dx = _nsx-_osx;
		int dy = _nsy-_osy;
		TMorfRecti nwp=_win->GetPos();

		if (_win->HasAnchorLeft())
		{
			if (_win->HasAnchorRight())
			{
				// LEFT & RIGHT
				nwp.w+=dx;
			} 
			else 
			{
				// LEFT
			}
		} 
		else 
		{
			if (_win->HasAnchorRight())
			{
				nwp.x+=dx;
				// RIGHT
			} 
			else 
			{
				// NONE
				nwp.w+=dx/2;
			}
		}

		if (_win->HasAnchorBottom())
		{
			if (_win->HasAnchorTop())
			{
				// BOTTOM & TOP
				nwp.h+=dy;
			} 
			else 
			{
				// BOTTOM
			}
		} 
		else 
		{
			if (_win->HasAnchorTop())
			{
				nwp.y+=dy;
				// TOP
			} 
			else 
			{
				// NONE
				nwp.h+=dy/2;
			}
		}
		_win->_SetPos(nwp.x,nwp.y,nwp.w,nwp.h);
	}

	void CCTL2Container::_Resize(int w, int h)
	{
		int osx = GetPos().w;
		int osy = GetPos().h;
		CCTL2Window::_Resize(w,h);

		TWindowList::iterator it;
		for (it = children.begin(); it != children.end(); it++)
			SetChildPos(osx,osy,GetPos().w,GetPos().h,&*it);
//		SetClientSize();
	}

}