#ifndef CTL2SCROLLINGCONTAINER_H
#define CTL2SCROLLINGCONTAINER_H

#include "CTL2ClientWindow.h"
#include "CTL2ScrollBar.h"
#include "CTL2Label.h"

namespace FRONTEND
{
	class CCTL2ScrollingContainer : public CCTL2ClientWindow
	{
	protected:
		sptr<CCTL2ScrollBar> vScrollBar;
		sptr<CCTL2ScrollBar> hScrollBar;
		TMorfPointi scrollAreaSize;

	protected:
		virtual void CalculateWindowSize(int &_cx, int &_cy);
		virtual void SetClientSize();
		static bool StaticCallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,void *pparam, void *userdata);
		virtual bool CallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,TCTL2PParam *pparam);

	public:
		CCTL2ScrollingContainer(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback = DummyCallBack);		
		virtual ~CCTL2ScrollingContainer();
		virtual void Init(sptr<CRenderAble> &_self);
		virtual void CalculateClientSize(TMorfRecti &rect);
		virtual void _Resize(int w, int h);
	};

	class CCTL2Dialog : public CCTL2ScrollingContainer
	{
	protected:
		sptr<CCTL2ClientWindow> titleBar;
		sptr<CCTL2Label> titleLabel;
		sptr<CCTL2Button> closeButton;

		virtual void CalculateWindowSize(int &_cx, int &_cy);
	protected:
		virtual bool CallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,TCTL2PParam *pparam);

	public:
		CCTL2Dialog(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback = DummyCallBack);		
		virtual ~CCTL2Dialog();
		virtual void Init(sptr<CRenderAble> &_self);
		virtual void CalculateClientSize(TMorfRecti &rect);

		inline void SetTitle(char *_title) { titleLabel->SetText(_title); };
		inline char *GetTitle() { return titleLabel->GetText(); };
	};
}

#endif