#ifndef CTL2STRINGLIST_H
#define CTL2STRINGLIST_H

#include "CTL2ClientWindow.h"
#include "CTL2ScrollBar.h"

namespace FRONTEND
{
	class CCTL2StringList : public CCTL2ClientWindow
	{
	public:
		typedef std::deque<std::string> TLineList;

	protected:
		sptr<CCTL2ScrollBar> vScrollBar;
		int visibleLines;
		TLineList lines;
		TLineList *useLines;
		long updateTime;
		long curTime;

		virtual void CalculateWindowSize(int &_cx, int &_cy);
		static bool StaticCallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,void *pparam, void *userdata);
		virtual bool CallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,TCTL2PParam *pparam);
	public:
		CCTL2StringList(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback = DummyCallBack);		
		virtual ~CCTL2StringList();
		virtual void Init(sptr<CRenderAble> &_self);
		virtual void CalculateClientSize(TMorfRecti &rect);
		virtual void _Resize(int w, int h);
		
		virtual void InsertLine(char *text, int at);
		virtual void SetUseLines(TLineList *_useLines) {useLines = _useLines;};
		virtual void CalculateSurfaces();

		virtual void RenderScissor(TMorfRecti _scissor, int _dt);
	};
}

#endif