#include "DLG2Console.h"
#include "../implementation/glFE.h"

namespace FRONTEND
{
	CDLG2Console::CDLG2Console(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback)
		: CCTL2Dialog(_fe, _domainObj, _guiStyle,_userdata,_callback),
		  edit(new CCTL2Edit(_fe,NULL,_guiStyle,NULL,StaticCallBack)),
		  stringList(new CCTL2StringList(_fe,NULL,_guiStyle,NULL,StaticCallBack))
	{
	}

	void CDLG2Console::Init(sptr<CRenderAble> &_self)
	{
		SetAnchorRight();
		SetAnchorLeft();
		SetAnchorTop();
		ClearAnchorBottom();


		CCTL2Dialog::Init(_self);
		SetScrollAreaAutoSizeX();
		SetScrollAreaAutoSizeY();


		edit->SetUserdata(this);
		edit->Init((sptr<CRenderAble>)edit);
		InsertControl((sptr<CCTL2Window>)edit);
		edit->ClearAnchorTop();
		edit->SetAnchorBottom();
		edit->SetAnchorLeft();
		edit->SetAnchorRight();
		edit->ClearMultiLine();
		edit->ClearWordWrap();
		edit->SetPos(0,0,edit->GetParent()->GetPos().w,GetShader()->fnt->GetHeight());
		edit->SetNotMoveable();
		edit->SetNotResizeable();

		stringList->SetUserdata(this);
		stringList->Init((sptr<CRenderAble>)stringList);
		InsertControl((sptr<CCTL2Window>)stringList);
		stringList->SetUseLines(&GENERAL::debugconsole);
		stringList->SetAnchorTop();
		stringList->SetAnchorBottom();
		stringList->SetAnchorLeft();
		stringList->SetAnchorRight();
		stringList->SetPos(0,GetShader()->fnt->GetHeight(),edit->GetParent()->GetPos().w,stringList->GetParent()->GetPos().h-GetShader()->fnt->GetHeight());
		stringList->SetNotMoveable();
		stringList->SetNotResizeable();
		stringList->SetBorderSize(0,0,0,2);

		SetBorderSize(0,0,0,4);
		titleBar->Hide();
		vScrollBar->Hide();
		hScrollBar->Hide();

		SetPos(0,parent->GetPos().h-GetPos().h,parent->GetPos().w,GetPos().h);
		SetClientSize();
	}

	void CDLG2Console::AppendText(char *_text)
	{
		stringList->InsertLine(_text,-1);
	}

	bool CDLG2Console::CallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,TCTL2PParam *pparam)
	{
		if (ctl==&edit)
		{
			if (action==CB2ACTION_KEYPRESS)
			{
				if (lparam=='\r')
				{
					((CGLFrontEnd*)fe)->ExecuteCommand(edit->GetText());
					edit->SetText("");

					return true;
				}
			}
		}
		return CCTL2Dialog::CallBack(ctl,action,lparam,pparam);
	}



}