#include "DLG2IconContainer.h"
#include "../implementation/glFE.h"


namespace FRONTEND
{
#define ICONSIZE 48

	CDLG2IconContainer::CDLG2IconContainer(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, char *_title, void *_userdata, FCTL2CallBack _callback)
		: CCTL2Dialog(_fe,_domainObj,_guiStyle,_userdata,_callback),
		  title(strdup(_title))
	{}

	void CDLG2IconContainer::Init(sptr<CRenderAble> &_self)
	{
		CCTL2Dialog::Init(_self);

		domainObj->AddUpdateRenderable(this);
		titleLabel->SetText(title);
		SAFE_FREE(title);
		vScrollBar->Hide();
		SetScrollAreaAutoSizeY();
		Update();
		SetClientSize();

/*		int x,y,w,h;
		x=y=0;
		w=GetPos().w;
		h=GetPos().h;
		CalculateClientSize(x,y,w,h);
		clientWindow->SetPos(x,y,w,h);*/	
	}

	bool CDLG2IconContainer::CallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,TCTL2PParam *pparam)
	{
		if ( (ctl==&closeButton) && (action==CB2ACTION_MOUSECLICK) )
		{
			domainObj->RemoveUpdateRenderable(this);
		} 
		else 
		{
			if ((ctl->GetCTLID()>0) && (action==CB2ACTION_MOUSECLICK))
			{
				DOMAIN::CGameObject::tActionList al;
				GetDomainObj()->GetActionList(al,0);
				((CGLFrontEnd*)fe)->PopUp(&ctl->GetDomainObj()->GetfeData(),al);
			}
		}
		return CCTL2Dialog::CallBack(ctl,action,lparam,pparam);
	}

	void CDLG2IconContainer::Update(int _flags)
	{
		sptr<CCTL2Icon> ic;

		CCTL2Dialog::Update(_flags);

		std::vector<sptr<CCTL2Icon> >::iterator iit;
		for (iit=icons.begin(); iit!=icons.end(); iit++)
		{
			RemoveControl(&(*iit));
		}
		icons.clear();

		int i = (int)domainObj->GetChilds().size();
		if (i<1) i=1;
		scrollAreaSize.x = 2+i*(ICONSIZE+2);
		vScrollBar->SetMaxVal(scrollAreaSize.x);
		if (i>4) i=4;
		clientArea->Resize(2+i*(ICONSIZE+2),ICONSIZE+4);

		i=0;

		DOMAIN::CGraphObject::tChildsType::iterator it;
		for (it = domainObj->GetChilds().begin(); it != domainObj->GetChilds().end(); it++, i++)
		{
			ic = new CCTL2Icon((CFrontEnd*)fe, &(*it), guiStyle, this, StaticCallBack);
			ic->Init((sptr<CRenderAble>)ic);
			ic->SetPos(2+((ICONSIZE+2)*i),2,ICONSIZE,ICONSIZE);
			ic->SetCTLID(i+1);
			InsertControl((sptr<CCTL2Window>)ic);
			icons.push_back(ic);
		}
	}

}