#include "DLG2PlayerSelection.h"

#include "../implementation/glfe.h"


namespace FRONTEND
{
	CDLG2PlayerSelection::CDLG2PlayerSelection(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback)
		: CCTL2ClientWindow(_fe,_domainObj,_guiStyle,_userdata,_callback),
		lblCaption(new CCTL2Label(_fe,_domainObj,_guiStyle,_userdata,_callback)),
		bHitpoints(new CCTL2Bar(_fe,_domainObj,_guiStyle,"data/icons/bar",_userdata,_callback))
	{
	}
	
	void CDLG2PlayerSelection::Init(sptr<CRenderAble> &_self)
	{
		CCTL2ClientWindow::Init(_self);
		
		SetPos(((CGLFrontEnd*)fe)->GetWidth()/2-100,((CGLFrontEnd*)fe)->GetHeight()-30,200,/*GetShader()->fnt->GetHeight()+2*/30);

		//clientArea->Resize(150,5*GetShader()->fnt->GetHeight());

		SetBorderSize(0,0,0,0);


		lblCaption->Init((sptr<CRenderAble>)lblCaption);
//		lblCaption->SetCTLID(345);
		lblCaption->ClearMultiLine();
		lblCaption->ClearWordWrap();
		lblCaption->SetAlignHLeft();
		lblCaption->SetAlignVCenter();
		lblCaption->SetAnchorTop();
		lblCaption->SetAnchorLeft();
		lblCaption->SetAnchorRight();
		lblCaption->ClearAnchorBottom();	
		lblCaption->SetPos(0,/*GetShader()->fnt->GetHeight()*/ 10,clientArea->GetPos().w,GetShader()->fnt->GetHeight()+2);
		InsertControl((sptr<CCTL2Window>)lblCaption);

		lblCaption->SetAlignVCenter();
		//lblCaption->HideBackground();
		lblCaption->SetNotMoveable();

		bHitpoints->Init((sptr<CRenderAble>)bHitpoints);
		bHitpoints->SetPos(0,0,200,10);

		bHitpoints->SetMaxPos(200);
		bHitpoints->SetActPos(30);

		bHitpoints->SetNotResizeable();






		InsertControl((sptr<CCTL2Window>)bHitpoints);


	}

	bool CDLG2PlayerSelection::CallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,TCTL2PParam *pparam)
	{
		//return CCTL2ClientWindow::CallBack(ctl,action,lparam,pparam);
		return DummyCallBack(ctl,action,lparam,pparam,0);
	}

	void CDLG2PlayerSelection::Update(int _flags)
	{
		if (domainObj)
		{
			char *blu = (char*)domainObj->GetCaption();
			lblCaption->SetText(blu);

			if (ISOFTYPE(domainObj,DOMAIN::CCharacterObject))
			{
				if (((DOMAIN::CCharacterObject*)domainObj)->GetHealth()<=0)
				{
					std::string blo = "A corpse of "+std::string(blu);
					
					lblCaption->SetText((char*)blo.data());

				}
				bHitpoints->Show();
				bHitpoints->SetMaxPos(200);
				bHitpoints->SetActPos(((DOMAIN::CCharacterObject*)domainObj)->GetHealth()*2);
			}
			else
			{
				bHitpoints->Hide();
			}


		}
		else lblCaption->SetText("");
	}








		CDLG2Spiderquest::CDLG2Spiderquest(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback)
		: CCTL2ClientWindow(_fe,_domainObj,_guiStyle,_userdata,_callback),
		lblCaption(new CCTL2Label(_fe,_domainObj,_guiStyle,_userdata,_callback)),
		LblLeft(new CCTL2Label(_fe,_domainObj,_guiStyle,_userdata,_callback))
		
	{
	}

	void CDLG2Spiderquest::SetLBL()
	{
		char text[1024];

		sprintf(text,"%d spiders left",numSpiders);
		LblLeft->SetText(text);
	}
	
	void CDLG2Spiderquest::Init(sptr<CRenderAble> &_self)
	{
		CCTL2ClientWindow::Init(_self);
		
		SetPos(400,10,150,31);

		//clientArea->Resize(150,5*GetShader()->fnt->GetHeight());

		//SetBorderSize(0,0,0,0);


		lblCaption->Init((sptr<CRenderAble>)lblCaption);
//		lblCaption->SetCTLID(345);
		lblCaption->ClearMultiLine();
		lblCaption->ClearWordWrap();
		lblCaption->SetAlignHLeft();
		lblCaption->SetAlignVCenter();
		lblCaption->SetAnchorTop();
		lblCaption->SetAnchorLeft();
		lblCaption->SetAnchorRight();
		lblCaption->ClearAnchorBottom();	
		lblCaption->SetPos(0,15,clientArea->GetPos().w,15);
		InsertControl((sptr<CCTL2Window>)lblCaption);

		
		//lblCaption->HideBackground();
		lblCaption->SetNotMoveable();

		lblCaption->SetText("Kill the spiders");

		LblLeft->Init((sptr<CRenderAble>)LblLeft);
//		LblLeft->SetCTLID(345);
		LblLeft->ClearMultiLine();
		LblLeft->ClearWordWrap();
		LblLeft->SetAlignHLeft();
		LblLeft->SetAlignVCenter();
		LblLeft->SetAnchorTop();
		LblLeft->SetAnchorLeft();
		LblLeft->SetAnchorRight();
		LblLeft->ClearAnchorBottom();	
		LblLeft->SetPos(0,0,clientArea->GetPos().w,15);
		InsertControl((sptr<CCTL2Window>)LblLeft);

		LblLeft->SetAlignVCenter();
		//LblLeft->HideBackground();
		LblLeft->SetNotMoveable();


		SetLBL();
	}

	bool CDLG2Spiderquest::CallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,TCTL2PParam *pparam)
	{
		//return CCTL2ClientWindow::CallBack(ctl,action,lparam,pparam);
		return DummyCallBack(ctl,action,lparam,pparam,0);
	}

	void CDLG2Spiderquest::Update(int _flags)
	{
		
	}



}