#include "DLG2Status.h"

namespace FRONTEND
{
	CDLG2Status::CDLG2Status(CFrontEnd *_fe, DOMAIN::CGraphObject *_domainObj, HResGUIStyle &_guiStyle, void *_userdata, FCTL2CallBack _callback)
		: CCTL2Dialog(_fe, _domainObj, _guiStyle,_userdata,_callback),
		  fps(new CCTL2Label(_fe,NULL,_guiStyle,NULL)),
		  triangles(new CCTL2Label(_fe,NULL,_guiStyle,NULL)),
		  campos(new CCTL2Label(_fe,NULL,_guiStyle,NULL)),
		  viewdir(new CCTL2Label(_fe,NULL,_guiStyle,NULL)),
		  time(new CCTL2Label(_fe,NULL,_guiStyle,NULL))
	{
	}

	void CDLG2Status::Init(sptr<CRenderAble> &_self)
	{
		CCTL2Dialog::Init(_self);
		SetScrollAreaAutoSizeX();
		SetScrollAreaAutoSizeY();

		vScrollBar->Hide();
		hScrollBar->Hide();
		clientArea->Resize(150,5*GetShader()->fnt->GetHeight());
		titleLabel->SetText("Status");
//		SetClientSize();

		sptr<CCTL2Label> labels[5] = {fps, triangles, campos, viewdir, time};
		for (int i=0; i<5; i++)
		{
			labels[i]->Init((sptr<CRenderAble>)labels[i]);
			labels[i]->ClearMultiLine();
			labels[i]->ClearWordWrap();
			labels[i]->SetAlignHLeft();
			labels[i]->SetAlignVCenter();
			labels[i]->SetAnchorTop();
			labels[i]->SetAnchorLeft();
			labels[i]->SetAnchorRight();
			labels[i]->ClearAnchorBottom();	
			labels[i]->SetPos(0,(4-i)*GetShader()->fnt->GetHeight(),clientArea->GetPos().w,GetShader()->fnt->GetHeight());
			InsertControl((sptr<CCTL2Window>)labels[i]);
		}

	}

	bool CDLG2Status::CallBack(CCTL2Window* ctl,ECTL2CallBackAction action,unsigned long lparam,TCTL2PParam *pparam)
	{
		return CCTL2Dialog::CallBack(ctl,action,lparam,pparam);
	}

}