#include "glFE.h"
#include <time.h>
#include <morfclasses.h>
#include "../objects/cube.h"
#include "../objects/quakebsp.h"
#include "../objects/md3object.h"
#include "../resources/md3link.h"



#include <trace.h>

namespace GENERAL {
/*
	template <typename A,typename TYP> class TQuadricBezierPatch
	{
	public:
		TYP controlPoints[3];


		inline TQuadricBezierPatch() {};
		inline void Tesselate(TYP &out, A t)
			{
				register A t1 = (1-t);
				register A b0 = t1*t1;
				register A b1 = 2*t*t1;
				register A b2 = t*t;	

				out = controlPoints[0]*b0+controlPoints[1]*b1+controlPoints[2]*b2;
			}
	};
	*/
}

namespace FRONTEND
{
	int numSpiders = 10;

	void CGLFrontEnd::SpiderDied()
	{
		numSpiders--;

		pspider->SetLBL();

		if (numSpiders==9)
		{
			ShowMessageBox("Quest Done!","Congratulations! You have killed all Spiders.");
		}
	}


	CGLFrontEnd::CGLFrontEnd(APPLICATION::CWinApplication *_app, HINSTANCE _hinst, DOMAIN::CObjectDomain *_domain) :
		CFrontEnd(), rootui2(0), objects(0), res(0), domain(_domain), domainActions(_domain->GetActionObj())
	{
		app = _app;
		hInstance = _hinst;
		res = NULL;
		popup = NULL;
		renderer=NULL;
//R		rootui=NULL;
		statusDialog=NULL;
		loadingSrceen=NULL;
		console=NULL;
		backgroundStream=NULL;

		pselection = NULL;
		pspider = NULL;

		
	}

	CGLFrontEnd::~CGLFrontEnd()
	{
		CCTL2Window::focusedControl = 0;
		CCTL2Window::mouseOverControl = 0;
		CCTL2Window::mouseCaptureControl = 0;
		for (int i=0; i<CCTL2_NUM_MOUSEBUTTONS; i++)
			CCTL2Window::mouseButtonDownControl[i]=0;
		rootui2=0;
		console=0;
		popup=0;
		statusDialog=0;
		guiStyle=0;

		CloseSoundEngine();
		SAFE_DELETE(loadingSrceen);
		guiStyle = HResGUIStyle(0);

		
//		SAFE_DELETE(popup);
//		SAFE_DELETE(console);
//		SAFE_DELETE(statusDialog);

//		if (rootui->HasChild(ic))
//			SAFE_DELETE(ic);
//		SAFE_DELETE(rootui);

		if (renderer) delete renderer;
		if (res) delete res;

	}

	void CGLFrontEnd::SetMouseCapture()
	{
		SetCapture(hWnd);
	}
	void CGLFrontEnd::ReleaseMouseCapture()
	{
		ReleaseCapture();
	}

	bool CGLFrontEnd::Init()
	{
		//bool result = InitGL();

		InitSoundEngine();

		res = new CResManagerGL(hDC);

		renderer=new CRendererGL(this, res);

		PreloadResources();
		guiStyle = res->CreateRes("windowsstyle.sty",RESTYP_GUISTYLE);

		rootui2 = new CCTL2Container(this,NULL,guiStyle,this,staticRootUIHandler);
		rootui2->Init((sptr<CRenderAble>)rootui2);
		rootui2->SetPos(0,0,width,height);
//		rootui2->SetBorderSize(0,0,0,0);
		rootui2->HideBorder();
		rootui2->HideBackground();
		rootui2->SetNotMoveable();
		rootui2->SetNotResizeable();

/*		sptr<CCTL2ClientWindow> bw(new CCTL2Dialog(this,NULL,guiStyle,this));
		bw->Init((sptr<CRenderAble>)bw);
		bw->ClearAnchorTop();
		bw->SetAnchorBottom();

		rootui2->InsertControl((sptr<CCTL2Window>)bw);
//		bw->SetBorderSize(5,5,5,5);
		bw->SetPos(4,4,100,100);

		sptr<CCTL2ClientWindow> bw2(new CCTL2Button(this,NULL,guiStyle,this));
		bw2->Init((sptr<CRenderAble>)bw2);
		bw->InsertControl((sptr<CCTL2Window>)bw2);
		bw2->SetPos(4,4,50,50);

		sptr<CCTL2Edit> edit(new CCTL2Edit(this,NULL,guiStyle,this));
		edit->Init((sptr<CRenderAble>)edit);
		bw->InsertControl((sptr<CCTL2Window>)edit);
//		bw->SetBorderSize(5,5,5,5);
		edit->SetPos(58,4,200,50);
		edit->SetMultiLine();
		edit->SetWordWrap();
		edit->SetText("12345 12345");*/

/*		sptr<CDLG2Console> console2(new CDLG2Console(this,NULL,guiStyle,this));
		console2->Init((sptr<CRenderAble>)console2);
		rootui2->InsertControl((sptr<CCTL2Window>)console2);
		console2->SetPos(100,100,200,200);*/

		console = new CDLG2Console(this,NULL,guiStyle,this);
		rootui2->InsertControl((sptr<CCTL2Window>)console);
		console->Init((sptr<CRenderAble>)console);
		console->Hide();
//		console2->SetAnchorTop();
//		console2->SetAnchorBottom();
//		console2->SetBorderSize(5,5,5,5);
//		console2->SetPos(4,4,100,100);
//		console2->SetPos(100,100,200,200);


/*		sptr<CCTL2ScrollBar> sbv(new CCTL2ScrollBar(this,NULL,guiStyle,CCTL2ScrollBar::SB_VERTICAL,this));
		sbv->Init((sptr<CRenderAble>)sbv);
		bw->InsertControl((sptr<CCTL2Window>)sbv);
		sbv->SetPos(bw->GetClientArea()->GetPos().w-sbv->GetPos().w,sbv->GetPos().w,sbv->GetPos().w,bw->GetClientArea()->GetPos().h-sbv->GetPos().w);

		sptr<CCTL2ScrollBar> sbh(new CCTL2ScrollBar(this,NULL,guiStyle,CCTL2ScrollBar::SB_HORIZONTAL,this));
		sbh->Init((sptr<CRenderAble>)sbh);
		bw->InsertControl((sptr<CCTL2Window>)sbh);
		sbh->SetPos(0,0,bw->GetClientArea()->GetPos().w-sbh->GetPos().h,sbh->GetPos().h);
*/
//R
/*		rootui = new CCTLContainer(this, NULL,guiStyle,this,staticRootUIHandler);
		rootui->Init((sptr<CRenderAble>)rootui);
		rootui->SetBorderSize(0,0,0,0);
		rootui->SetShader(HResShader());*/

		statusDialog = new CDLG2Status(this, NULL,guiStyle,NULL);
		statusDialog->Init((sptr<CRenderAble>)statusDialog);

		pselection=new CDLG2PlayerSelection(this, 0, guiStyle, 0);
		pselection->Init((sptr<CRenderAble>)pselection);
		pselection->Hide();
		rootui2->InsertControl((sptr<CCTL2Window>)pselection);

		pspider=new CDLG2Spiderquest(this, 0, guiStyle, 0);
		pspider->Init((sptr<CRenderAble>)pspider);
		pspider->Show();
		rootui2->InsertControl((sptr<CCTL2Window>)pspider);


//C
/*		console = new CDLGConsole(this, NULL,guiStyle);
		console->Init((sptr<CRenderAble>)console);
		rootui->InsertControl((sptr<CCTLWindow>)console);
		rootui->SetFocus();*/
		
		loadingSrceen = new CGLLoadingScreenGL(this);

		Resize(width, height);	


		//rootui->Resize(width, height);
		//rootui->CalculateSurfaces();

		return true;
	}

/* move to morfmath */


	void CGLFrontEnd::Render(DOMAIN::CDomain::TObjectList *_obj)
	{

		static int lastframecount=0,frames=0;
		static float lasttime = (float)clock()/(float)CLOCKS_PER_SEC;
		static float lastRenderStart=-1;

		float currentTime=(float)clock()/(float)CLOCKS_PER_SEC;
		float dt;
		dt=(lastRenderStart==-1)?0.0f:currentTime-lastRenderStart;
		lastRenderStart=currentTime;

		static bool lastLoadingstatus=APPLICATION::CApplication::GetApplication()->GetLoadingthread().IsLoading();

		objects=NULL;

		if (APPLICATION::CApplication::GetApplication()->GetLoadingthread().IsLoading())
		{
			loadingSrceen->SetStatusString(APPLICATION::CApplication::GetApplication()->GetLoadingthread().GetStatusString());
			loadingSrceen->Render((int)dt);
			SwapBuffers(hDC);
			lastLoadingstatus=true;
			return;
		} else {
			if (lastLoadingstatus)
			{
				APPLICATION::CLoadingThread::TLoadedResources lres;
				APPLICATION::CApplication::GetApplication()->GetLoadingthread().GetLoadedResources(lres);

				while (!lres.empty())
				{
					APPLICATION::CLoadingQueuesItemResource *lqir = lres.front();
					lres.pop();

					
					//loadingSrceen->SetStatusString(lqir->GetStatusString());
					loadingSrceen->SetStatusString("Binding Textures... ");

					loadingSrceen->Render((int)dt);
					SwapBuffers(hDC);

					if (lqir->GetTargetStatus() != lqir->GetResource()->GetStatus())
					{
						lqir->GetResource()->LoadIntoGraphicAdapter(lqir->GetTargetStatus());
					}

					lqir->GetResource()->CallResourceLoaded();
					delete lqir;
				}
			}
			lastLoadingstatus=false;
		}

		lastLoadingstatus=APPLICATION::CApplication::GetApplication()->GetLoadingthread().IsLoading();

	/*	if ( (objects==0) || (_obj->empty()))
		{
			loadingSrceen->Render();
			SwapBuffers(hDC);
			return;
		}*/



		

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear Screen And Depth Buffer
		
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		SetRENDERMODE_PERSPECTIVE();
		glLoadIdentity();
		camera.Look();
		glLoadIdentity();

		float vel[3] = {1.0f,0.0f,0.0f};
		FSOUND_3D_Listener_SetAttributes(&camera.GetPos().x,vel,1.0f,0.0f,0.0f,0.0f,1.0f,0.0f);

	/*
		DOMAIN::CDomain::TObjectList::iterator it;
		for (it = _obj->begin(); it != _obj->end(); it++)
		{
			if (it->second->GetfeData())
				((CRenderAble*)it->second->GetfeData())->Render(((float)dt)*1000.0f);
		}*/

		((DOMAIN::CObjectDomain*)APPLICATION::CApplication::GetApplication()->GetDomain())->GetRootObject()->GetfeData()->Render((int)(((float)dt)*1000.0f));
//R		rootui->Render((int)(dt*1000.0f));
		rootui2->Render((int)(dt*1000.0f));

		glLoadIdentity();
		camera.Look();
		renderer->Flush();

		glPopAttrib();
/*		DOMAIN::CQuakeBsp *bsp = (DOMAIN::CQuakeBsp*)APPLICATION::CApplication::GetApplication()->GetObjectMan()->GetRef(3);
		if (bsp)
		{
			if (bsp->GetfeData())
				((CObjQuakeBspGL*)bsp->GetfeData())->RenderLeafBrushes(camera.GetPos());
		}*/


//		InitGL();
		/*SetRENDERMODE_RASTER2D();
		glLoadIdentity();	
		glTranslatef(0.375f,0.375f,0.0f);
		glPushAttrib(GL_ENABLE_BIT);

		glDisable(GL_DEPTH_TEST);
		glEnable(GL_SCISSOR_TEST);
		glScissor(0,0,width,height);


		glPopAttrib();  // GL_ENABLE_BIT*/

		SwapBuffers(hDC);

		frames++;
		float time = ((float)clock()/(float)CLOCKS_PER_SEC);

		char txt[128];
		if ( time>lasttime+1.0f )
		{
			fps=(frames-lastframecount)/(time-lasttime);
			sprintf(txt,"fps     : %f",fps);
			lastframecount=frames;
			lasttime = time;
			statusDialog->fps->SetText(txt);
		}
		sprintf(txt,"ticktime: %ld",APPLICATION::CApplication::GetApplication()->GetTicker().getTick());
		statusDialog->time->SetText(txt);
		sprintf(txt,"triangle: %d",renderer->GetTriangleCount());
		statusDialog->triangles->SetText(txt);

		if (domain->GetControllingObj()!=NULL)
		{
			sprintf(txt,"pos     : (%2.2f,%2.2f,%2.2f)",
				domain->GetControllingObj()->GetPos().x,
				domain->GetControllingObj()->GetPos().y,
				domain->GetControllingObj()->GetPos().z);
			statusDialog->campos->SetText(txt);	
		}
	}

	CRenderAble *CGLFrontEnd::RenderSelect(int x, int y)
	{
//		if (objects==0) return 0;
		// see nehe.gamedev.net lesson 32

		GLuint buffer[128*4]; // 4 ints per hit;
		GLint viewport[4];
		GLint hits;

		glGetIntegerv(GL_VIEWPORT, viewport);
		glSelectBuffer(sizeof(buffer), buffer);

		renderer->SetRenderMode(GL_SELECT);
/*		glRenderMode(GL_SELECT);
		glInitNames();
		glPushName(0);*/

		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glMatrixMode(GL_PROJECTION);		
		glPushMatrix();			
		glLoadIdentity();	
		gluPickMatrix((GLdouble) x, (GLdouble)y, 1.0f, 1.0f, viewport);
		gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,10.0f,10000.0f);

		glMatrixMode(GL_MODELVIEW);			
		glLoadIdentity();	
		camera.Look();
		glLoadIdentity();	

		CRenderAble *ro = &((DOMAIN::CObjectDomain*)APPLICATION::CApplication::GetApplication()->GetDomain())->GetRootObject()->GetfeData();
		ro->SetSelectMode(RENDERSELECT_NORMAL,0);
		ro->Render();

/*
		DOMAIN::CDomain::TObjectList::iterator it;
		for (it = objects->begin(); it != objects->end(); it++)
		{
#pragma warning( disable : 4311 )
			glLoadName((GLuint)it->second->GetfeData());
#pragma warning( default : 4311 )
			if (it->second->GetfeData())
			{
#pragma warning( disable : 4311 )
				((CRenderAble*)it->second->GetfeData())->SetSelectMode(RENDERSELECT_NORMAL,(int)it->second->GetfeData());
#pragma warning( default : 4311 )
				((CRenderAble*)it->second->GetfeData())->Render();
				((CRenderAble*)it->second->GetfeData())->SetSelectMode(RENDERSELECT_NONE,0);
			}
		}*/

		camera.Look();
		renderer->Flush();

		glPopName();
		glPopAttrib();

		hits = renderer->SetRenderMode(GL_RENDER);
//		hits = glRenderMode(GL_RENDER);

		glMatrixMode(GL_PROJECTION);		
		glPopMatrix();			
		glMatrixMode(GL_MODELVIEW);			

		if (hits>0)
		{
			GLuint choose = buffer[3];
			GLuint depth = buffer[1];

			for (int i=1; i<hits; i++)
			{
				if (buffer[i*4+1]<depth)
				{
					choose=buffer[i*4+3];
					depth=buffer[i*4+1];
				}
			}

			
			sptr<DOMAIN::CGraphObject> go=domain->GetObjMan()->GetPtr(choose);
			return go!=NULL?&go->GetfeData():NULL;
		}
		return NULL;
	}

	int CGLFrontEnd::RenderSelectDetail(int x, int y, CRenderAble *_obj)
	{
		GLuint buffer[128*4]; // 4 ints per hit;
		GLint viewport[4];
		GLint hits;

		glGetIntegerv(GL_VIEWPORT, viewport);
		glSelectBuffer(sizeof(buffer), buffer);

		renderer->SetRenderMode(GL_SELECT);

		glPushAttrib(GL_ALL_ATTRIB_BITS);

		glMatrixMode(GL_PROJECTION);		
		glPushMatrix();			
		glLoadIdentity();	
		gluPickMatrix((GLdouble) x, (GLdouble)y, 1.0f, 1.0f, viewport);
		gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,10.0f,10000.0f);

		glMatrixMode(GL_MODELVIEW);			
		glLoadIdentity();	
		camera.Look();
		glLoadIdentity();	

		_obj->SetSelectMode(RENDERSELECT_DETAIL,0);
		_obj->Render();
		_obj->SetSelectMode(RENDERSELECT_NONE,0);

		glLoadIdentity();	
		camera.Look();
		renderer->Flush();

		glPopName();

		
		glPopAttrib();

		hits = renderer->SetRenderMode(GL_RENDER);
//		hits = glRenderMode(GL_RENDER);

		glMatrixMode(GL_PROJECTION);		
		glPopMatrix();			
		glMatrixMode(GL_MODELVIEW);			

		if (hits>0)
		{
			GLuint choose = buffer[3];
			GLuint depth = buffer[1];

			for (int i=1; i<hits; i++)
			{
				if (buffer[i*4+1]<depth)
				{
					choose=buffer[i*4+3];
					depth=buffer[i*4+1];
				}
			}

			return (int)choose;
		}
		return -1;
	}

	/*********************************************************************/

	void CGLFrontEnd::SetRENDERMODE_RASTER2D()
	{
		glMatrixMode(GL_PROJECTION);						
		glLoadIdentity();									
		gluOrtho2D(0,width,0,height);
		glMatrixMode(GL_MODELVIEW);						
	}

	void CGLFrontEnd::SetRENDERMODE_PERSPECTIVE()
	{
		glMatrixMode(GL_PROJECTION);						
		glLoadIdentity();									
		gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,10.0f,10000.0f);
		glMatrixMode(GL_MODELVIEW);	
	}


	void CGLFrontEnd::ReSizeWindow(int _width, int _height)		
	{
		if (_height==0)										
		{
			_height=1;										
		}
		glViewport(0,0,_width,_height);						
//		glMatrixMode(GL_PROJECTION);						
//		glLoadIdentity();									
//		gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);
//		glMatrixMode(GL_MODELVIEW);							
//		glLoadIdentity();							

		width  = _width;
		height = _height;
	}
	

	bool CGLFrontEnd::InitGL()										
	{
		AddUsedGLExtension((void*&)glActiveTexture,"glActiveTexture");
		AddUsedGLExtension((void*&)glClientActiveTexture,"glClientActiveTexture");

		LoadGL1_2();
		LoadGL1_3();
		LoadGL1_4();
		LoadGL1_5();
		LoadGL2_0();

		char extError[1024];
		strcpy(extError,"Some needed openGL extensions are not present.\n");
		if (!CheckGLExtensions(extError+strlen(extError),1024-(int)strlen(extError)))
		{
			MessageBox(NULL,extError,"ERROR",MB_OK|MB_ICONEXCLAMATION);
			return FALSE;								// Return FALSE
		}

		glShadeModel(GL_SMOOTH);							
		glClearColor(0.0f, 0.0f, 0.0f, 0.5f);				
		glClearDepth(1.0f);									
		glEnable(GL_DEPTH_TEST);							
		glDepthFunc(GL_LEQUAL);								
		glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	

		glEnable(GL_CULL_FACE);
//		glDisable(GL_CULL_FACE);
		glFrontFace(GL_CW);

		glClientActiveTexture(GL_TEXTURE0);
		glEnable(GL_TEXTURE_2D);

		glDisable(GL_BLEND);
		glClearStencil(0);
		
		return TRUE;										
	}

	void CGLFrontEnd::PreloadResources()
	{
		GetResMan()->CreateRes("data/dune.bmp");
		GetResMan()->CreateRes("data/icons/no_icon.tga");
		GetResMan()->CreateRes("data/icons/shotgun.tga");
		GetResMan()->CreateRes("data/icons/railgun.tga");
		GetResMan()->CreateRes("data/icons/armor_l.tga");
		GetResMan()->CreateRes("data/icons/armor_u.tga");
		GetResMan()->CreateRes("data/icons/granadel.tga");
		GetResMan()->CreateRes("data/icons/lasergun.tga");

		GetResMan()->CreateRes("links/lara_head",RESTYP_MD3LINK);
		GetResMan()->CreateRes("links/lara_lower",RESTYP_MD3LINK);
		GetResMan()->CreateRes("links/lara_upper",RESTYP_MD3LINK);

		GetResMan()->CreateRes("links/keel_head",RESTYP_MD3LINK);
		GetResMan()->CreateRes("links/keel_lower",RESTYP_MD3LINK);
		GetResMan()->CreateRes("links/keel_upper",RESTYP_MD3LINK);
		GetResMan()->CreateRes("models/players/keel/keel.tga");
		GetResMan()->CreateRes("models/players/keel/keel_h.tga");

		GetResMan()->CreateRes("links/sarge_head",RESTYP_MD3LINK);
		GetResMan()->CreateRes("links/sarge_lower",RESTYP_MD3LINK);
		GetResMan()->CreateRes("links/sarge_upper",RESTYP_MD3LINK);
		GetResMan()->CreateRes("models/players/sarge/band.tga");
		GetResMan()->CreateRes("models/players/sarge/cigar.tga");

		GetResMan()->CreateRes("links/lucy_head",RESTYP_MD3LINK);
		GetResMan()->CreateRes("links/lucy_lower",RESTYP_MD3LINK);
		GetResMan()->CreateRes("links/lucy_upper",RESTYP_MD3LINK);
		GetResMan()->CreateRes("models/players/lucy/angel_h.tga");
		GetResMan()->CreateRes("models/players/lucy/angel.tga");
		GetResMan()->CreateRes("models/mapobjects/bitch/hologirl2.tga");

		GetResMan()->CreateRes("links/railgun",RESTYP_MD3LINK);
		GetResMan()->CreateRes("links/shotgun",RESTYP_MD3LINK);
		GetResMan()->CreateRes("textures/base_wall/metaltechgeomtrn",FRONTEND::RESTYP_SHADER);

		GetResMan()->CreateRes("links/crackle",RESTYP_MD3LINK);
		GetResMan()->CreateRes("models/weaphits/electric",FRONTEND::RESTYP_SHADER);
		GetResMan()->CreateRes("links/ring02",RESTYP_MD3LINK);
		GetResMan()->CreateRes("models/weaphits/ring01_1",FRONTEND::RESTYP_SHADER);

		GetResMan()->CreateRes("models/ammo/rocket/rocket.tga");
		GetResMan()->CreateRes("models/ammo/rocket/rocketfn.tga");

		GetResMan()->CreateRes("links/rocket",RESTYP_MD3LINK);
		GetResMan()->CreateRes("models/ammo/rocket/rocket",FRONTEND::RESTYP_SHADER);
		GetResMan()->CreateRes("models/ammo/rocket/rockfls1",FRONTEND::RESTYP_SHADER);
		GetResMan()->CreateRes("models/ammo/rocket/rockfls2",FRONTEND::RESTYP_SHADER);
		GetResMan()->CreateRes("models/ammo/rocket/rockflar",FRONTEND::RESTYP_SHADER);
		GetResMan()->CreateRes("models/ammo/rocket/rockfn",FRONTEND::RESTYP_SHADER);
		GetResMan()->CreateRes("links/rocketboom",RESTYP_MD3LINK);
		GetResMan()->CreateRes("weaphits/explosion/rocket",FRONTEND::RESTYP_SHADER);

		GetResMan()->CreateRes("links/granadel",RESTYP_MD3LINK);
		GetResMan()->CreateRes("models/weapons2/grenadel/grenadel",FRONTEND::RESTYP_SHADER);
		GetResMan()->CreateRes("models/weapons2/grenadel/grenadel_metal",FRONTEND::RESTYP_SHADER);

		GetResMan()->CreateRes("links/crackle_fire",RESTYP_MD3LINK);
		GetResMan()->CreateRes("models/weaphits/fireball",FRONTEND::RESTYP_SHADER);
		GetResMan()->CreateRes("links/fireboom",RESTYP_MD3LINK);
		GetResMan()->CreateRes("models/weaphits/fireboom",FRONTEND::RESTYP_SHADER);
	}

	void CGLFrontEnd::KillWindow()								
	{
		if (fullscreen)										
		{
			ChangeDisplaySettings(NULL,0);					
			ShowCursor(TRUE);								
		}

		if (hRC)											
		{
			if (!wglMakeCurrent(NULL,NULL))					
			{
				MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
			}

			if (!wglDeleteContext(hRC))						
			{
				MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
			}
			hRC=NULL;										
		}

		if (hDC && !ReleaseDC(hWnd,hDC))					
		{
			MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
			hDC=NULL;										
		}

		if (hWnd && !DestroyWindow(hWnd))					
		{
			MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
			hWnd=NULL;										
		}

		if (!UnregisterClass("OpenGL",hInstance))			
		{
			MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
			hInstance=NULL;									
		}
	}


	

	bool CGLFrontEnd::CreateFeWindow(LPCSTR title, int width, int height, int bits, bool fullscreenflag)
	{
		GLuint		PixelFormat;			// Holds The Results After Searching For A Match
		DWORD		dwExStyle;				// Window Extended Style
		DWORD		dwStyle;				// Window Style
		RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
		WindowRect.left=(long)0;			// Set Left Value To 0
		WindowRect.right=(long)width;		// Set Right Value To Requested Width
		WindowRect.top=(long)0;				// Set Top Value To 0
		WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

		fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

		
	//	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
			
		if (fullscreen)												// Attempt Fullscreen Mode?
		{
			DEVMODE dmScreenSettings;								// Device Mode
			memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
			dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
			dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
			dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
			dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
			dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

			
			if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
			{
				
				if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
				{
					fullscreen=FALSE;
				}
				else
				{
					
					MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
					return FALSE;
				}
			}
		}

		if (fullscreen)												// Are We Still In Fullscreen Mode?
		{
			dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
			dwStyle=WS_POPUP;										// Windows Style
			ShowCursor(FALSE);										// Hide Mouse Pointer
		}
		else
		{
			dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
			dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
		}

		AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Adjust Window To True Requested Size

		// Create The Window
		if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
									title,								// Class Name
									title,								// Window Title
									dwStyle |							// Defined Window Style
									WS_CLIPSIBLINGS |					// Required Window Style
									WS_CLIPCHILDREN,					// Required Window Style
									0, 0,								// Window Position
									WindowRect.right-WindowRect.left,	// Calculate Window Width
									WindowRect.bottom-WindowRect.top,	// Calculate Window Height
									NULL,								// No Parent Window
									NULL,								// No Menu
									hInstance,							// Instance
									(void*)app)))								// Dont Pass Anything To WM_CREATE
		{
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
	/*		LPVOID lpMsgBuf;
			FormatMessage( 
				FORMAT_MESSAGE_ALLOCATE_BUFFER | 
				FORMAT_MESSAGE_FROM_SYSTEM | 
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				GetLastError(),
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
				(LPTSTR) &lpMsgBuf,
				0,
				NULL );
	
			// Process any inserts in lpMsgBuf.
			// ...

			// Display the string.
			MessageBox( NULL, (LPCTSTR)lpMsgBuf, "Error", MB_OK | MB_ICONINFORMATION );

			// Free the buffer.
			LocalFree( lpMsgBuf );
			*/
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////


			KillWindow();								// Reset The Display
			MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
			return FALSE;								// Return FALSE
		}

		static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
		{
			sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
			1,											// Version Number
			PFD_DRAW_TO_WINDOW |						// Format Must Support Window
			PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
			PFD_DOUBLEBUFFER,							// Must Support Double Buffering
			PFD_TYPE_RGBA,								// Request An RGBA Format
			bits,										// Select Our Color Depth
			0, 0, 0, 0, 0, 0,							// Color Bits Ignored
			0,											// No Alpha Buffer
			0,											// Shift Bit Ignored
			0,											// No Accumulation Buffer
			0, 0, 0, 0,									// Accumulation Bits Ignored
			16,											// 16Bit Z-Buffer (Depth Buffer)  
			1,											// 1Bit Stencil Buffer
			0,											// No Auxiliary Buffer
			PFD_MAIN_PLANE,								// Main Drawing Layer
			0,											// Reserved
			0, 0, 0										// Layer Masks Ignored
		};
		
		if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
		{
			KillWindow();								// Reset The Display
			MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
			return FALSE;								// Return FALSE
		}

		if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
		{
			KillWindow();								// Reset The Display
			MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
			return FALSE;								// Return FALSE
		}

		if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
		{
			KillWindow();								// Reset The Display
			MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
			return FALSE;								// Return FALSE
		}

		if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
		{
			KillWindow();								// Reset The Display
			MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
			return FALSE;								// Return FALSE
		}

		if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
		{
			KillWindow();								// Reset The Display
			MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
			return FALSE;								// Return FALSE
		}

		if (!InitGL())									// Initialize Our Newly Created GL Window
		{
			KillWindow();								// Reset The Display
			MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
			return FALSE;								// Return FALSE
		}

		ShowWindow(hWnd,SW_SHOW);						// Show The Window
		SetForegroundWindow(hWnd);						// Slightly Higher Priority
		SetFocus(hWnd);									// Sets Keyboard Focus To The Window


		Resize(width, height);					// Set Up Our Perspective GL Screen
		SetRENDERMODE_PERSPECTIVE();

		return TRUE;									// Success
	}

/*
	CRenderAble *CGLFrontEnd::CreateObject(DOMAIN::CGraphObject *_from)
	{
		CRenderAble *newObj = 0; 

		if (ISOFTYPE(_from, DOMAIN::CMD3Object))
		{
			DOMAIN::CMD3Object *obj = (DOMAIN::CMD3Object*)_from;
			DOMAIN::CMD3Object::tLinkMap::iterator it;

			for (it=obj->GetLinks().begin(); it!= obj->GetLinks().end(); it++)
			{
				std::vector<DOMAIN::CMD3Object::tLink>::iterator lit;

				for (lit=it->second.begin(); lit!=it->second.end(); lit++)
				{
					if ((lit->id<0) && (lit->linkedObj==NULL))
					{
						char *linkename = (char*)CONFIG::g_config.LinkIds[lit->id].data();
						lit->linkedObj = new CMD3Object(this, _from, 
							(char*)CONFIG::g_config.LinkIds[lit->id].data());
						((CMD3Object*)lit->linkedObj)->SetLinkedAtTagID(it->first);
					}
				}
			}

			/// @todo root node mu derzeit, ein frontend data sein
			/// 1 = tagID des rootlinks
			if (!obj->GetLinks()[1].empty())
				newObj = (FRONTEND::CRenderAble*)obj->GetLinks()[1].front().linkedObj;
		}
//		if (GET_KEY(DOMAIN::CAnimatedCharacterObject)==_from->GetClassKey())
//		{
//			newObj = new CMD3Model(this,_from);
//		}
		if (ISOFTYPE(_from,DOMAIN::CTestObject))
		{
			newObj = new CObjCubeGL(_from, 1.0f, GENERAL::CVector3f(0.0f,0.0f,0.0f), GENERAL::CVector3f(0.0f,0.0f,0.0f),
				res->GetPtr(NULL,"data/dune.tga"), GENERAL::TColor4ub(255,255,255,128));
		}
		if (ISOFTYPE(_from,DOMAIN::CQuakeBsp))
		{
			newObj = new CObjQuakeBspGL(this,res,(DOMAIN::CQuakeBsp*)_from);
		}
		return newObj;
	}
*/

	sptr<CRenderAble> CGLFrontEnd::CreateObject(DOMAIN::CGraphObject *_from, int _typ, int iParam, void *pParam)
	{
		sptr<CRenderAble> newObj = 0; 

		if (ISOFTYPE(_from, DOMAIN::CMD3Object))
		{
			char *linkname = (char*)CONFIG::g_config.LinkIds[_typ].data();
			newObj = new CMD3Object(this, _from, linkname);
			((CMD3Object*)&newObj)->SetLinkedAtTagID(iParam);
			((FRONTEND::CMD3Object*)&newObj)->shadowCaster = true;
			((FRONTEND::CMD3Object*)&newObj)->shadowReceiver = false;

			if (ISOFTYPE(_from, DOMAIN::CShot))
			{
				//((FRONTEND::CMD3Object*)&newObj)->shadowSource = renderer->CreateShadowSource();
				((FRONTEND::CMD3Object*)&newObj)->shadowCaster = false;
				((FRONTEND::CMD3Object*)&newObj)->shadowReceiver = false;
			}

/*			DOMAIN::CMD3Object *obj = (DOMAIN::CMD3Object*)_from;
			DOMAIN::CMD3Object::tLinkMap::iterator it;

			for (it=obj->GetLinks().begin(); it!= obj->GetLinks().end(); it++)
			{
				std::vector<DOMAIN::CMD3Object::tLink>::iterator lit;

				for (lit=it->second.begin(); lit!=it->second.end(); lit++)
				{
					if ((lit->id<0) && (lit->linkedObj==NULL))
					{
						char *linkename = (char*)CONFIG::g_config.LinkIds[lit->id].data();
						lit->linkedObj = new CMD3Object(this, _from, 
							(char*)CONFIG::g_config.LinkIds[lit->id].data());
						((CMD3Object*)lit->linkedObj)->SetLinkedAtTagID(it->first);
					}
				}
			}

			/// @todo root node mu derzeit, ein frontend data sein
			/// 1 = tagID des rootlinks
			if (!obj->GetLinks()[1].empty())
				newObj = (FRONTEND::CRenderAble*)obj->GetLinks()[1].front().linkedObj;*/
		}
//		if (GET_KEY(DOMAIN::CAnimatedCharacterObject)==_from->GetClassKey())
//		{
//			newObj = new CMD3Model(this,_from);
//		}
		if (ISOFTYPE(_from,DOMAIN::CTestObject))
		{
			newObj = new CObjCubeGL(_from, 1.0f, GENERAL::CVector3f(0.0f,0.0f,0.0f), GENERAL::CVector3f(0.0f,0.0f,0.0f),
				res->GetPtr((sptr<CRenderAble>)(NULL),"data/dune.tga"), GENERAL::TColor4ub(255,255,255,128));
		}
		if (ISOFTYPE(_from,DOMAIN::CQuakeBsp))
		{
			newObj = new CObjQuakeBspGL(this,res,(DOMAIN::CQuakeBsp*)_from);
		}
		newObj->Init(newObj);
		return sptr<CRenderAble>(newObj);
	}

	void CGLFrontEnd::SetCamera(sptr<DOMAIN::CWorldObject> _obj)
	{
		camera.Attach(_obj);
	}

	static oldx=-1,oldy=-1;

/*	void CGLFrontEnd::MouseMove(INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys)
	{
		y=height-y;
		if (CCTLWindow::mouseCapture)
		{
			CCTLWindow::mouseCapture->ScreenToClient(x,y);
			CCTLWindow::mouseCapture->MouseMove(x,y,z,buttons,keys);
			return;
		}


		rootui->MouseMove(x,y,z,buttons,keys);
	}

	void CGLFrontEnd::MouseDown(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys)
	{
		y=height-y;
		if (CCTLWindow::mouseCapture)
		{
			CCTLWindow::mouseCapture->ScreenToClient(x,y);
			CCTLWindow::mouseCapture->MouseDown(button,x,y,z,buttons,keys);
			return;
		}

		rootui->MouseDown(button,x,y,z,buttons,keys); 
		return;
	}

	void CGLFrontEnd::MouseUp(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys)
	{
		y=height-y;
		if (CCTLWindow::mouseCapture)
		{
			CCTLWindow::mouseCapture->ScreenToClient(x,y);
			CCTLWindow::mouseCapture->MouseUp(button,x,y,z,buttons,keys);
			return;
		}

		rootui->MouseUp(button,x,y,z,buttons,keys);
	}

	void CGLFrontEnd::MouseClick(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys)
	{
		y=height-y;
		if (CCTLWindow::mouseCapture)
		{
			CCTLWindow::mouseCapture->ScreenToClient(x,y);
			CCTLWindow::mouseCapture->MouseClick(button,x,y,z,buttons,keys);
			return;
		} 

		rootui->MouseClick(button,x,y,z,buttons,keys);
	}

	void CGLFrontEnd::KeyDown(int key,TKeyStates &keyState)
	{
		if (CCTLWindow::focusedControl)
		{
			if (CCTLWindow::focusedControl->KeyDown(key,keyState)) return;
		}

	/1*	const float speed=10.0f;
		if (key==VK_UP)
		{
			domain->GetControllingObj()->Forward(speed);
		}
		if (key==VK_DOWN)
		{
			domain->GetControllingObj()->Forward(-speed);
		}*1/
		if (domain->GetControllingObj()!=NULL)
		{
			char buffer[128];
			sprintf(buffer,"CamPos  : (%2.2f,%2.2f,%2.2f)",
				domain->GetControllingObj()->GetPos().x,
				domain->GetControllingObj()->GetPos().y,
				domain->GetControllingObj()->GetPos().z);
			statusDialog->campos->SetText(buffer);
		}
	}

	void CGLFrontEnd::KeyUp(int key,TKeyStates &keyState)
	{
		if (CCTLWindow::focusedControl)
		{
			if (CCTLWindow::focusedControl->KeyUp(key,keyState)) return;
		}
	}

	void CGLFrontEnd::KeyPress(int key,TKeyStates &keyState)
	{
		if (CCTLWindow::focusedControl)
		{
			if (CCTLWindow::focusedControl->KeyPress(key,keyState)) return;
		}
	}

	void CGLFrontEnd::Resize(INT x, INT y)
	{
		ReSizeWindow(x,y);
		if (rootui!=NULL)
			rootui->Resize(x,y);
		//CFrontEnd::Resize(x,y);
	}*/

	void CGLFrontEnd::MouseMove(INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys)
	{
		y=height-y;
		CCTL2Window *control;
		if (CCTL2Window::mouseCaptureControl!=NULL)
			control = &CCTL2Window::mouseCaptureControl;
		else
			control = &rootui2;
			
		TMorfPointi p(x,y);
		control->ScreenToClient(p);
		control->MouseMove(p.x,p.y,z,buttons,keys);
	}

	void CGLFrontEnd::MouseDown(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys)
	{
		y=height-y;
		CCTL2Window *control;
		if (CCTL2Window::mouseCaptureControl!=NULL)
			control = &CCTL2Window::mouseCaptureControl;
		else
			control = &rootui2;
			
		TMorfPointi p(x,y);
		control->ScreenToClient(p);
		control->MouseDown(button,p.x,p.y,z,buttons,keys);
	}

	void CGLFrontEnd::MouseUp(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys)
	{
		y=height-y;
		CCTL2Window *control;
		if (CCTL2Window::mouseCaptureControl!=NULL)
			control = &CCTL2Window::mouseCaptureControl;
		else
			control = &rootui2;
			
		TMorfPointi p(x,y);
		control->ScreenToClient(p);
		control->MouseUp(button,p.x,p.y,z,buttons,keys);
	}

	void CGLFrontEnd::MouseClick(EMouseButton button, INT x,INT y,INT z,TMouseButtons &buttons,TKeyStates &keys)
	{
		y=height-y;
/*		if (CCTL2Window::mouseCaptureControl!=NULL)
		{
			CCTL2Window::mouseCaptureControl->MouseClick(button,x,y,z,buttons,keys);
		} else {
			rootui2->MouseClick(button,x,y,z,buttons,keys);
		}*/
	}

	void CGLFrontEnd::KeyDown(int key,TKeyStates &keyState)
	{
		if (CCTL2Window::focusedControl!=NULL)
		{
			CCTL2Window::focusedControl->KeyDown(key,keyState);
		}
	}

	void CGLFrontEnd::KeyUp(int key,TKeyStates &keyState)
	{
		if (CCTL2Window::focusedControl!=NULL)
		{
			CCTL2Window::focusedControl->KeyUp(key,keyState);
		}
	}

	void CGLFrontEnd::KeyPress(int key,TKeyStates &keyState)
	{
		if (CCTL2Window::focusedControl!=NULL)
		{
			CCTL2Window::focusedControl->KeyPress(key,keyState);
		}
	}

	void CGLFrontEnd::Resize(INT x, INT y)
	{
		ReSizeWindow(x,y);
//R		if (rootui!=NULL)
//R			rootui->Resize(x,y);
		if (rootui2!=NULL)
			rootui2->_Resize(x,y);
	}

	void CGLFrontEnd::PopUp(CRenderAble *ro, DOMAIN::CGameObject::tActionList &_actionMask)
	{
		if (popup!=NULL)
		{
//			popup->Hide();
			rootui2->RemoveControl(&popup);
//			delete popup;
//			popup = NULL;
		}

		popup = new CDLG2ActionPopUp(this,ro->GetDomainObj(),guiStyle,_actionMask,this,staticRootUIHandler);
		
		
		POINT pt;
		GetCursorPos(&pt);
		ScreenToClient(hWnd,&pt);

		popup->Init((sptr<CRenderAble>)popup);
		popup->Move(pt.x,height-pt.y-popup->GetPos().h);
		rootui2->InsertControl((sptr<CCTL2Window>)popup);
	}

	bool __cdecl CGLFrontEnd::staticRootUIHandler(CCTL2Window *control, ECTL2CallBackAction action, unsigned long int lparam, void *pparam, void *userdata)
	{

		return userdata?((CGLFrontEnd*)userdata)->RootUIHandler(control,action,lparam,(TCTL2PParam*)pparam):false;
	}

	bool __cdecl CGLFrontEnd::RootUIHandler(CCTL2Window *control, ECTL2CallBackAction action, unsigned long int lparam, TCTL2PParam *pparam)
	{
		static HCURSOR oldcursor=NULL;
		enum TState {
			STATE_NONE,
			STATE_LOOK
		};

		static TState state = STATE_NONE;
//		pparam->mouse.
		switch (action)
		{
//C
/*		case CBACTION_RESIZED:
			if (&rootui==control)
			{
				console->AlignTop();
			}
			break;*/
		case CB2ACTION_MOUSEDOWN:
			{
				if (popup!=NULL)
				{
					popup->Hide();
					popup->GetParent()->RemoveControl(&popup);
					popup=NULL;
				}

				CRenderAble *ro = RenderSelect(pparam->mouse.x,pparam->mouse.y);
				if (ro)
				{
/*					if (ISOFTYPE(ro->GetDomainObj(),DOMAIN::CQuakeBsp))
					{
						int face
					}*/


					if (ro->MouseDown(pparam->mouse.button,pparam->mouse.x,pparam->mouse.y,pparam->mouse.z,*pparam->mouse.buttons,*pparam->mouse.keys)) 
						return true;

				}
			
				if (pparam->mouse.button==MOUSEBUTTON_LEFT)
				{
					POINT p;
					p.x = width/2;
					p.y = height/2;
					ClientToScreen(hWnd,&p);
					SetCursorPos(p.x,p.y);
					oldx=width/2; oldy=height/2;

//R					rootui->CaptureMouse();
					rootui2->SetMouseCapture();
					state = STATE_LOOK;

					ShowCursor(FALSE);
				}
			}
			break;
		case CB2ACTION_MOUSEUP:
			{
				if (state=STATE_LOOK)
				{
//R					rootui->ReleaseMouse();
					rootui2->ReleaseMouseCapture();
					state=STATE_NONE;
					ShowCursor(TRUE);
				}
			}
			break;
		case CB2ACTION_MOUSEMOVE:
			if (state==STATE_LOOK)
			{
/*				cam.LookSide(-((float)(pparam->mouse.x-oldx))/150.0f);
				cam.LookUp(-((float)(pparam->mouse.y-oldy))/150.0f);*/
//				domain->GetControllingObj()->LookY(-((float)(pparam->mouse.x-oldx))/150.0f);
//				domain->GetControllingObj()->LookX(((float)(pparam->mouse.y-oldy))/150.0f);	
				
				if ((pparam->mouse.x-oldx!=0) || (pparam->mouse.y-oldy))
				{
					domainActions.LookY(-((float)(pparam->mouse.x-oldx))/150.0f);
					domainActions.LookX(((float)(pparam->mouse.y-oldy))/150.0f);	
				
					POINT p;
					p.x = width/2;
					p.y = height/2;
					ClientToScreen(hWnd,&p);

					SetCursorPos(p.x,p.y);
					oldx=width/2; oldy=height/2;


					char buffer[128];
					sprintf(buffer,"View    : (%2.2f,%2.2f,%2.2f)",
						domain->GetControllingObj()->GetRotation().x,
						domain->GetControllingObj()->GetRotation().y,
						domain->GetControllingObj()->GetRotation().z);
					statusDialog->viewdir->SetText(buffer);
				}
			}
			break;
		case CB2ACTION_MOUSECLICK:
			if (control==&popup)
			{
				//popup->GetDomainObj()
				sptr<DOMAIN::CGraphObject> go = domain->GetObjMan()->GetPtr(popup->GetDomainObj()->GetID());
				domain->GetControllingObj()->ExecuteAction(lparam, &go);
			}
			break;
		case CB2ACTION_KEYDOWN:
			if (lparam==VK_UP)
			{
				domainActions.Forward(400);
			} else
			if (lparam==VK_DOWN)
			{
				domainActions.Forward(-400);
			} else
			if (lparam==VK_LEFT)
			{
				domainActions.Strafe(400);
			} else
			if (lparam==VK_SPACE)
			{
				domainActions.Jump(400);
			} else  
			if (lparam==VK_RIGHT)
			{
				domainActions.Strafe(-400);
			} else
			if (lparam==0xdc)  // keycode for '^' german layout
			{
				if (console->IsVisible())
				{
					console->Hide();
				} else {
					console->Show();
					console->SetFocus();
				}
			} 
			break;
		case CB2ACTION_KEYUP:
			if ((lparam==VK_UP) || (lparam==VK_DOWN) ||
				(lparam==VK_LEFT) || (lparam==VK_RIGHT))
			{
				domainActions.Stop();
			}
		};

		return ((control->HasParent(&popup)) || (control==&popup));
	}

	inline char *BoolToString(GLboolean test)
	{
		return test?"enabled":"disabled";
	}

	void CGLFrontEnd::DumpGLState()
	{
		GLint	itest,itest2;
		
		dprintf("\n-------------BEGIN DUMP------------\n");

		dprintf("GL_BLEND     : %s\n", BoolToString(glIsEnabled(GL_BLEND)));
		dprintf("GL_CULL_FACE : %s\n", BoolToString(glIsEnabled(GL_CULL_FACE)));
		
		glGetIntegerv(GL_ACTIVE_TEXTURE, &itest);
		
		dprintf("\n-------------TEXTURES--------------\n");

		dprintf("Active Texture Unit: GL_TEXTURE%i\n",itest-GL_TEXTURE0);
		glActiveTexture(GL_TEXTURE0);
		dprintf("   Texture Unit 0: GL_TEXTURE_2D        : %s\n", BoolToString(glIsEnabled(GL_TEXTURE_2D)));
		glGetIntegerv(GL_TEXTURE_BINDING_2D, &itest2);
		dprintf("   Texture Unit 0: GL_TEXTURE_BINDING_2D: %i\n", itest2);


		glActiveTexture(GL_TEXTURE1);
		dprintf("   Texture Unit 1: GL_TEXTURE_2D        : %s\n", BoolToString(glIsEnabled(GL_TEXTURE_2D)));
		glGetIntegerv(GL_TEXTURE_BINDING_2D, &itest2);
		dprintf("   Texture Unit 1: GL_TEXTURE_BINDING_2D: %i\n", itest2);

		glActiveTexture(itest);
	}

	bool CGLFrontEnd::InitSoundEngine()
	{
		FSOUND_SetOutput(FSOUND_OUTPUT_WINMM);
		FSOUND_SetDriver(0); 
		if (!FSOUND_Init(44100, 32, 0)) 
		{
			dprintf("[FMOD_ERROR] %s\n",FMOD_ErrorString(FSOUND_GetError()));
			return false;
		}
		FSOUND_Stream_SetBufferSize(1000);

//		backgroundStream = FSOUND_Stream_Open("data/audio/background.mp3",FSOUND_LOOP_NORMAL | FSOUND_NORMAL | FSOUND_MPEGACCURATE /*FSOUND_NORMAL | FSOUND_2D | FSOUND_MPEGACCURATE | FSOUND_NONBLOCKING*/,0,0);
		backgroundStream = CreateSound((char*)CONFIG::g_config.ConfString["BackGroundTitle"].data(),true);
		int channel = PlaySound(backgroundStream);
		FSOUND_SetVolume(channel,CONFIG::g_config.ConfInt["MusicVolume"]);
/*		if (backgroundStream==NULL) 
		{
			dprintf("[FMOD_ERROR] %s\n",FMOD_ErrorString(FSOUND_GetError()));
		} else {
			int channel;
			if ((channel=FSOUND_Stream_PlayEx(FSOUND_FREE, backgroundStream,NULL,TRUE))==-1)
			{
				dprintf("[FMOD_ERROR] %s\n",FMOD_ErrorString(FSOUND_GetError()));
			}
			else
			{
				FSOUND_SetPaused(channel, FALSE);
			}
		}*/




		return true;
	}

	FSOUND_STREAM *CGLFrontEnd::CreateSound(char *filename, bool loop)
	{
		FSOUND_STREAM *res = FSOUND_Stream_Open(filename,(loop)?FSOUND_LOOP_NORMAL:0 | FSOUND_NORMAL | FSOUND_MPEGACCURATE,0,0);
		if (res==0)
		{
			dprintf("[FMOD_ERROR] %s\n",FMOD_ErrorString(FSOUND_GetError()));
		}
		return res;
	}

	int CGLFrontEnd::PlaySound(FSOUND_STREAM *sound, int channel)
	{
		int res = FSOUND_Stream_PlayEx(channel, sound,NULL,FALSE);
		if (res==-1)
		{
			dprintf("[FMOD_ERROR] %s\n",FMOD_ErrorString(FSOUND_GetError()));
		}

		FSOUND_SetPaused(res, FALSE);

		return res;
	}

	void CGLFrontEnd::FreeSound(FSOUND_STREAM *sound)
	{
		FSOUND_Stream_Close(sound);
	}

	void CGLFrontEnd::CloseSoundEngine()
	{
		FreeSound(backgroundStream);
		FSOUND_Close();
	}

	void CGLFrontEnd::ExecuteCommand(char *cmd)
	{
		if (cmd==NULL) return;
		console->AppendText(cmd);
		if (cmd[0]!='/') return;

		char *command = strdup(cmd);
		char *token = strtok(cmd," \t\n");

		// open status dialog
		if ((strcmp(token,"/status")==0) || 
			(strcmp(token,"/s")==0))
		{
			rootui2->InsertControl((sptr<CCTL2Window>)statusDialog);
			statusDialog->Show();
		}
		else if ((strcmp(token,"/inv")==0) || 
			(strcmp(token,"/i")==0))
		{
			CreateIconContainer(&domain->GetControllingObj()->GetInventory());
		}
		else if (strcmp(token,"/m")==0)
		{
			ShowMessageBox("message","test message");
			
		} 
		else if (strcmp(token,"/w")==0)
		{
			renderer->SetRenderWireFrame(!renderer->GetRenderWireFrame());
		} 
		else if (strcmp(token,"/l")==0)
		{
			renderer->SetRenderLights(!renderer->GetRenderLights());
		} 
		else if (strcmp(token,"/rl")==0)
		{
			renderer->SetLightingEnabled(!renderer->GetLightingEnabled());
		} 
		else if (strcmp(token,"/smooth")==0)
		{
			glShadeModel(GL_SMOOTH);							
		} 
		else if (strcmp(token,"/flat")==0)
		{
			glShadeModel(GL_FLAT);							
		} 
		else if (strcmp(token,"/n")==0)
		{
			renderer->SetRenderNormals(!renderer->GetRenderNormals());
		}
		else if (strcmp(token,"/fsmi")==0)
		{
			char *objectID = strtok(NULL," \t\n");
			if (objectID!=0) 
			{
				char *eptr;
				long iod = strtol(objectID,&eptr,0);

				DOMAIN::CGraphObject *gro = (DOMAIN::CGraphObject*) &domain->GetObjMan()->GetPtr(iod);
				
				if (!gro)
				{
					console->AppendText("/c (Open Owned Chatwindow): that ObjectId doesnt exist!");
				}
				else
				{
					CreateUIObject(gro,UITYPE_FSMINFO);

				}
			}
		}
		else if (strcmp(token,"/oc")==0)
		{
			char *objectID = strtok(NULL," \t\n");
			if (objectID!=0) 
			{
				char *eptr;
				long iod = strtol(objectID,&eptr,0);

				DOMAIN::CGraphObject *gro = (DOMAIN::CGraphObject*) &domain->GetObjMan()->GetPtr(iod);
				
				if (!gro)
				{
					console->AppendText("/c (Open Owned Chatwindow): that ObjectId doesnt exist!");
				}
				else
				{

					long cid = gro->GetOwnedChatChannel();

					if (cid!=0)				
					{
						domain->GetObjMan()->PrintDebug("objs");
						
						DOMAIN::CGameObject *ghj = &domain->GetObjMan()->GetPtr(cid);
						//sptr<DOMAIN::CGameObject> ggg = domain->GetObjMan()->GetPtr(cid);
						
						CreateUIObject((DOMAIN::CGraphObject*) ghj,UITYPE_CHATWINDOW);
						
					}
					else
					{
						
						console->AppendText("/c (Open Owned Chatwindow): that Object doesnt own a chatchannel");
					}
				}

			}
			else
			{

			
			}
		} 
		else if (strcmp(token,"/fec")==0)
		{
			char *objectID = strtok(NULL," \t\n");
			if (objectID!=0) 
			{
				char *eptr;
				long iod = strtol(objectID,&eptr,0);

				char *command = strtok(NULL," \t\n");
				if (command!=0)
				{
					std::map<std::string, long>::iterator itc = CONFIG::g_config.ModelCommands.find(command);
					if (itc!=CONFIG::g_config.ModelCommands.end())
					{
						sptr<DOMAIN::CGameObject> go = domain->GetObjMan()->GetRef(iod);
						if (go!=NULL)
						{
							if (ISOFTYPE(go,DOMAIN::CMD3Object))
							{
								((DOMAIN::CMD3Object*)&go)->feCommands.push(itc->second);
							}
						}
					}
				}

			}
		} 
		else
			console->AppendText("#! unknown command");

		free(command);
	}

	void CGLFrontEnd::CreateUIObject(DOMAIN::CGraphObject *_from, int _uitype, int lParam, void *pParam)
	{
		switch (_uitype)
		{
		default:
		case UITYPE_UNKNOWN:
			CreateIconContainer(_from);
			break;

		case UITYPE_ICONCONTAINER:
			CreateIconContainer(_from);
			break;
		case UITYPE_FSMINFO:
			{
				sptr<CDLG2FSMInfo> fsmi = new CDLG2FSMInfo(this,_from,guiStyle,0);
				fsmi->Init((sptr<CRenderAble>)fsmi);
				rootui2->InsertControl((sptr<CCTL2Window>)fsmi);
			}
			break;
		case UITYPE_CHATWINDOW:
			{
				//CDLGChat *chat = new CDLGChat(this, (DOMAIN::CGraphObject*) &domain->GetObjMan()->GetPtr(lParam), guiStyle, (sptr<DOMAIN::CGraphObject>)domain->GetControllingObj());
				//chat->Init();
				//chat->SetTitle("Talk to Lucy\n");
				
				//rootui->InsertControl(chat);

				sptr<CDLG2ChatWindow> chat = new CDLG2ChatWindow(this,_from,guiStyle,0);
				rootui2->InsertControl((sptr<CCTL2Window>)chat);
				chat->Init((sptr<CRenderAble>)chat);
				char bla[128];

				if (_from->GetParentId()==3)
				{
					sprintf(bla, "Global Chat");
				}
				else
				{
					sprintf(bla, "Chat with %s", domain->GetObjMan()->GetPtr(_from->GetParentId())->GetCaption());
				}
				
				long pid = _from->GetParentId();

			//	domain->GetObjMan()->GetPtr(_from->GetParentId())->GetCaption());
				chat->SetTitle(bla);
				

			}
		}
	
	}

	void CGLFrontEnd::CreateIconContainer(DOMAIN::CGraphObject *go)
	{
		sptr<CDLG2IconContainer> iconContainer = new CDLG2IconContainer(this, go, guiStyle, "Inventory",NULL);
		rootui2->InsertControl((sptr<CCTL2Window>)iconContainer);
		iconContainer->Init((sptr<CRenderAble>)iconContainer);
		//ic->SetPos(50,50,100,100);
		iconContainer->Show();
	}

	void CGLFrontEnd::ShowMessageBox(char *_title, char *_message)
	{
//M
/*		sptr<CMessageBoxDialog> mb(new CMessageBoxDialog(this, NULL, guiStyle, _message));
		rootui->InsertControl((sptr<CCTLWindow>)mb);
		mb->Init((sptr<CRenderAble>)mb);
		mb->SetTitle(_title);
		//mb->SetPos(50,50,100,100);
		mb->Show();*/
	}

	CGLLoadingScreenGL::CGLLoadingScreenGL(CGLFrontEnd *_fe)
	{
		fe = _fe;
		loadingSplash = fe->GetResMan()->GetPtr((sptr<CRenderAble>)(NULL),"misc/coresplash",RESTYP_SHADER);
		if (loadingSplash->GetShaderStatus()==CResShader::EShaderStatus::SS_NOTLOADED)
			loadingSplash->LoadDefaultShader("data/coresplash");

		loading = fe->GetResMan()->GetPtr((sptr<CRenderAble>)(NULL),"data/loading",RESTYP_SHADER);
		if (loading->GetShaderStatus()==CResShader::EShaderStatus::SS_NOTLOADED)
			loading->LoadDefaultShader("data/loading");

		statusString=0;

		fnt = 0;
		fnt = fe->GetResMan()->GetPtr((sptr<CRenderAble>)(NULL),"terminal12.fnt", RESTYP_BMPFONT);
		if (fnt==0) GENERAL::dprintf("[ERROR1] LoadingScreen: could not get Font\n");
	}

	void CGLLoadingScreenGL::Render(int dt)
	{
		if (loadingSplash->GetStatus()==RESSTATUS_NOTLOADED)
			return;
		static float splashVertices[4*3] = 
		{
			-1.0f,-1.0f,0.0f,
			-1.0f, 1.0f,0.0f,
			 1.0f, 1.0f,0.0f,
			 1.0f,-1.0f,0.0f,
		};		
		static float loadingVertices[4*3] = 
		{
			-0.5f,0.25f,-0.1f,
			-0.5f,0.75f,-0.1f,
			 0.5f,0.75f,-0.1f,
			 0.5f,0.25f,-0.1f,
		};
		static float normals[4*3] = 
		{
			0.0f,0.0f,1.0f,
			0.0f,0.0f,1.0f,
			0.0f,0.0f,1.0f,
			0.0f,0.0f,1.0f,
		};
		static float texCoords[4*2] = 
		{
			0.0f,1.0f,
			0.0f,0.0f,
			1.0f,0.0f,
			1.0f,1.0f,
		};

		
		GENERAL::TColor4ub cols[4];
		cols[0]=GENERAL::TColor4ub(255,255,255,255);
		cols[1]=GENERAL::TColor4ub(255,255,255,255);
		cols[2]=GENERAL::TColor4ub(255,255,255,255);
		cols[3]=GENERAL::TColor4ub(255,255,255,255);

		GENERAL::CVector3f textpos(0.0f,0.0f,-0.1f);

		splash.type=TSurface::SURFACETYPE_POLYGON;
		splash.name=0;
		splash.primitiveType=GL_QUADS;
		splash.shader=loadingSplash;
		splash.lightMap=NULL;
		splash.modelView=NULL;

		splash.numVertices=4;
		splash.vertices=(CVector3f*)splashVertices;
		splash.normals=(CVector3f*)normals;
		splash.texCoords=(CVector2f*)texCoords;
		splash.lightMapTexCoords=NULL;
		splash.colors=cols;


//		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();

//		fe->GetRenderer().PushSurface(&splash);
		GENERAL::TMorfRecti scissor;
		scissor.x=0;
		scissor.y=0;
		scissor.w=fe->GetWidth();
		scissor.h=fe->GetHeight();
		fe->GetRenderer().PushSurface(&splash,false, false);

		glPushAttrib(GL_ALL_ATTRIB_BITS);
		fe->GetRenderer().Flush();
		glPopAttrib();

		


		glClear(GL_DEPTH_BUFFER_BIT);

		glMatrixMode(GL_PROJECTION);						
		glLoadIdentity();									
		gluOrtho2D(0,fe->GetWidth(),0,fe->GetHeight());

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();

		
		glColor4ub(255,255,255,255);
		glDisable(GL_TEXTURE_2D);
		glDisable(GL_BLEND);
		glDisable(GL_STENCIL_TEST);
		glDisable(GL_DEPTH_TEST);
		glRasterPos3f(0,0,0);

		static int fgh = 0;
		fgh++;
		if (fgh>fe->GetWidth()) fgh = 0;

		glPointSize(10);
        
		glBegin(GL_POINTS);

		glVertex3f((GLfloat) fgh, 20, 0);

		glEnd();
       /* 
		if (statusString!=0)
		{
			fnt->Printf("%s",statusString);
		}
		else fnt->Print("no information");
		*/	
		glFlush();
	}

	void CGLFrontEnd::SelectionChanged(DOMAIN::CGameObject *_old, DOMAIN::CGameObject *_new)
	{
		
		if (domain->GetSelectedObject()!=0)
		{
			if (_old!=0) ((DOMAIN::CGraphObject*) _old)->RemoveUpdateRenderable(&pselection);
			pselection->SetDomainObj((DOMAIN::CGraphObject*)domain->GetSelectedObject());
			((DOMAIN::CGraphObject*)domain->GetSelectedObject())->AddUpdateRenderable(&pselection);
			pselection->Show();
		}
		else pselection->Hide();
	};


/*end namespace */
}