#include "renderer.h"

#include "../gl/glextensions.h"
#include "resman.h"
#include "glFE.h"

#include <algorithm>

#include <trace.h>

#define SM_SIZE 512

namespace FRONTEND
{
	TGLState CRendererGL::glState;
/*	// Scissor
	GLboolean		TGLState::cur_scissorEnabled;

	// PolygonMode			
	GLint			TGLState::cur_polygonMode;
	
	// Culling				
	GLboolean		TGLState::cur_cullEnabled;
	GLint			TGLState::cur_cullFace;
		
	// Rendermode
	GLenum			TGLState::cur_rendermode;

	// Render Select
	GLuint			TGLState::cur_name;

	// Blend States
	GLboolean		TGLState::cur_blendEnabled;
	GLint			TGLState::cur_blendsrc;
	GLint			TGLState::cur_blenddst;

	// AlphaTestStates
	GLboolean		TGLState::cur_alphaTestEnabled;
	GLint			TGLState::cur_alphafunc;
	GLfloat			TGLState::cur_alpharef;

	// DepthBuffer
	GLboolean		TGLState::cur_depthTestEnabled;
	GLboolean		TGLState::cur_depthMask;
	GLint			TGLState::cur_depthFunc;

	GLint			TGLState::cur_textureUnit;
	TGLTextureUnit	TGLState::textureUnits[MAXTEXTUREUNITS];

	// ClientState
	GLint			TGLState::cur_clientTextureUnit;

	// Arrays
	GLboolean		TGLState::cur_vaEnabled;
	GLint			TGLState::cur_vaSize;
	GLint			TGLState::cur_vaTyp;
	GLint			TGLState::cur_vaStride;
	GLvoid*			TGLState::cur_vaPointer;

	GLboolean		TGLState::cur_naEnabled;
	GLint			TGLState::cur_naSize;
	GLint			TGLState::cur_naTyp;
	GLint			TGLState::cur_naStride;
	GLvoid*			TGLState::cur_naPointer;

	GLboolean		TGLState::cur_iaEnabled;
	GLint			TGLState::cur_iaSize;
	GLint			TGLState::cur_iaTyp;
	GLint			TGLState::cur_iaStride;
	GLvoid*			TGLState::cur_iaPointer;

	GLboolean		TGLState::cur_efaEnabled;
	GLint			TGLState::cur_efaSize;
	GLint			TGLState::cur_efaTyp;
	GLint			TGLState::cur_efaStride;
	GLvoid*			TGLState::cur_efaPointer;

	GLboolean		TGLState::cur_caEnabled;
	GLint			TGLState::cur_caSize;
	GLint			TGLState::cur_caTyp;
	GLint			TGLState::cur_caStride;
	GLvoid*			TGLState::cur_caPointer;*/


	TShadowSource::TShadowSource()
	{
		glGenTextures(1,&map);
		glBindTexture(GL_TEXTURE_CUBE_MAP_ARB,map);
		glTexImage2D(GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB,0,GL_RGBA8,SM_SIZE,SM_SIZE,0,GL_RGBA,GL_UNSIGNED_BYTE,NULL);
		glTexImage2D(GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB,0,GL_RGBA8,SM_SIZE,SM_SIZE,0,GL_RGBA,GL_UNSIGNED_BYTE,NULL);
		glTexImage2D(GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB,0,GL_RGBA8,SM_SIZE,SM_SIZE,0,GL_RGBA,GL_UNSIGNED_BYTE,NULL);
		glTexImage2D(GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB,0,GL_RGBA8,SM_SIZE,SM_SIZE,0,GL_RGBA,GL_UNSIGNED_BYTE,NULL);
		glTexImage2D(GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB,0,GL_RGBA8,SM_SIZE,SM_SIZE,0,GL_RGBA,GL_UNSIGNED_BYTE,NULL);
		glTexImage2D(GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB,0,GL_RGBA8,SM_SIZE,SM_SIZE,0,GL_RGBA,GL_UNSIGNED_BYTE,NULL);
		glTexParameteri(GL_TEXTURE_CUBE_MAP_ARB,GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_CUBE_MAP_ARB,GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_CUBE_MAP_ARB,GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
		glTexParameteri(GL_TEXTURE_CUBE_MAP_ARB,GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
		glTexParameteri(GL_TEXTURE_CUBE_MAP_ARB,GL_TEXTURE_WRAP_R, GL_CLAMP_TO_EDGE);
	}

	TShadowSource::~TShadowSource()
	{
		glDeleteTextures(1,&map);
	}


	CRendererGL::CRendererGL(CGLFrontEnd *_fe, CResManagerGL *_resMan)
		: guiShaderList()
	{
		guiShaderList.clear();
//		guiShaderList = new TGUIShaderList();
		fe = _fe;
		bRenderWireFrame = false;
		bRenderNormals = false;
		bLightingEnabled = false;
		bRenderLights = false; 

		ambientLight.x=0.2f;
		ambientLight.y=0.2f;
		ambientLight.z=0.2f;

/*		light.diffuseColor.x=0.0f;
		light.diffuseColor.y=1.0f;
		light.diffuseColor.z=0.0f;
		light.pos=CVector4f(800,120,-2000,1.0f);
		light.constantAttenuation=0;
		light.linearAttenuation=500.0f;
		light.quadraticAttenuation=50000.0f;*/

		numVertices = 
		numNormals = 
		numColors =
		numSurfaces = 
		numShadowCaster = 
		numShadowReceiver =
		numSilhouettes = 0;
		memset(numTexCoords,0,MAXTEXTUREUNITS*sizeof(int));

		glState.cur_rendermode = GL_RENDER;
		resMan=_resMan;
		whiteTexture = resMan->GetPtr(sptr<CRenderAble>(NULL),"data/white.tga",RESTYP_TEXTURE);

		maxVertices=1024;
		maxNormals=1024;
		maxColors=1024;
		maxTexCoords[0]=1024;
		maxTexCoords[1]=1024;
		maxTexCoords[2]=16;
		maxTexCoords[3]=16;
		maxSurfaces=512;
		maxSilhouettes=32;
		maxShadowCaster=32;
		maxShadowReceiver=32;

		texCoords = (CVector2f**)malloc(sizeof(CVector2f*)*MAXTEXTUREUNITS);
		vertices = (CVector3f*)malloc(maxVertices*sizeof(CVector3f));
		normals = (CVector3f*)malloc(maxNormals*sizeof(CVector3f));
		for (int i=0;i<MAXTEXTUREUNITS;i++)
			texCoords[i] = (CVector2f*)malloc(maxTexCoords[i]*sizeof(CVector2f));
		vertexColors = (TColor4ub*)malloc(maxColors*sizeof(TColor4ub));

		surfaces = (TSurface**)malloc(maxSurfaces*sizeof(TSurface*));//[MAXPRIMITIVES];
		silhoutteSurfaces = (int*)malloc(maxSilhouettes*sizeof(int));
		shadowCasterSurfaces = (int*)malloc(maxShadowCaster*sizeof(int));
		shadowReceiverSurfaces = (int*)malloc(maxShadowReceiver*sizeof(int));


		int glMaxLights;
		glGetIntegerv(GL_MAX_LIGHTS, &glMaxLights);
        if (CONFIG::g_config.ConfInt["MaxLights"]<=glMaxLights)
            MaxLightSources = CONFIG::g_config.ConfInt["MaxLights"];
		else MaxLightSources = glMaxLights;

		TShadowSource *ss=CreateShadowSource();
		ss->pos=CVector3f(0,128,0);
	}

	CRendererGL::~CRendererGL()
	{
		for (int i=0;i<MAXTEXTUREUNITS;i++)
			SAFE_FREE(texCoords[i]);
		SAFE_FREE(texCoords);
		SAFE_FREE(vertices);
		SAFE_FREE(normals);
		SAFE_FREE(vertexColors);
		SAFE_FREE(surfaces);
		SAFE_FREE(silhoutteSurfaces);
//	delete guiShaderList;
	}

	void CRendererGL::GrowVertices(int num)
	{
		maxVertices=num;
		// grow to multiplyer of 1024
		maxVertices+=1024-(maxVertices%1024);
		vertices =		(CVector3f*)realloc(vertices	,maxVertices*sizeof(CVector3f));
	}

	void CRendererGL::GrowNormals(int num)
	{
		maxNormals=num;
		maxNormals+=1024-(maxNormals%1024);
		normals = (CVector3f*)realloc(normals ,maxNormals*sizeof(CVector3f));
	}

	void CRendererGL::GrowColors(int num)
	{
		maxColors=num;
		maxColors+=1024-(maxColors%1024);
		vertexColors = (TColor4ub*)realloc(vertexColors,maxColors*sizeof(TColor4ub));
	}

	void CRendererGL::GrowTexCoords(int num, int texunit)
	{
		maxTexCoords[texunit]=num;
		maxTexCoords[texunit]+=1024-(maxTexCoords[texunit]%1024);
		texCoords[texunit] = (CVector2f*)realloc(texCoords[texunit],maxTexCoords[texunit]*sizeof(CVector2f));
	}

	void CRendererGL::GrowSurfaces(int num)
	{
		maxSurfaces=num;
		maxSurfaces+=128-(maxSurfaces%128);

		surfaces = (TSurface**)realloc(surfaces,maxSurfaces*sizeof(TSurface*));
	}

	void CRendererGL::GrowSilhouetteSurfaces(int num)
	{
		maxSilhouettes=num;
		maxSilhouettes+=32-(maxSilhouettes%32);

		silhoutteSurfaces = (int*)realloc(silhoutteSurfaces,maxSilhouettes*sizeof(int));
	}

	void CRendererGL::GrowShadowCasterSurfaces(int num)
	{
		maxShadowCaster=num;
		maxShadowCaster+=32-(maxShadowCaster%32);

		shadowCasterSurfaces = (int*)realloc(shadowCasterSurfaces,maxShadowCaster*sizeof(int));
	}

	void CRendererGL::GrowShadowReceiverSurfaces(int num)
	{
		maxShadowReceiver=num;
		maxShadowReceiver+=32-(maxShadowReceiver%32);

		shadowReceiverSurfaces = (int*)realloc(shadowReceiverSurfaces,maxShadowReceiver*sizeof(int));
	}

	void CRendererGL::InitStates()
	{
		int i;
		// scissor
		glState.cur_scissorEnabled = glIsEnabled(GL_SCISSOR_TEST);

		// polygon mode
		glGetIntegerv(GL_POLYGON_MODE,&glState.cur_polygonMode);

		// culling
		glState.cur_cullEnabled = glIsEnabled(GL_CULL_FACE);
		glGetIntegerv(GL_CULL_FACE_MODE,&glState.cur_cullFace);

		// blending
		glState.cur_blendEnabled = glIsEnabled(GL_BLEND);
		glGetIntegerv(GL_BLEND_SRC,&glState.cur_blendsrc);
		glGetIntegerv(GL_BLEND_DST,&glState.cur_blenddst);

		// AlphaTestStates
		glState.cur_alphaTestEnabled = glIsEnabled(GL_ALPHA_TEST);
		glGetIntegerv(GL_ALPHA_TEST_FUNC,&glState.cur_alphafunc);
		glGetFloatv  (GL_ALPHA_TEST_REF,&glState.cur_alpharef);

		// DepthBuffer
		glState.cur_depthTestEnabled = glIsEnabled(GL_DEPTH_TEST);
		glGetBooleanv(GL_DEPTH_WRITEMASK,&glState.cur_depthMask);
		glGetIntegerv(GL_DEPTH_FUNC,&glState.cur_depthFunc);

		glGetIntegerv(GL_ACTIVE_TEXTURE, &glState.cur_textureUnit);
		glGetIntegerv(GL_CLIENT_ACTIVE_TEXTURE, &glState.cur_clientTextureUnit);

		for (i=0; i<MAXTEXTUREUNITS; i++)
		{
			glActiveTexture(GL_TEXTURE0+i);
			glState.textureUnits[i].cur_active2D = glIsEnabled(GL_TEXTURE_1D);
			glGetIntegerv(GL_TEXTURE_BINDING_1D,&glState.textureUnits[i].cur_texture1D);
			glState.textureUnits[i].cur_active2D = glIsEnabled(GL_TEXTURE_2D);
			glGetIntegerv(GL_TEXTURE_BINDING_2D,&glState.textureUnits[i].cur_texture2D);

			glClientActiveTexture(GL_TEXTURE0+i);
			glState.textureUnits[i].cur_tcaEnabled = glIsEnabled(GL_TEXTURE_COORD_ARRAY);
			glGetIntegerv(GL_TEXTURE_COORD_ARRAY_SIZE,&glState.textureUnits[i].cur_tcaSize);
			glGetIntegerv(GL_TEXTURE_COORD_ARRAY_TYPE,&glState.textureUnits[i].cur_tcaTyp);
			glGetIntegerv(GL_TEXTURE_COORD_ARRAY_STRIDE,&glState.textureUnits[i].cur_tcaStride);
			glGetPointerv(GL_TEXTURE_COORD_ARRAY_POINTER,&glState.textureUnits[i].cur_tcaPointer);

			glState.textureUnits[i].matrixstacksize=0;
		}
		glActiveTexture(glState.cur_textureUnit);
		glClientActiveTexture(glState.cur_clientTextureUnit);

		glState.cur_textureUnit-=GL_TEXTURE0;
		glState.cur_clientTextureUnit-=GL_TEXTURE0;

		glState.cur_vaEnabled = glIsEnabled(GL_VERTEX_ARRAY);
		glGetIntegerv(GL_VERTEX_ARRAY_SIZE,&glState.cur_vaSize);
		glGetIntegerv(GL_VERTEX_ARRAY_TYPE,&glState.cur_vaTyp);
		glGetIntegerv(GL_VERTEX_ARRAY_STRIDE,&glState.cur_vaStride);
		glGetPointerv(GL_VERTEX_ARRAY_POINTER,&glState.cur_vaPointer);

		glState.cur_naEnabled = glIsEnabled(GL_NORMAL_ARRAY);
		glGetIntegerv(GL_NORMAL_ARRAY_TYPE,&glState.cur_naTyp);
		glGetIntegerv(GL_NORMAL_ARRAY_STRIDE,&glState.cur_naStride);
		glGetPointerv(GL_NORMAL_ARRAY_POINTER,&glState.cur_naPointer);

		glState.cur_iaEnabled = glIsEnabled(GL_INDEX_ARRAY);
		glGetIntegerv(GL_INDEX_ARRAY_TYPE,&glState.cur_iaTyp);
		glGetIntegerv(GL_INDEX_ARRAY_STRIDE,&glState.cur_iaStride);
		glGetPointerv(GL_INDEX_ARRAY_POINTER,&glState.cur_iaPointer);

		glState.cur_efaEnabled = glIsEnabled(GL_EDGE_FLAG_ARRAY);
		glGetIntegerv(GL_EDGE_FLAG_ARRAY_STRIDE,&glState.cur_efaStride);
		glGetPointerv(GL_EDGE_FLAG_ARRAY_POINTER,&glState.cur_efaPointer);

		glState.cur_caEnabled = glIsEnabled(GL_COLOR_ARRAY);
		glGetIntegerv(GL_COLOR_ARRAY_TYPE,&glState.cur_caTyp);
		glGetIntegerv(GL_COLOR_ARRAY_STRIDE,&glState.cur_caStride);
		glGetPointerv(GL_COLOR_ARRAY_POINTER,&glState.cur_caPointer);
	}

	void CRendererGL::InitShader(TShaderInfo &s)
	{
		numVertices=numNormals=numColors=0;
		memset(numTexCoords,0,MAXTEXTUREUNITS*sizeof(int));
		if (s.shader->cull!=glState.cur_cullFace)
		{
			glState.cur_cullFace=s.shader->cull;
			if (s.shader->cull>0)
			{
				glEnable(GL_CULL_FACE);
				glCullFace(GL_FRONT);
				glState.cur_cullEnabled=true;
			} else if (s.shader->cull<0) {
				glEnable(GL_CULL_FACE);
				glCullFace(GL_BACK);
				glState.cur_cullEnabled=true;
			} else
			{
				glDisable(GL_CULL_FACE);
				glState.cur_cullEnabled=false;
			}
		}
	}

	void CRendererGL::FinishShader(TShaderInfo &s)
	{
	}

	GLint CRendererGL::InitLayer(TShaderInfo &s, int &layer, TLight *light)
	{
		CResShader::Layer *l;
		int tex=0;
		int lmtex=-1;


		do {
			l = s.shader->layer[layer];
			if ((light!=NULL) && 
				(l->flags & LF_LIGHTMAP))
			{
				DisableTextureUnit(tex+GL_TEXTURE0);
				layer++;
				continue;
			}


			if (l->num_maps>1)
			{
				l->frame++;
				l->frame%=l->num_maps;
			}

			SetTextureCoordinates(tex+GL_TEXTURE0,s,l);
			BindTexture(tex+GL_TEXTURE0,s,l);
			if (l->flags & LF_LIGHTMAP)
				lmtex = tex;

			if (tex==0)
			{
				SetBlendState(l);
				SetAlphaFunc(l);
				SetDepthFunc(l);
				SetVertexColors(s,l,light);
			}
			tex++;
			layer++;
		} while ((layer<s.shader->num_layers) && (s.shader->layer[layer-1]->flags & LF_MULTITEX));

		while (tex<MAXTEXTUREUNITS)
		{
			DisableTextureUnit(tex+GL_TEXTURE0);
			tex++;
		}

		return (tex!=0)?lmtex:-2;
	}

	void CRendererGL::DoneLayer(TShaderInfo &s, int layer)
	{
		GLint texunit = GL_TEXTURE0;
		do {
			glMatrixMode(GL_TEXTURE);
			glActiveTexture(texunit);
			glLoadIdentity();
			glMatrixMode(GL_MODELVIEW);
			texunit++;
			layer++;
		} while ((layer<s.shader->num_layers) && (s.shader->layer[layer-1]->flags & LF_MULTITEX));
		glActiveTexture(glState.cur_textureUnit+GL_TEXTURE0);
	}

	void CRendererGL::RenderPlane(TColor4ub color, CVector3f normal, SCALAR d)
	{
		SCALAR dist;
		CVector3f p0(0.0f,0.0f,0.0f);
		dist=p0.ScalarMultiply(normal)-d;
		p0-=normal*dist;

		CVector3f p1(1.0f,0.0f,0.0f);
		dist=p1.ScalarMultiply(normal)-d;
		p1-=normal*dist;

		if ( (p0-p1).abs2()<0.1 )
		{
			p1 =CVector3f(0.0f,1.0f,0.0f);
			dist=p1.ScalarMultiply(normal)-d;
			p1-=normal*dist;
		}

		if ( (p0-p1).abs2()<0.1 )
		{
			return;
		}

		CVector3f d2 = normal.VectorProduct(p1-p0);
		CVector3f d1 = p1-p0;
	//	CVector3f d2 = p2-p0;

		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glDisable(GL_CULL_FACE);
		glEnable(GL_DEPTH_TEST);
		glDepthMask(GL_FALSE);
		glColorMask(GL_TRUE,GL_TRUE,GL_TRUE,GL_TRUE);
		glDepthFunc(GL_LEQUAL);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

		CVector3f p;

		p=p0-d1*5000.0f-d2*5000.0f;
		glColor4ub(color.r,color.g,color.b,color.a);
		glBegin(GL_QUADS);
			glVertex3fv(&p.x);
			p+=d1*10000.0f;
			glVertex3fv(&p.x);
			p+=d2*10000.0f;
			glVertex3fv(&p.x);
			p-=d1*10000.0f;
			glVertex3fv(&p.x);
		glEnd();
		glPopAttrib();
	}

	void CRendererGL::RenderShadowMaps()
	{
		TShadowSourceMap::iterator it;
		for (it=shadowSources.begin(); it!=shadowSources.end(); it++)
			RenderShadowMaps(it->second);
	}

	void CRendererGL::RenderShadows()
	{
		TShadowSourceMap::iterator it;
		for (it=shadowSources.begin(); it!=shadowSources.end(); it++)
			RenderShadows(it->second);
	}

	void CRendererGL::RenderShadowMaps(TShadowSource *ss)
	{
		if (glState.cur_rendermode!=GL_RENDER)
		{
			return;
		}


		DisableTextureUnit(GL_TEXTURE0);
		DisableTextureUnit(GL_TEXTURE1);
		DisableTextureUnit(GL_TEXTURE2);
		DisableTextureUnit(GL_TEXTURE3);

		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glEnableClientState(GL_VERTEX_ARRAY);
		glDisableClientState(GL_NORMAL_ARRAY);
		glDisableClientState(GL_COLOR_ARRAY);
		glDisableClientState(GL_NORMAL_ARRAY);
		glDisable(GL_BLEND);
		glDisable(GL_DEPTH_TEST);
		glDisable(GL_STENCIL_TEST);
		glColorMask(GL_TRUE,GL_TRUE,GL_TRUE,GL_TRUE);
		glDepthMask(GL_FALSE);

		glMatrixMode(GL_PROJECTION);
		glPushMatrix();
		glLoadIdentity();
		gluPerspective(90.0f,1.0f,1.0f,5000.0f);
		glViewport(0,0,SM_SIZE,SM_SIZE);

		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
		glClearColor(0.0f,0.0f,0.0f,0.0f);
		glColor4ub(0,0,0,255);


		/// Positive Z-Plane
		glLoadIdentity();
		gluLookAt(ss->pos.x,ss->pos.y,ss->pos.z,
			      ss->pos.x,ss->pos.y,ss->pos.z+1,
				  0.0,-1.0,0.0);
		glClear(GL_COLOR_BUFFER_BIT);
		for (int i=0; i<numShadowCaster; i++)
		{
			TSurface *s = surfaces[shadowCasterSurfaces[i]];

			CVector3f *verts;

			if (s->useVertices==-1)
				verts=s->vertices;
			else
				verts=vertices+s->useVertices;
			glVertexPointer(3,GL_FLOAT,sizeof(CVector3f),verts);	

			if (s->modelView!=NULL)
			{
				glPushMatrix();
				glMultMatrixf(s->modelView->m);
			}

			switch (s->type)
			{
			case TSurface::SURFACETYPE_POLYGON:
				glDrawArrays(s->primitiveType,0,s->numVertices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->numVertices);
				break;
			case TSurface::SURFACETYPE_MESH:
				glDrawElements(s->primitiveType,s->mesh.numIndices,GL_UNSIGNED_INT,s->mesh.indices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->mesh.numIndices);
				break;
			}
			if (s->modelView!=NULL)
				glPopMatrix();
		}

		glFlush();
		glBindTexture(GL_TEXTURE_CUBE_MAP_ARB,ss->map);
		glCopyTexImage2D(GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB,0,GL_RGBA8,0,0,SM_SIZE,SM_SIZE,0);

		/// Negative Z-Plane
		glLoadIdentity();
		gluLookAt(ss->pos.x,ss->pos.y,ss->pos.z,
			      ss->pos.x,ss->pos.y,ss->pos.z-1,
				  0.0,-1.0,0.0);
		glClear(GL_COLOR_BUFFER_BIT);
		for (int i=0; i<numShadowCaster; i++)
		{
			TSurface *s = surfaces[shadowCasterSurfaces[i]];

			CVector3f *verts;

			if (s->useVertices==-1)
				verts=s->vertices;
			else
				verts=vertices+s->useVertices;
			glVertexPointer(3,GL_FLOAT,sizeof(CVector3f),verts);	

			if (s->modelView!=NULL)
			{
				glPushMatrix();
				glMultMatrixf(s->modelView->m);
			}

			switch (s->type)
			{
			case TSurface::SURFACETYPE_POLYGON:
				glDrawArrays(s->primitiveType,0,s->numVertices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->numVertices);
				break;
			case TSurface::SURFACETYPE_MESH:
				glDrawElements(s->primitiveType,s->mesh.numIndices,GL_UNSIGNED_INT,s->mesh.indices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->mesh.numIndices);
				break;
			}
			if (s->modelView!=NULL)
				glPopMatrix();
		}

		glFlush();
		glBindTexture(GL_TEXTURE_CUBE_MAP_ARB,ss->map);
		glCopyTexImage2D(GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB,0,GL_RGBA8,0,0,SM_SIZE,SM_SIZE,0);

		/// Positive X-Plane
		glLoadIdentity();
		gluLookAt(ss->pos.x,ss->pos.y,ss->pos.z,
			      ss->pos.x+1,ss->pos.y,ss->pos.z,
				  0.0,-1.0,0.0);
		glClear(GL_COLOR_BUFFER_BIT);
		for (int i=0; i<numShadowCaster; i++)
		{
			TSurface *s = surfaces[shadowCasterSurfaces[i]];

			CVector3f *verts;

			if (s->useVertices==-1)
				verts=s->vertices;
			else
				verts=vertices+s->useVertices;
			glVertexPointer(3,GL_FLOAT,sizeof(CVector3f),verts);	

			if (s->modelView!=NULL)
			{
				glPushMatrix();
				glMultMatrixf(s->modelView->m);
			}

			switch (s->type)
			{
			case TSurface::SURFACETYPE_POLYGON:
				glDrawArrays(s->primitiveType,0,s->numVertices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->numVertices);
				break;
			case TSurface::SURFACETYPE_MESH:
				glDrawElements(s->primitiveType,s->mesh.numIndices,GL_UNSIGNED_INT,s->mesh.indices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->mesh.numIndices);
				break;
			}
			if (s->modelView!=NULL)
				glPopMatrix();
		}

		glFlush();
		glBindTexture(GL_TEXTURE_CUBE_MAP_ARB,ss->map);
		glCopyTexImage2D(GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB,0,GL_RGBA8,0,0,SM_SIZE,SM_SIZE,0);

		/// Negative X-Plane
		glLoadIdentity();
		gluLookAt(ss->pos.x,ss->pos.y,ss->pos.z,
			      ss->pos.x-1,ss->pos.y,ss->pos.z,
				  0.0,-1.0,0.0);
		glClear(GL_COLOR_BUFFER_BIT);
		for (int i=0; i<numShadowCaster; i++)
		{
			TSurface *s = surfaces[shadowCasterSurfaces[i]];

			CVector3f *verts;

			if (s->useVertices==-1)
				verts=s->vertices;
			else
				verts=vertices+s->useVertices;
			glVertexPointer(3,GL_FLOAT,sizeof(CVector3f),verts);	

			if (s->modelView!=NULL)
			{
				glPushMatrix();
				glMultMatrixf(s->modelView->m);
			}

			switch (s->type)
			{
			case TSurface::SURFACETYPE_POLYGON:
				glDrawArrays(s->primitiveType,0,s->numVertices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->numVertices);
				break;
			case TSurface::SURFACETYPE_MESH:
				glDrawElements(s->primitiveType,s->mesh.numIndices,GL_UNSIGNED_INT,s->mesh.indices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->mesh.numIndices);
				break;
			}
			if (s->modelView!=NULL)
				glPopMatrix();
		}

		glFlush();
		glBindTexture(GL_TEXTURE_CUBE_MAP_ARB,ss->map);
		glCopyTexImage2D(GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB,0,GL_RGBA8,0,0,SM_SIZE,SM_SIZE,0);

		/// Positive Y-Plane
		glLoadIdentity();
		gluLookAt(ss->pos.x,ss->pos.y,ss->pos.z,
			      ss->pos.x,ss->pos.y+1,ss->pos.z,
				  0.0,0.0,-1.0);
		glClear(GL_COLOR_BUFFER_BIT);
		for (int i=0; i<numShadowCaster; i++)
		{
			TSurface *s = surfaces[shadowCasterSurfaces[i]];

			CVector3f *verts;

			if (s->useVertices==-1)
				verts=s->vertices;
			else
				verts=vertices+s->useVertices;
			glVertexPointer(3,GL_FLOAT,sizeof(CVector3f),verts);	

			if (s->modelView!=NULL)
			{
				glPushMatrix();
				glMultMatrixf(s->modelView->m);
			}

			switch (s->type)
			{
			case TSurface::SURFACETYPE_POLYGON:
				glDrawArrays(s->primitiveType,0,s->numVertices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->numVertices);
				break;
			case TSurface::SURFACETYPE_MESH:
				glDrawElements(s->primitiveType,s->mesh.numIndices,GL_UNSIGNED_INT,s->mesh.indices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->mesh.numIndices);
				break;
			}
			if (s->modelView!=NULL)
				glPopMatrix();
		}

		glFlush();
		glBindTexture(GL_TEXTURE_CUBE_MAP_ARB,ss->map);
		glCopyTexImage2D(GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB,0,GL_RGBA8,0,0,SM_SIZE,SM_SIZE,0);

		/// Negative Y-Plane
		glLoadIdentity();
		gluLookAt(ss->pos.x,ss->pos.y,ss->pos.z,
			      ss->pos.x,ss->pos.y-1,ss->pos.z,
				  0.0,0.0,-1.0);
		glClear(GL_COLOR_BUFFER_BIT);
		for (int i=0; i<numShadowCaster; i++)
		{
			TSurface *s = surfaces[shadowCasterSurfaces[i]];

			CVector3f *verts;

			if (s->useVertices==-1)
				verts=s->vertices;
			else
				verts=vertices+s->useVertices;
			glVertexPointer(3,GL_FLOAT,sizeof(CVector3f),verts);	

			if (s->modelView!=NULL)
			{
				glPushMatrix();
				glMultMatrixf(s->modelView->m);
			}

			switch (s->type)
			{
			case TSurface::SURFACETYPE_POLYGON:
				glDrawArrays(s->primitiveType,0,s->numVertices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->numVertices);
				break;
			case TSurface::SURFACETYPE_MESH:
				glDrawElements(s->primitiveType,s->mesh.numIndices,GL_UNSIGNED_INT,s->mesh.indices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->mesh.numIndices);
				break;
			}
			if (s->modelView!=NULL)
				glPopMatrix();
		}

		glFlush();
		glBindTexture(GL_TEXTURE_CUBE_MAP_ARB,ss->map);
		glCopyTexImage2D(GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB,0,GL_RGBA8,0,0,SM_SIZE,SM_SIZE,0);

		glMatrixMode(GL_PROJECTION);
		glPopMatrix();
		glMatrixMode(GL_MODELVIEW);
		glPopMatrix();

		glPopAttrib();

	}


		
	void CRendererGL::RenderShadows(TShadowSource *ss)
	{
		GLfloat vec[4];
		if (glState.cur_rendermode!=GL_RENDER)
		{
			return;
		}

		int i;

		DisableTextureUnit(GL_TEXTURE0);
		DisableTextureUnit(GL_TEXTURE1);
		DisableTextureUnit(GL_TEXTURE2);
		DisableTextureUnit(GL_TEXTURE3);


		glPushAttrib(GL_ALL_ATTRIB_BITS);
		glDisable(GL_BLEND);
		glDisable(GL_STENCIL_TEST);

		glDisable(GL_BLEND);
		glDisable(GL_ALPHA_TEST);
		glDisable(GL_LIGHTING);

		glColor4ub(255,255,255,255);


		glActiveTexture(GL_TEXTURE0);
		glBindTexture(GL_TEXTURE_CUBE_MAP_ARB,ss->map);
		glEnable(GL_TEXTURE_CUBE_MAP_ARB);

		CMatrix4f bias = CMatrix4f(
			0.5f,0.0f,0.0f,0.5f,
			0.0f,0.5f,0.0f,0.5f,
			0.0f,0.0f,0.5f,0.5f,
			0.0f,0.0f,0.0f,1.0f);

//		bias*=view;

		glTexGeni(GL_S,GL_TEXTURE_GEN_MODE,GL_EYE_LINEAR);
		glTexGeni(GL_T,GL_TEXTURE_GEN_MODE,GL_EYE_LINEAR);
		glTexGeni(GL_R,GL_TEXTURE_GEN_MODE,GL_EYE_LINEAR);
		glTexGeni(GL_Q,GL_TEXTURE_GEN_MODE,GL_EYE_LINEAR);

		vec[0]=0.5f; vec[1]=0.0f; vec[2]=0.0f; vec[3]=0.5f-ss->pos.x*vec[0];
		glTexGenfv(GL_S,GL_EYE_PLANE,vec);
//		glTexGenfv(GL_S,GL_EYE_PLANE,bias.m+0);

		vec[0]=0.0f; vec[1]=0.5f; vec[2]=0.0f; vec[3]=0.5f-ss->pos.y*vec[1];
		glTexGenfv(GL_T,GL_EYE_PLANE,vec);
//		glTexGenfv(GL_T,GL_EYE_PLANE,bias.m+4);

		vec[0]=0.0f; vec[1]=0.0f; vec[2]=0.5f; vec[3]=0.5f-ss->pos.z*vec[2];
		glTexGenfv(GL_R,GL_EYE_PLANE,vec);
//		glTexGenfv(GL_R,GL_EYE_PLANE,bias.m+8);

		vec[0]=0.0f; vec[1]=0.0f; vec[2]=0.0f; vec[3]=1.0f;
		glTexGenfv(GL_Q,GL_EYE_PLANE,vec);
//		glTexGenfv(GL_Q,GL_EYE_PLANE,bias.m+12);

		glEnable(GL_TEXTURE_GEN_S);
		glEnable(GL_TEXTURE_GEN_T);
		glEnable(GL_TEXTURE_GEN_R);
		glEnable(GL_TEXTURE_GEN_Q);

		glDisable(GL_BLEND);

		glEnable(GL_DEPTH_TEST);
		glDepthFunc(GL_LEQUAL);

/*		glPushMatrix();
//		glTranslatef(lightPos.x,lightPos.y,lightPos.z);
		glBegin(GL_QUADS);
			glVertex3i(64,-64+lightPos.y,64);
			glVertex3i(-64,-64+lightPos.y,64);
			glVertex3i(-64,64+lightPos.y,64);
			glVertex3i(64,64+lightPos.y,64);

			glVertex3i(-64,-64+lightPos.y,-64);
			glVertex3i(64,-64+lightPos.y,-64);
			glVertex3i(64,64+lightPos.y,-64);
			glVertex3i(-64,64+lightPos.y,-64);

			glVertex3i(64,-64+lightPos.y,-64);
			glVertex3i(64,-64+lightPos.y,64);
			glVertex3i(64,64+lightPos.y,64);
			glVertex3i(64,64+lightPos.y,-64);

			glVertex3i(-64,-64+lightPos.y,64);
			glVertex3i(-64,-64+lightPos.y,-64);
			glVertex3i(-64,64+lightPos.y,-64);
			glVertex3i(-64,64+lightPos.y,64);

		glEnd();
		glPopMatrix();*/

		glEnable(GL_DEPTH_TEST);
		glDepthFunc(GL_EQUAL);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

		for (i=0; i<numShadowReceiver; i++)
		{
			TSurface *s = surfaces[shadowReceiverSurfaces[i]];

			CVector3f *verts;

/*			if (s->useVertices==-1)
				verts=s->vertices;
			else
				verts=vertices+s->useVertices;*/

			if (s->useVertices==-1)
				glVertexPointer(3,GL_FLOAT,sizeof(CVector3f),verts=s->vertices);
			else
				glVertexPointer(3,GL_FLOAT,sizeof(CVector3f),verts=vertices+s->useVertices);

		// Set Normal Array
		/*if (s->useNormals==-1)
			SetNormalPointer(norms=s->normals);
		else
			SetNormalPointer(norms=normals+s->useNormals);

		// Set Color Array
		switch (s->useColors)
		{
		case -1:
			SetColorPointer(s->colors);
			break;
		case -3:
			SetSurfaceLights(s);
			SetColorPointer(NULL);
			break;
		case -2:
			glDisable(GL_LIGHTING);
			SetColorPointer(NULL);
			break;
		default:
			SetColorPointer(vertexColors+s->useColors);
		}

		int i=0;
		while (glState.textureUnits[i].cur_active2D)
		{
			switch (s->useTexCoords[i])
			{
			case -1:
				SetTextureCoordPointer(s->texCoords,i+GL_TEXTURE0);
				break;
			case -2:
				SetTextureCoordPointer(s->lightMapTexCoords,i+GL_TEXTURE0);
				break;
			default:
				SetTextureCoordPointer(texCoords[i]+s->useTexCoords[i],i+GL_TEXTURE0);
				break;
			}

		i++;
		}*/


//			glVertexPointer(3,GL_FLOAT,sizeof(CVector3f),verts);	
			if (s->modelView!=NULL)
			{
				glPushMatrix();
				glMultMatrixf(s->modelView->m);
			}

			glColor4ub(128,128,128,128);
			switch (s->type)
			{
			case TSurface::SURFACETYPE_POLYGON:
				glBegin(s->primitiveType);
				for (int i=0; i<s->numVertices; i++)
				{
					glVertex3fv(&verts[i].x);
				}
				glEnd();
//				glDrawArrays(s->primitiveType,0,s->numVertices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->numVertices);
				break;
			case TSurface::SURFACETYPE_MESH:
				glBegin(s->primitiveType);
				for (int i=0; i<s->mesh.numIndices; i++)
				{
					glVertex3fv(&verts[s->mesh.indices[i]].x);
				}
				glEnd();

/*				if (s!=NULL)
				{
					if (s->mesh.indices!=NULL)
					{
						glDrawElements(s->primitiveType,s->mesh.numIndices,GL_UNSIGNED_INT,s->mesh.indices);
						numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->mesh.numIndices);
					}
				}*/
				break;
			}
			if (s->modelView!=NULL)
				glPopMatrix();
		}

		glPopAttrib();

		int error = glGetError();
		if (error)
		{
			char *errstr = (char*)gluErrorString(error);
			GENERAL::dprintf("[GLERROR] shadowmap: %s\n",errstr);
		}
	}


/*	void CRendererGL::PushGUISurface(TSurface *_surface, TMorfRecti &_scissor, int _styleElement)
	{
		if (_surface->type==TSurface::SURFACETYPE_UNKNOWN)
			return;
		if (numSurfaces==maxSurfaces)
			GrowSurfaces(numSurfaces+1);

		surfaces[numSurfaces]=_surface;

		TGUIShaderInfo si;

		si.shader = _surface->shader;
		si.surfaces.push_back(numSurfaces);
		si.scissor = _scissor;
		si.styleElement = _styleElement;

		guiShaderList.push_back(si);

		numSurfaces++;		
	}*/

	TShadowSource *CRendererGL::CreateShadowSource()
	{
		TShadowSource *ss = new TShadowSource();
		shadowSources[ss]=ss;
		return ss;
	}

	void CRendererGL::RemoveShadowSource(TShadowSource* ss)
	{
		TShadowSourceMap::iterator it = shadowSources.find(ss);
		if (it!=shadowSources.end())
			shadowSources.erase(it);
		delete ss;
	}

	void CRendererGL::PushGUISurface(TSurface *_surface, TMorfRecti &_scissor, int _styleElement)
	{
		if (_surface->type==TSurface::SURFACETYPE_UNKNOWN)
			return;
		if (numSurfaces==maxSurfaces)
			GrowSurfaces(numSurfaces+1);

		surfaces[numSurfaces]=_surface;

		TGUIShaderInfo si;
		si.scissor = _scissor;
		si.styleElement = _styleElement;
		si.shader = _surface->shader;
		si.surfaces.push_back(numSurfaces);
		guiShaderList.push_back(si);

		numSurfaces++;	
	}


	void CRendererGL::PushSurface(TSurface *_surface, bool shadowCaster, bool shadowReceiver)
	{
		if (_surface->type==TSurface::SURFACETYPE_UNKNOWN)
			return;
		if (numSurfaces==maxSurfaces)
			GrowSurfaces(numSurfaces+1);


	//	if (_surface->type==TSurface::SURFACETYPE_MESH)
//			light.litSurfaces.push_back(numSurfaces);

		surfaces[numSurfaces]=_surface;

		shaderMap[&_surface->shader].surfaces.push_back(numSurfaces);
		shaderMap[&_surface->shader].shader=_surface->shader;


		if (shadowCaster)
		{
			if (numShadowCaster>=maxShadowCaster)
				GrowShadowCasterSurfaces(maxShadowCaster+1);

			shadowCasterSurfaces[numShadowCaster]=numSurfaces;
			numShadowCaster++;
		} 

		if (shadowReceiver)
		{
			if (numShadowReceiver>=maxShadowReceiver)
				GrowShadowReceiverSurfaces(maxShadowReceiver+1);

			shadowReceiverSurfaces[numShadowReceiver]=numSurfaces;
			numShadowReceiver++;
		}
		numSurfaces++;
	}

	void CRendererGL::PushSilhouette(TSurface *_surface)
	{
		if (_surface->type==TSurface::SURFACETYPE_UNKNOWN)
			return;
		if (numSurfaces==maxSurfaces)
			GrowSurfaces(numSurfaces+1);

		surfaces[numSurfaces]=_surface;
		silhoutteSurfaces[numSilhouettes]=numSurfaces;

		numSurfaces++;
		numSilhouettes++;
	}


	bool cmpShader(CRendererGL::TShaderInfo s1, CRendererGL::TShaderInfo s2)
	{
		return (s1.shader->sortvalue < s2.shader->sortvalue);
	}

	void delay()
	{
		long double r=0.0, ld = 0.0;
		long int i;
		for (i=0; i<1000000; i++)
		{
			ld+=0.5;
	
			r+=sqrt(ld);
		}
	}

	void CRendererGL::Flush()
	{
		numTrianglesFlushed=0;

		glColor4ub(255,255,255,255);
		InitStates();

		if (bRenderWireFrame)
		{
			if (glState.cur_polygonMode!=GL_LINE)
			{
				glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
				glState.cur_polygonMode=GL_LINE;
			}
		} else {
			if (glState.cur_polygonMode!=GL_FILL)
			{
				glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
				glState.cur_polygonMode=GL_FILL;
			}
		}
		SetScissor(NULL);

		std::map<CResShader*,TShaderInfo>::iterator it;

/*		for (i=0; i<numSurfaces; i++)
		{
			surfaces[i].useVertices=-99;
		}*/

		for (it=shaderMap.begin(); it!=shaderMap.end(); it++)
		{
			CalculateVertices(it->second);
		}

		RenderShadowMaps();
		RenderScene();
		RenderShadows();


		if (glState.cur_rendermode==GL_RENDER)
			RenderSilhouettes();


		//RenderLight(&light);
		//if (bRenderNormals)
		//	RenderNormals();



		glMatrixMode(GL_PROJECTION);						
		glLoadIdentity();									
		gluOrtho2D(0,fe->GetWidth(),0,fe->GetHeight());
		glMatrixMode(GL_MODELVIEW);	
		glLoadIdentity();
		RenderGUI();



		shaderMap.clear();
//		light.litSurfaces.clear();
		guiShaderList.clear();
		numSurfaces=0;
		numSilhouettes=0;
		numShadowCaster=0;
		numShadowReceiver=0;

	}

	void CRendererGL::RenderScene()
	{
		TShaderMap::iterator itsh;

		// sort shaders
		std::deque<TShaderInfo> vecShad;
		std::deque<TShaderInfo>::iterator itsort;
		for (itsh=shaderMap.begin(); itsh!= shaderMap.end(); itsh++)
			vecShad.push_back(itsh->second);
		std::sort(vecShad.begin(),vecShad.end(),cmpShader);

		// render sorted
		for (itsort=vecShad.begin(); itsort!= vecShad.end(); itsort++)
		{
			std::vector<int> &surf = itsort->surfaces;
			HResShader curshad = itsort->shader;

			if (!curshad)
				continue;
			
			InitShader(*itsort);

			CalculateVertices(*itsort);
			CalculateNormals(*itsort);
			int pass;
			for (pass=0; pass<curshad->num_layers; )
			{
				int cpass=pass;
				//	Init Stage
				GLint bindLightMap = InitLayer(*itsort,pass,NULL);

				// Render primitives
				std::vector<int>::iterator it;
				for (it=surf.begin(); it!=surf.end(); it++)
				{
					TSurface *surface=surfaces[*it];

					if (bindLightMap!=-1)
						BindTexture(bindLightMap+GL_TEXTURE0, ((CResTextureGL*)surface->lightMap)->GetTextureName());

					if ( (glState.cur_rendermode==GL_SELECT) && 
						 (glState.cur_name!=surface->name) )
					{
						glLoadName(surface->name);
						glState.cur_name = surface->name;
					}

					RenderSurface(surface);
				}
			
				DoneLayer(*itsort,cpass);
			}

			int error = glGetError();
			if (error)
			{
				char *errstr = (char*)gluErrorString(error);
				GENERAL::dprintf("[GLERROR] shader '%s': %s\n",curshad->shadername,errstr);
			}

			FinishShader(*itsort);
		}
	}

	void CRendererGL::RenderGUI()
	{
		TGUIShaderList::iterator itshad;
		// render sorted
		for (itshad=guiShaderList.begin(); itshad!= guiShaderList.end(); itshad++)
		{
			std::vector<int> &surf = itshad->surfaces;
			HResShader curshad = itshad->shader;

			if (!curshad)
				continue;
			
			InitShader(*itshad);
			SetScissor(&itshad->scissor);

			CalculateVertices(*itshad);
			CalculateNormals(*itshad);
			int pass;
			for (pass=0; pass<curshad->num_layers; )
			{
				int cpass=pass;
				//	Init Stage
				GLint bindLightMap = InitLayer(*itshad,pass,NULL);

				// Render primitives
				std::vector<int>::iterator it;
				for (it=surf.begin(); it!=surf.end(); it++)
				{
					TSurface *surface=surfaces[*it];

/*					if (surface->name==-1234567)
					{
						int blu=123;
					}*/

					if (bindLightMap!=-1)
						BindTexture(bindLightMap+GL_TEXTURE0, ((CResTextureGL*)surface->lightMap)->GetTextureName());

					if ( (glState.cur_rendermode==GL_SELECT) && 
						 (glState.cur_name!=surface->name) )
					{
						glLoadName(surface->name);
						glState.cur_name = surface->name;
					}

					RenderSurface(surface);
				}
			
				DoneLayer(*itshad,cpass);
			}

			int error = glGetError();
			if (error)
			{
				char *errstr = (char*)gluErrorString(error);
				GENERAL::dprintf("[GLERROR] shader '%s': %s\n",curshad->shadername,errstr);
			}

			FinishShader(*itshad);
		}
	}


	void CRendererGL::RenderLight(TLight *light)
	{
		std::vector<int>::iterator it;
		TSurface *s;
		for (it = light->litSurfaces.begin(); it != light->litSurfaces.end(); it++)
		{
			s = surfaces[*it];

			TShaderInfo si;

			si.shader=s->shader;
			si.surfaces.push_back(*it);


			InitShader(si);

			CalculateVertices(si);
			CalculateNormals(si);

			int pass;
			for (pass=0; pass<s->shader->num_layers; )
			{
				int cpass=pass;
				//	Init Stage
				GLint bindLightMap = InitLayer(si,pass,light);
				
				if (bindLightMap==-2)
					continue;

				if (bindLightMap!=-1)
					BindTexture(bindLightMap+GL_TEXTURE0, ((CResTextureGL*)s->lightMap)->GetTextureName());

	//			if (cpass==0)
				{
					glPushAttrib(GL_ALL_ATTRIB_BITS);
					glEnable(GL_BLEND);
					glBlendFunc(GL_ONE,GL_ONE);
	/*				glState.cur_blendEnabled=true;
					glState.cur_blendsrc=GL_ONE;
					glState.cur_blenddst=GL_ONE;*/
					RenderSurface(s);
					glPopAttrib();
				} //else 
			//		RenderSurface(s);

//				if (!glState.cur_blendEnabled)


				DoneLayer(si,cpass);
			}
			FinishShader(si);
		}
	}

	void CRendererGL::RenderNormals()
	{	
		DisableTextureUnit(GL_TEXTURE0);
		DisableTextureUnit(GL_TEXTURE1);
		DisableTextureUnit(GL_TEXTURE2);
		DisableTextureUnit(GL_TEXTURE3);
		glColor4ub(255,255,255,255);

		for (int i=0; i<numSurfaces; i++)
			RenderSurfaceNormals(surfaces[i]);
	}

	void CRendererGL::SetScissor(GENERAL::TMorfRecti *_scissorRect)
	{
		if (!_scissorRect)
		{
			if (glState.cur_scissorEnabled)
			{
				glDisable(GL_SCISSOR_TEST);
				glState.cur_scissorEnabled = false;
			}
		} else {
			if (!glState.cur_scissorEnabled)
			{
				glEnable(GL_SCISSOR_TEST);
				glState.cur_scissorEnabled = true;
			}

			glScissor(_scissorRect->x,_scissorRect->y,_scissorRect->w,_scissorRect->h);
		}
	}

	void CRendererGL::RenderSilhouettes()
	{
		const float firstExtrude = 0.5f;
		const float secondExtrude = 1.0f;
		DisableTextureUnit(GL_TEXTURE0);
		DisableTextureUnit(GL_TEXTURE1);
		DisableTextureUnit(GL_TEXTURE2);
		DisableTextureUnit(GL_TEXTURE3);
		glPushAttrib(GL_ALL_ATTRIB_BITS);

		glEnableClientState(GL_VERTEX_ARRAY);
		glDisableClientState(GL_NORMAL_ARRAY);
		glDisableClientState(GL_COLOR_ARRAY);
		glDisableClientState(GL_NORMAL_ARRAY);
		glDisable(GL_BLEND);
		glEnable(GL_DEPTH_TEST);
		glDepthFunc(GL_LEQUAL);
		glColor4ub(255,255,255,255);

		glClear(GL_STENCIL_BUFFER_BIT);
		glEnable(GL_STENCIL_TEST);
		glStencilFunc(GL_ALWAYS,0x1,0x1);
		glStencilOp(GL_KEEP,GL_KEEP,GL_REPLACE);
		glStencilMask(0x1);
		glColorMask(GL_FALSE,GL_FALSE,GL_FALSE,GL_FALSE);
		glDepthMask(GL_FALSE);

// pass 1
		for (int i=0; i<numSilhouettes; i++)
		{
			TSurface *s = surfaces[silhoutteSurfaces[i]];

			glEnable(GL_DEPTH_TEST);
			glDepthFunc(GL_LEQUAL);


			CVector3f *verts, *norms;

			if (s->useVertices==-1)
				verts=s->vertices;
			else
				verts=vertices+s->useVertices;

			if (s->useNormals==-1)
				norms=s->normals;
			else
				norms=normals+s->useNormals;


			if (numVertices+s->numVertices>maxVertices)
				GrowVertices(numVertices+s->numVertices);

			ExtrudeVerts(vertices+numVertices, verts, norms, s->numVertices,firstExtrude);
			s->useVertices=numVertices;

			glVertexPointer(3,GL_FLOAT,sizeof(CVector3f),vertices+s->useVertices);

			numVertices+=s->numVertices;
			
			if (s->modelView!=NULL)
			{
				glPushMatrix();
				glMultMatrixf(s->modelView->m);
			}
			switch (s->type)
			{
			case TSurface::SURFACETYPE_POLYGON:
				glDrawArrays(s->primitiveType,0,s->numVertices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->numVertices);
				break;
			case TSurface::SURFACETYPE_MESH:
				glDrawElements(s->primitiveType,s->mesh.numIndices,GL_UNSIGNED_INT,s->mesh.indices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->mesh.numIndices);
				break;
			}
			if (s->modelView!=NULL)
				glPopMatrix();
		}


// pass 2


		glColorMask(GL_TRUE,GL_TRUE,GL_TRUE,GL_TRUE);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glEnable(GL_BLEND);
		glColor4ub(0,0,200,200);

		glEnable(GL_STENCIL_TEST);
		glStencilFunc(GL_NOTEQUAL,0x1,0x1);
		glStencilOp(GL_REPLACE,GL_KEEP,GL_REPLACE);

		for (int i=0; i<numSilhouettes; i++)
		{
			TSurface *s = surfaces[silhoutteSurfaces[i]];

			glEnable(GL_DEPTH_TEST);
			glDepthFunc(GL_LEQUAL);


			CVector3f *verts, *norms;

			verts=vertices+s->useVertices;

			if (s->useNormals==-1)
				norms=s->normals;
			else
				norms=normals+s->useNormals;

			ExtrudeVerts(verts, verts, norms, s->numVertices,secondExtrude);

			glVertexPointer(3,GL_FLOAT,sizeof(CVector3f),verts);
			
			if (s->modelView!=NULL)
			{
				glPushMatrix();
				glMultMatrixf(s->modelView->m);
			}
			switch (s->type)
			{
			case TSurface::SURFACETYPE_POLYGON:
				glDrawArrays(s->primitiveType,0,s->numVertices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->numVertices);
				break;
			case TSurface::SURFACETYPE_MESH:
				glDrawElements(s->primitiveType,s->mesh.numIndices,GL_UNSIGNED_INT,s->mesh.indices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->mesh.numIndices);
				break;
			}
			if (s->modelView!=NULL)
				glPopMatrix();
		}

		glPopAttrib();
	}

	void CRendererGL::SetSurfaceLights(TSurface *s)
	{
		static GLfloat mat_ambient[4]={0.15f,0.15f,0.15f,0.15f};
		static GLfloat light_ambient[4]={0.0f,0.0f,0.0f,1.0f};
		static GLfloat mat_diffuse[4]={1.0f,1.0f,1.0f,1.0f};

		if (!bLightingEnabled)
		{
			glDisable(GL_LIGHTING);
			return;
		}

		glColor4ub(255,255,255,255);
		glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,mat_ambient);
		glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,mat_diffuse);
		glLightModelfv(GL_LIGHT_MODEL_AMBIENT,light_ambient);


		DOMAIN::CGraphObject::tLightsType::iterator it;
		int i;
		for (i=0, it = s->visibleLights->begin(); (i<MaxLightSources) && (it!=s->visibleLights->end()); i++, it++)
		{
			DOMAIN::CLight *l = (DOMAIN::CLight*)&(*it);
			GENERAL::CVector4f lpos = l->GetPos();
			lpos.w=1.0f;
			glLightfv(GL_LIGHT0+i,GL_POSITION,(GLfloat*)&lpos.x);
			glLightfv(GL_LIGHT0+i,GL_DIFFUSE,(GLfloat*)&l->GetDiffuseColor().x);
			
			glLightf(GL_LIGHT0+i,GL_CONSTANT_ATTENUATION,(GLfloat)l->GetConstantAtt());
			glLightf(GL_LIGHT0+i,GL_LINEAR_ATTENUATION,(GLfloat)l->GetLinearAtt());
			glLightf(GL_LIGHT0+i,GL_QUADRATIC_ATTENUATION,(GLfloat)l->GetQuadAtt());
			
			
			glEnable(GL_LIGHT0+i);

			if (bRenderLights)
			{
				glPointSize(20);
				glColor4fv((GLfloat*)&l->GetDiffuseColor().x);
				glBegin(GL_POINTS);
					glVertex3fv((GLfloat*)&l->GetPos().x);
				glEnd();
				glColor4ub(255,255,255,255);
			}

		}

		CVector3f ambient(1.000000f, 0.776471f, 0.776471f);

		glLightfv(GL_LIGHT0, GL_AMBIENT, (GLfloat*) &ambient.x);


		while (i<8)
		{
			glDisable(GL_LIGHT0+i);
			i++;
		}
		glEnable(GL_LIGHTING);
	}

	void CRendererGL::RenderSurface(TSurface *s)
	{
		CVector3f *verts,*norms;
		// Set Vertex Array
		if (s->useVertices==-1)
			SetVertexPointer(verts=s->vertices);
		else
			SetVertexPointer(verts=vertices+s->useVertices);

		// Set Normal Array
		if (s->useNormals==-1)
			SetNormalPointer(norms=s->normals);
		else
			SetNormalPointer(norms=normals+s->useNormals);

		// Set Color Array
		switch (s->useColors)
		{
		case -1:
			SetColorPointer(s->colors);
			break;
		case -3:
			SetSurfaceLights(s);
			SetColorPointer(NULL);
			break;
		case -2:
			glDisable(GL_LIGHTING);
			SetColorPointer(NULL);
			break;
		default:
			SetColorPointer(vertexColors+s->useColors);
		}

		int i=0;
		while (glState.textureUnits[i].cur_active2D)
		{
			switch (s->useTexCoords[i])
			{
			case -1:
				SetTextureCoordPointer(s->texCoords,i+GL_TEXTURE0);
				break;
			case -2:
				SetTextureCoordPointer(s->lightMapTexCoords,i+GL_TEXTURE0);
				break;
			default:
				SetTextureCoordPointer(texCoords[i]+s->useTexCoords[i],i+GL_TEXTURE0);
				break;
			}

		i++;
		}

		if (s->modelView!=NULL)
		{
			glPushMatrix();
			glMultMatrixf(s->modelView->m);
		}

		if (!(s->flags & TSurface::TSurfaceFlags::SF_TEXTONLY))
		{
			switch (s->type)
			{
			case TSurface::SURFACETYPE_POLYGON:
				glDrawArrays(s->primitiveType,0,s->numVertices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->numVertices);
				break;
			case TSurface::SURFACETYPE_MESH:
				if (s->mesh.indices)
					glDrawElements(s->primitiveType,s->mesh.numIndices,GL_UNSIGNED_INT,s->mesh.indices);
				numTrianglesFlushed+=GetTriangleCount(s->primitiveType,s->mesh.numIndices);
				break;
			}
		}

		std::vector<TSurfaceText>::iterator tit;

		if (!s->texts.empty())
		{
			glPushAttrib(GL_ALL_ATTRIB_BITS);
			glDisable(GL_DEPTH_TEST);
			for (tit=s->texts.begin(); tit!=s->texts.end(); tit++)
			{
				TSurfaceText &st = *tit;
				glColor4ubv(&st.color.r);
				st.fnt->Print(st.setPos?&st.pos:NULL,st.text,st.numChars,st.marked);
			}
			glPopAttrib();
		}

		if (s->modelView!=NULL)
		{
			glPopMatrix();
		}
	}

	void CRendererGL::RenderSurfaceNormals(TSurface *s)
	{
		CVector3f *verts,*norms;
		// Set Vertex Array
		if (s->useVertices==-1)
			verts=s->vertices;
		else
			verts=vertices+s->useVertices;

		// Set Normal Array
		if (s->useNormals==-1)
			norms=s->normals;
		else
			norms=normals+s->useNormals;

		if (s->modelView)
		{
			glPushMatrix();
			glMultMatrixf(s->modelView->m);
		}

		glBegin(GL_LINES);
		for (int i=0; i<s->numVertices; i++)
		{
			CVector3f p=verts[i]+norms[i]*4;
			glColor4ub(255,255,255,255);
			glVertex3fv(&verts[i].x);
			glColor4ub(255,0,0,255);
			glVertex3fv(&p.x);
		}
		glEnd();

		if (s->modelView)
		{
			glPopMatrix();
		}
	}

	void CRendererGL::DisableTextureUnit(int texunit)
	{
		texunit-=GL_TEXTURE0;
		if (glState.textureUnits[texunit].cur_active2D)
		{
			if (glState.cur_textureUnit!=texunit)
			{
				glActiveTexture(texunit+GL_TEXTURE0);
				glState.cur_textureUnit=texunit;
			}

			glDisable(GL_TEXTURE_2D);
			glState.textureUnits[texunit].cur_active2D = false;
		}

	}

	void CRendererGL::BindTexture(int texunit, GLint texNum)
	{
		texunit-=GL_TEXTURE0;

		if (glState.cur_textureUnit!=texunit)
		{
			glActiveTexture(texunit+GL_TEXTURE0);
			glState.cur_textureUnit=texunit;
		}

		if (!glState.textureUnits[texunit].cur_active2D)
		{
			glEnable(GL_TEXTURE_2D);
			glState.textureUnits[texunit].cur_active2D = true;
		}

		if (glState.textureUnits[texunit].cur_texture2D!=texNum)
		{
			glBindTexture(GL_TEXTURE_2D,texNum);
			glState.textureUnits[texunit].cur_texture2D=texNum;
		}
	}

	void CRendererGL::BindTexture(int texunit, TShaderInfo &s, CResShader::Layer *l)
	{
		texunit-=GL_TEXTURE0;

		if (glState.cur_textureUnit!=texunit)
		{
			glActiveTexture(texunit+GL_TEXTURE0);
			glState.cur_textureUnit=texunit;
		}

		int useTexture = 0;

		if (l->num_maps>1)
		{
			GENERAL::TGameTick tick = APPLICATION::CApplication::GetApplication()->GetTicker().getTick();
			float period = (1/l->anim_speed)*1000.0f;

			tick/=(GENERAL::TGameTick)period; 
			useTexture = (int)(tick%l->num_maps);
		}


		if (l->map[useTexture]!=NULL)
		{
			if (!glState.textureUnits[texunit].cur_active2D)
			{
				glEnable(GL_TEXTURE_2D);
				glState.textureUnits[texunit].cur_active2D = true;
			}

			if (glState.textureUnits[texunit].cur_texture2D!=((HResTextureGL)l->map[useTexture])->GetTextureName())
			{
				glBindTexture(GL_TEXTURE_2D,((HResTextureGL)l->map[useTexture])->GetTextureName());
				glState.textureUnits[texunit].cur_texture2D=((HResTextureGL)l->map[useTexture])->GetTextureName();
			}
		} else {
			if (l->flags & LF_ELEMENT)
			{
				TGUIShaderInfo &sg = *((TGUIShaderInfo*)&s); 
				HResTextureGL tex = (HResTextureGL)sg.shader->elements[sg.styleElement].tex;

				if (!glState.textureUnits[texunit].cur_active2D)
				{
					glEnable(GL_TEXTURE_2D);
					glState.textureUnits[texunit].cur_active2D = true;
				}

				if (glState.textureUnits[texunit].cur_texture2D!=tex->GetTextureName())
				{
					glBindTexture(GL_TEXTURE_2D,tex->GetTextureName());
					glState.textureUnits[texunit].cur_texture2D=tex->GetTextureName();
				}
			} else
			if (glState.textureUnits[texunit].cur_active2D)
			{
				glDisable(GL_TEXTURE_2D);
				glState.textureUnits[texunit].cur_active2D = false;
			}
		}
	}

	int CRendererGL::SetRenderMode(int mode)
	{
		int res = glRenderMode(mode);
		glState.cur_rendermode=mode;
		switch (mode)
		{
		default:
			break;
		case GL_SELECT:
			glInitNames();
			glPushName(0);
			glState.cur_name=0;
			break;
		}
		return res;
	}

	void CRendererGL::CalculateVertices(TShaderInfo &s)
	{
		std::vector<int>::iterator it;

		for (it=s.surfaces.begin(); it!=s.surfaces.end(); it++)
		{
			int i = *it;
			surfaces[i]->useVertices=-1;
		}
	}

	void CRendererGL::CalculateNormals(TShaderInfo &s)
	{
		std::vector<int>::iterator it;

		for (it=s.surfaces.begin(); it!=s.surfaces.end(); it++)
		{
			surfaces[*it]->useNormals=-1;
		}
	}

	void CRendererGL::SetVertexColors(TShaderInfo &s, CResShader::Layer *l, TLight *light)
	{
		int i,c;

		std::vector<int>::iterator it;
		TSurface *surf;

		switch (l->rgbGen)
		{
		default:
		case RGBGEN_LIGHTING_DIFFUSE:
		case RGBGEN_IDENTITY_LIGHTING:
			for (it=s.surfaces.begin(); it!= s.surfaces.end(); it++)
			{
				surf = surfaces[*it]; 
				surf->useColors=-3;
			}
			break;
		case RGBGEN_VERTEX:
			for (it=s.surfaces.begin(); it!= s.surfaces.end(); it++)
			{
				surf = surfaces[*it]; 
				if (light!=NULL)
				{
					if (numColors+surf->numVertices>maxColors)
						GrowColors(numColors+surf->numVertices);
					
					i=numColors+surf->numVertices;
					c=surf->numVertices;

					while (i>numColors)
					{
						i--;
						c--;

						CVector3f dcol=light->CalculateDiffuseCol(surf->vertices[c],surf->normals[c])*255.0f;

						vertexColors[i].r=(UBYTE)dcol.x;
						vertexColors[i].g=(UBYTE)dcol.y;
						vertexColors[i].b=(UBYTE)dcol.z;
						vertexColors[i].a=surf->colors[c].a;
					}
					surf->useColors=numColors;
					numColors+=surf->numVertices;
				} else {
					surf->useColors=-1;
				}
			}
			break;
		case RGBGEN_NONE:
		case RGBGEN_IDENTITY:
			for (it=s.surfaces.begin(); it!= s.surfaces.end(); it++)
			{
				surf = surfaces[*it]; 
				if (light!=NULL)
				{
					if (numColors+surf->numVertices>maxColors)
						GrowColors(numColors+surf->numVertices);
					
					i=numColors+surf->numVertices;
					c=surf->numVertices;

					while (i>numColors)
					{
						i--;
						c--;

						CVector3f dcol=light->CalculateDiffuseCol(surf->vertices[c],surf->normals[c])*255.0f;

						vertexColors[i].r=(UBYTE)dcol.x;
						vertexColors[i].g=(UBYTE)dcol.y;
						vertexColors[i].b=(UBYTE)dcol.z;
						vertexColors[i].a=255;
					}
					surf->useColors=numColors;
					numColors+=surf->numVertices;
				} else {
					surf->useColors=-2;
				}
//				surfaces[*it]->useColors=-2;
			}
			break;
		case RGBGEN_WAVE:
			c = (int) (255.0f*Eval(l->rgbGenParams));
			if (c<0) c=0;
			if (c>255) c=255;

			for (it=s.surfaces.begin();it!=s.surfaces.end();it++)
			{
				surf=surfaces[*it];

				if (numColors+surf->numVertices<maxColors)
					GrowColors(numColors+surf->numVertices);

				i = numColors+surf->numVertices;
				while (i>numColors)
				{
					i--;

					vertexColors[i].r=vertexColors[i].g=vertexColors[i].b=c;
					vertexColors[i].a=255;
				}

				surf->useColors=numColors;
				numColors+=surf->numVertices;
			}
			break;
		}
	}

	void CRendererGL::SetTextureCoordinates(int texunit, TShaderInfo &s, CResShader::Layer *l)
	{
		std::vector<int>::iterator it;

//		glDisable(GL_TEXTURE_GEN_S);
//		glDisable(GL_TEXTURE_GEN_T);

		texunit-=GL_TEXTURE0;
//		CVector2f *tc = NULL;
		switch (l->tcGen)
		{
		case TCGEN_ELEMENT:
			{
				TGUIShaderInfo &sg = *((TGUIShaderInfo*)&s); 
				TSurface *surf;
				for (it=s.surfaces.begin();it!=s.surfaces.end();it++)
				{
					surf=surfaces[*it];
					if (surf->numVertices!=4)
					{

						/// @todo handle error
						break;
					}

					if (numTexCoords[texunit]+4>maxTexCoords[texunit])
						GrowTexCoords(numTexCoords[texunit]+4,texunit);

					int i = numTexCoords[texunit]+4;
					int c = 4;
					while (i>numTexCoords[texunit])
					{
						i--;
						c--;
						texCoords[texunit][i].x=sg.shader->elements[sg.styleElement].texCoords[c].x;
						texCoords[texunit][i].y=sg.shader->elements[sg.styleElement].texCoords[c].y;
					}

					surf->useTexCoords[texunit] = numTexCoords[texunit];
					numTexCoords[texunit]+=4;

				}
			}
			break;
		case TCGEN_LIGHTMAP:
			for (it=s.surfaces.begin();it!=s.surfaces.end();it++)
			{
				surfaces[*it]->useTexCoords[texunit]=-2;
			}
			break;
		case TCGEN_VECTOR:
		case TCGEN_BASE:
			for (it=s.surfaces.begin();it!=s.surfaces.end();it++)
			{
				surfaces[*it]->useTexCoords[texunit]=-1;
			}
			break;
		case TCGEN_FOG:
			break;
		case TCGEN_ENVIRONMENT:
			{
				TSurface *surf;
				CVector3f dir, pos;

				for (it=s.surfaces.begin();it!=s.surfaces.end();it++)
				{
					surf=surfaces[*it];

					if (surf->modelView)
					{
						CMatrix4f mv(*surf->modelView);
						mv.Invert();
						pos.x = mv.m[13];
						pos.y = mv.m[14];
						pos.z = mv.m[15];
					} else {
						pos = fe->GetCamera().GetPos();
					}

					if (numTexCoords[texunit]+surf->numVertices>maxTexCoords[texunit])
						GrowTexCoords(numTexCoords[texunit]+surf->numVertices,texunit);

					int i = numTexCoords[texunit]+surf->numVertices;
					while (i>numTexCoords[texunit])
					{
						i--;
						CVector3f dir(pos-surf->vertices[i-numTexCoords[texunit]]);
						dir.Normal();
						texCoords[texunit][i].y=1.0f-(dir.z-surf->normals[i-numTexCoords[texunit]].z);
						texCoords[texunit][i].x=1.0f-(dir.y-surf->normals[i-numTexCoords[texunit]].y);
					}

					surf->useTexCoords[texunit] = numTexCoords[texunit];
					numTexCoords[texunit]+=surf->numVertices;
				}
			}
			break;
			/// not implemented yet
		default:
			DisableTextureUnit(texunit+GL_TEXTURE0);
			break;
		}

		//if (tc!=NULL)
		{
			if (glState.cur_textureUnit!=texunit)
			{
				glActiveTexture(texunit+GL_TEXTURE0);
				glState.cur_textureUnit=texunit;
			}

/*			if (glState.cur_clientTextureUnit!=texunit)
			{
				glClientActiveTexture(texunit+GL_TEXTURE0);
				glState.cur_clientTextureUnit=texunit;
			}

			if (!glState.textureUnits[texunit].cur_tcaEnabled)
			{
				glEnableClientState(GL_TEXTURE_COORD_ARRAY);
				glState.textureUnits[texunit].cur_tcaEnabled=true;
			}

			if ((void*)glState.textureUnits[texunit].cur_tcaPointer != (void*)tc)
			{
				glTexCoordPointer(
					2,
					GL_FLOAT,
					sizeof(CVector2f),
					tc);
				glState.textureUnits[texunit].cur_tcaPointer = tc;
			}*/

			CResShader::funclist *tcm = l->tcMod;
			glMatrixMode(GL_TEXTURE);
			glLoadIdentity();
			//glScalef(1.0f,-1.0f,1.0f);

			if (tcm)
			{
				GENERAL::TGameTick gt = APPLICATION::CApplication::GetApplication()->GetTicker().getTick();
				std::vector<CResShader::funclist*> fuli;
				while (tcm)
				{
					fuli.push_back(tcm);
					tcm = tcm->next;
				}

				glTranslated(0.5f,0.5f,0);

				std::vector<CResShader::funclist*>::iterator it;
				for (it=fuli.begin();it!=fuli.end();it++)
				{
					tcm=*it;
					switch (tcm->func)
					{
					case TCMOD_TRANSFORM:
						{
							GLfloat mat[16] =
							{
								tcm->p[0],tcm->p[1],0.0f,0.0f,
								tcm->p[2],tcm->p[3],0.0f,0.0f,
								0.0f,     0.0f,     1.0f,0.0f,
								tcm->p[4],tcm->p[5],0.0f,1.0f,
							};
							glMultMatrixf(mat);
						}
						break;
					case TCMOD_ROTATE:
						{
							int d=(int)tcm->p[0]*100;
							float angle = (float)(((gt*d)/(1000))%36000);
							angle/=100.0f;

//							glTranslated(0.5f,-0.5f,0);
							glRotatef(angle,0.0f,0.0f,1.0f);
//							glTranslated(-0.5f,0.5f,0);
						}
						break;
					case TCMOD_SCALE:
//						glScalef(1/tcm->p[0],1/tcm->p[1],1.0f);
						glScalef(tcm->p[0],tcm->p[1],1.0f);
						break;
					case TCMOD_SCROLL:
						{
							float dx = ((float)gt)/1000.0f*tcm->p[0];
							float dy = ((float)gt)/1000.0f*tcm->p[1];

							glTranslatef(dx,dy,0.0f);
						}
						break;
					case TCMOD_STRETCH:
						{
							float factor = 1/Eval(tcm->p);
							glScalef(factor,factor,1.0f);
		//					glTranslated(-0.5f,0.5f,0);
						}
						break;
					case TCMOD_TURB:
		/*				{
							float p[5];
							memcpy(p+2,tcm->p+1,3*sizeof(float));
							p[0]=FUNC_SIN;
							p[1]=0;
							float c=Eval(p);
							glRotatef(c*60.0f,0.0f,0.0f,1.0f);
							p[0]=FUNC_TRIANGLE;
							p[1]/=2;
							//p[4]*=2;
							p[3]+=p[4]/4;
							p[4]*=1.5f;
							float s=Eval(p);
							glScalef(1.0f+s,1.0f+c,1.0f);
							glTranslatef(s,c/2,0.0f);
							/*{
								t1 = f->p[2] + (float)Timer::fTime * f->p[3];
								t2 = f->p[1];
								for (i = 0; i < input.numverts; ++i, st += 2)
								{
									st[0] += FastSin(st[0]*t2+t1)*t2;
									st[1] += FastSin(st[1]*t2+t1)*t2;
								}
							}* /
						}*/
						break;
					default:
						break;
					}
				}
				glTranslated(-0.5f,-0.5f,0);

			}
			glMatrixMode(GL_MODELVIEW);
	
		}
/* else {
			if (glState.cur_clientTextureUnit!=texunit)
			{
				glClientActiveTexture(texunit+GL_TEXTURE0);
				glState.cur_clientTextureUnit=texunit;
			}

			if (glState.textureUnits[texunit].cur_tcaEnabled)
			{
				glDisableClientState(GL_TEXTURE_COORD_ARRAY);
				glState.textureUnits[texunit].cur_tcaEnabled=false;
			}
		}*/
    }

	void CRendererGL::SetBlendState(CResShader::Layer *l)
	{
		if ( (l->blendsrc==GL_ONE)&&(l->blenddst==GL_ZERO) )
		{
			if (glState.cur_blendEnabled)
			{
				glDisable(GL_BLEND);
				glState.cur_blendEnabled=false;
			}	
		} else {
			if (!glState.cur_blendEnabled)
			{
				glEnable(GL_BLEND);
				glState.cur_blendEnabled=true;
			}	

			if ( (l->blendsrc!=glState.cur_blendsrc) || (l->blenddst!=glState.cur_blenddst) )
			{
				glBlendFunc(l->blendsrc,l->blenddst);
				glState.cur_blendsrc = l->blendsrc;
				glState.cur_blenddst = l->blenddst;
			}
		}
	}

	void CRendererGL::SetAlphaFunc(CResShader::Layer *l)
	{
		if (l->alphafunc==GL_ALWAYS)
		{
			if (glState.cur_alphaTestEnabled)
			{
				glDisable(GL_ALPHA_TEST);
				glState.cur_alphaTestEnabled=false;
			}
		} else {
			if (!glState.cur_alphaTestEnabled)
			{
				glEnable(GL_ALPHA_TEST);
				glState.cur_alphaTestEnabled=true;
			}
			if ( (l->alphafunc!=glState.cur_alphafunc) || (l->alphafuncref!=glState.cur_alpharef) )
			{
				glAlphaFunc(l->alphafunc, l->alphafuncref);
				glState.cur_alphafunc = l->alphafunc;
				glState.cur_alpharef  = l->alphafuncref;
			}
		}
	}

	void CRendererGL::SetDepthFunc(CResShader::Layer *l)
	{
		if (l->depthWrite!=glState.cur_depthMask)
		{
			glDepthMask(l->depthWrite);
			glState.cur_depthMask=l->depthWrite;
		}

		if (l->depthFunc == GL_NEVER) 
		{
			if (glState.cur_depthTestEnabled)
			{
				glDisable(GL_DEPTH_TEST);
				glState.cur_depthTestEnabled=false;
			}
		} else { 

			if (!glState.cur_depthTestEnabled)
			{
				glEnable(GL_DEPTH_TEST);
				glState.cur_depthTestEnabled=true;
			}
			if (l->depthFunc!=glState.cur_depthFunc)
			{
				glDepthFunc(l->depthFunc);
				glState.cur_depthFunc = l->depthFunc;
			}
		}
	}

	float CRendererGL::Eval(float *p)
	{
		float x, y = 0;
	//	float time = (float)(APPLICATION::CApplication::GetApplication()->GetTicker().getTick()%(GENERAL::TGameTick)(1000.0f/p[4]));
		x = (((float)APPLICATION::CApplication::GetApplication()->GetTicker().getTick())/1000.0f + p[3]) * p[4];	//x = (Timer::fTime) * p[4] + p[3];
//		x = (time+p[3])*p[4];
		x -= floorf(x);

		switch ((int) (p[0]))
		{
		case FUNC_SIN:
			y = sinf(x*2.0f*3.1415f);
			break;
		case FUNC_SQUARE:
			y = (x<0.5f)?1.0f:-1.0f;
			break;
		case FUNC_SAWTOOTH:
			y = x;
			break;
		case FUNC_INVERSESAWTOOTH:
			y = 1.0f-x;
			break;
		case FUNC_TRIANGLE:
			y=(x<0.5)?4.0f*x -1.0f:-4.0f*x+3.0f;
			break;
		default:
			break;
		}

		return y*p[2]+p[1];

	}


}