#include "cube.h"
#include <morfclasses.h>
#include <trace.h>

namespace FRONTEND
{
	CObjCube::~CObjCube()
	{
	}

	void CObjCube::Update(int _flags)
	{
	}

	bool CObjCube::MouseDown(EMouseButton button, int x,int y,int z,TMouseButtons &buttons,TKeyStates &keys)
	{
		dprintf("CTestobject MouseDown button(%ld), objectID(%ld)\n",button,domainObj->GetID());
		return true;
	}

	CObjCubeGL::CObjCubeGL(DOMAIN::CGraphObject *_domainObj, float _r,
						  GENERAL::CVector3f &_worldOffset,
						  GENERAL::CVector3f &_worldRot,
						  HResTexture _texture,
						  GENERAL::TColor4ub &_color) : CObjCube( _domainObj,
														_r,
														_worldOffset,
														_worldRot,
														_texture,
														_color)
	{
	
		if (domainObj->GetID()==1)
		{
			color.r=0;
			color.g=255;
			color.b=0;
		} else {
			color.r=0;
			color.g=0;
			color.b=255;
		}
		base = glGenLists(1);

		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D,((HResTextureGL)texture)->GetTextureName());

		glNewList(base, GL_COMPILE);
			glBegin(GL_QUADS);	
				// Front Face
				glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);
				glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);
				glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);
				glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);
				// Back Face
				glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);
				glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);
				glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);
				glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);
				// Top Face
				glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);
				glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);
				glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f,  1.0f,  1.0f);
				glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f,  1.0f,  1.0f);
				// Bottom Face
				glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, -1.0f, -1.0f);
				glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);
				glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);
				glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f, -1.0f, -1.0f);
				// Right face
				glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);
				glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);
				glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);
				glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);
				// Left Face
				glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);
				glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);
				glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);
				glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);
			glEnd();								
		glEndList();		
	}

	CObjCubeGL::~CObjCubeGL()
	{
		glDeleteLists(base,1);
	}
	
	void CObjCubeGL::Render(int _dt)
	{

		glPushAttrib(GL_ENABLE_BIT);
		glPushMatrix();

		glDepthFunc(GL_ALWAYS);	
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glEnable(GL_BLEND);

		//glDisable(GL_CULL_FACE);
		GENERAL::CVector3f translation=((DOMAIN::CTestObject*) domainObj)->GetPos();
		translation+=worldOffset;

		glScalef(10.0f,10.0f,10.0f);		
		glTranslatef(translation.x,translation.y,translation.z);
		glTranslatef(0.0f,5.0f,0.0f);
		glRotatef( ((DOMAIN::CTestObject*) domainObj)->angle *180 / PI, 0.3f,1.0f,0.5f);
	
		
		glColor4ubv(color.array);
        
//		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D,((HResTextureGL)texture)->GetTextureName());
		glCallList(base);

		glPopMatrix();
		glPopAttrib();
	}

}