#ifndef OBJ_CUBE_H
#define OBJ_CUBE_H


#include <morfbase.h>
#include <object.h>
#include <glheaders.h>


#include "../resources/texture.h"

namespace FRONTEND
{
	class CObjCube : public CRenderAble
	{
	protected:

		float r;
		GENERAL::CVector3f worldOffset;
		GENERAL::CVector3f worldRot;

		GENERAL::CVector3f currentOffset;
		GENERAL::CVector3f currentRot;

		HResTexture texture;
		GENERAL::TColor4ub color;

	public:
		inline CObjCube(
					DOMAIN::CGraphObject *_domainObj, 
					float _r, 
					GENERAL::CVector3f &_worldOffset,
					GENERAL::CVector3f &_worldRot,
					HResTexture _texture,
					GENERAL::TColor4ub &_color) :
			CRenderAble(NULL,_domainObj), 
			r(_r), 
			worldOffset(_worldOffset),
			worldRot(_worldRot),
			texture(_texture), 
			color(_color)
		{}
	
		virtual ~CObjCube();


		virtual void Update(int _flags = UPDATEFLAGS_ALL);

		virtual bool MouseDown(EMouseButton button, int x,int y,int z,TMouseButtons &buttons,TKeyStates &keys);
	};

	class CObjCubeGL : public CObjCube 
	{
	protected:

		GLuint base;

	public:
			
		CObjCubeGL(DOMAIN::CGraphObject *_domainObj, float _r,
						  GENERAL::CVector3f &_worldOffset,
						  GENERAL::CVector3f &_worldRot,
						  HResTexture _texture,
						  GENERAL::TColor4ub &_color);
		
		virtual ~CObjCubeGL();
	
		virtual void Render(int _dt = 0);
	};


}

#endif