#include "fsm.h"

#include <map>

namespace FRONTEND
{
	CResFSM::CResFSM(CResourceManager *_resMan,char *_file, int _targetstatus)
		: CFEResource(_resMan,_file,_targetstatus)
	{
		data=NULL;
		status = RESSTATUS_NOTLOADED;
		if (_targetstatus!=RESSTATUS_NOTLOADED) LoadFromFile(_file, _targetstatus);
	}

	CResFSM::~CResFSM()
	{
		SAFE_FREE(data);
	}
	
	bool CResFSM::LoadFromFile(char *_file, int _targetstatus)
	{
		FILE *fp = GENERAL::morfOpenFile(_file,"r");

		if (fp==NULL)
			return false;

		char line[2048];
		int cmd=0;
		int lines=-1;
		animationTranslation.clear();
		commandTranslation.clear();
		while (fgets(line,2048,fp)!=NULL)
		{
			char *comment = strstr(line,"//");
			if (comment!=NULL)
				*comment='\0';

			char *token;
			token = strtok(line," \n\t");
			if (token==NULL)
				continue;

			if (stricmp(token,"#lines")==0)
			{
				char *eptr;
				token = strtok(NULL," \n\t");
				if (token==NULL)
					continue;

				animations=lines=strtol(token,&eptr,0);
				if ( (eptr==token) ||
						( (*eptr!='\0') && (*eptr!='\n') )
						)
				{
					lines=-1;
					GENERAL::dprintf("[ WARN ] CResFSM::LoadFromFile: invalid line in: %s! Skipped!\n", _file);
					continue;	
				}

				continue;
			}

			while (token!=NULL)
			{
				int command = CONFIG::g_config.ModelCommands[token];
				commandTranslation[command]=cmd;
				cmd++;
				token = strtok(NULL," \n\t");
			}
			if (cmd>0) break;
		}

		if (lines==-1)
		{
			GENERAL::dprintf("[ERROR] CResFSM::LoadFromFile: no '#lines' token provided in: %s!\n", _file);
			fclose(fp);
			return false;
		}

		commands = cmd;
		data = (long*)malloc(sizeof(long)*cmd*lines);
		long currentLine=0;

		while (fgets(line,2048,fp)!=NULL)
		{
			char *comment = strstr(line,"//");
			if (comment!=NULL)
				*comment='\0';

			char *token;
			token = strtok(line," \n\t");
			if (token==NULL)
				continue;

			long animation = CONFIG::g_config.AnimationIds[token];
			animationTranslation[animation]=currentLine;

			int i=0;
			token = strtok(NULL," \n\t");
			while (token)
			{
				if (stricmp(token,"#stay")==0)
				{
					data[cmd*currentLine+i]=0;
				} else if (token[0]=='*')
				{
					data[cmd*currentLine+i]=-CONFIG::g_config.AnimationIds[token+1];
				} else data[cmd*currentLine+i]=CONFIG::g_config.AnimationIds[token];

				dprintf("%2d ",data[cmd*currentLine+i]);
				i++;
				token = strtok(NULL," \n\t");
			}	
			currentLine++;
			dprintf("\n");
		}	

		if (ferror(fp))
		{
			GENERAL::dprintf("[FAILED] CResFSM::LoadFromFile: Could not read the file %s!",_file);
			return false;
		}

		fclose(fp);
		status = _targetstatus;

		return true;
	}

	bool CResFSM::LoadIntoGraphicAdapter(int _targetsatus)
	{
		return false;
	}

	bool CResFSM::UnloadFromGraphicAdapter()
	{
		return false;
	}

	int CResFSM::GetNextState(long _currentState, long _command)
	{
		std::map<long,long>::iterator ait,cit;

	if(_command)
	{
		int blo=4;
	}

		ait = animationTranslation.find(_currentState);
		cit = commandTranslation.find(_command);

		if ( (ait==animationTranslation.end()) ||
			 (cit==commandTranslation.end()))
			 return 0;

		if (_command!=0)
		{	
			dprintf("comds: ");
			for (int i=0;i<commands;i++)
			{
				dprintf("%d ",data[ait->second*commands+i]);
			}
			dprintf("\n");
		}


		int bla = data[ait->second*commands+cit->second];
		if (bla)
		{
			int blu=123;
		}
		return data[ait->second*commands+cit->second];
	}
}
