#ifndef RES_GUISTYLE_H
#define RES_GUISTYLE_H

#include <morfbase.h>
#include "shader.h"

namespace FRONTEND
{
	class CResGUIStyle : public CFEResource 
	{
	public:
		enum EButtonNumber {
			EBUTTON_RELEASED = 0,
			EBUTTON_FOCUSED_RELEASED,
			EBUTTON_HIGHLIGHTED_RELEASED,
			EBUTTON_FOCUSED_PRESSED,

			EBUTTON_MAX
		};

		struct TElement
		{
			int borderLeft;
			int borderTop;
			int borderRight;
			int borderBottom;

			int sizex;
			int sizey;

			HResShader clientShader;
			HResShader borderShader;
		};

		CResGUIStyle(CResourceManager *_resMan,char *_file, int _targetstatus);
		virtual ~CResGUIStyle();
		
		virtual bool LoadFromFile(char *_file, int _targetstatus);
		virtual bool LoadIntoGraphicAdapter(int _targetsatus);
		virtual bool UnloadFromGraphicAdapter();

		TElement	window[1];
		TElement	solidBckg[1];
		TElement	titlebar[1];
		TElement	btndefault[EBUTTON_MAX];
		TElement	btnup[EBUTTON_MAX];
		TElement	btndown[EBUTTON_MAX];
		TElement	btnleft[EBUTTON_MAX];
		TElement	btnright[EBUTTON_MAX];
		TElement	btnminimize[EBUTTON_MAX];
		TElement	btnmaximize[EBUTTON_MAX];
		TElement	btnclose[EBUTTON_MAX];
		TElement	btnpopup[EBUTTON_MAX];


	protected:
		void ParseElement(TElement *el, char *line);
	};

	typedef sptr<CResGUIStyle> HResGUIStyle;
}

#endif