#include "md3link.h"

namespace FRONTEND
{
	CResMD3Link::CResMD3Link(CResourceManager *_resMan,char *_file, int _targetstatus) : CFEResource(_resMan, _file, _targetstatus)
	{
//SPTR		fsm = NULL;
		status = 0; 
		if (_targetstatus>=RESSTATUS_INMEMORY) 
		{
			APPLICATION::CApplication::GetApplication()->GetLoadingthread().LoadResource(this,_file,_targetstatus);
		}
	}
	
	CResMD3Link::~CResMD3Link() 
	{
		std::vector<MD3MODEL::tMD3Mesh>::iterator it;
		for (it = link.pMeshes.begin(); it != link.pMeshes.end(); it++)
		{
			free(it->pShaders);
			free(it->pVerts);
			free(it->pTexCoords);
			free(it->pTriangles);
			free(it->pNormals);
		}

		SAFE_DELETE_AR(link.pTags);
		SAFE_DELETE_AR(link.pFrames);
	};
	
	bool CResMD3Link::LoadFromFile(char *_file, int _targetstatus) 
	{
		MD3MODEL::CLoadMD3Link loader;
		
		if (loader.ReadMD3LinkData(&link, _file))
		{
			GENERAL::dprintf("[  OK  ] ResourceManager: Loaded MD3Link %s\n", _file);
			status = RESSTATUS_INMEMORY;

			fsm = resMan->GetPtr(sptr<CRenderAble>(),link.fsmName,RESTYP_FSM);

			return true;
		} else
		{
			GENERAL::dprintf("[FAILED] ResourceManager: Unable to load MD3Link %s\n", _file);
			status = RESSTATUS_NOTLOADED;
			return false;
		}
	}

	bool CResMD3Link::LoadIntoGraphicAdapter(int _targetsatus) { return false;}

	bool CResMD3Link::UnloadFromGraphicAdapter() { return false;}

}