#include "inputthread.h"
#include <io.h>
#include "../../general/base/serialize.h"

#include "../../general/base/trace.h"

namespace APPLICATION 
{

CInputThread::CInputThread()
{
	terminate=false;
	if ((hThread=(HANDLE)_beginthread(staticInputThread,0,this))==(HANDLE)-1L)
			THROW("Cannot start input thread");
}

CInputThread::~CInputThread()
{
	terminate=true;
	WaitForSingleObject(hThread,INFINITE);

	while (!IsEpmty())
		delete [] PopString();
}

void CInputThread::staticInputThread(void *param)
{
	((CInputThread*)param)->InputThread();
}

void CInputThread::InputThread()
{
	while ((!feof(stdin)) && (!terminate))
	{
		char *ci=new char[1024];
		fgets(ci,1024,stdin);
		strings.push_back(ci);
	}

	char *ci=new char[1024];
	strcpy(ci,"shutdown");
	strings.push_back(ci);

	_endthread();
}

bool CInputThread::IsEpmty()
{
	return strings.empty();
}

char *CInputThread::PopString()
{
	char *res = strings.front();
	strings.pop_front();
	return res;
}

}