#include "domain.h"

#include "../../frontend/base/renderable.h"
#include "objectman.h"
#include "../../application/base/application.h"
#include "../../morfbase.h"
#include "../../general/base/trace.h"




namespace DOMAIN
{

IMPLEMENT_SERIALIZEABLE(CAction)
void CAction::execute() {}
CAction::~CAction() {}

CDomain::~CDomain() 
{
	SAFE_DELETE(rootObject);
	SAFE_DELETE(objMan);
	DonePython();
}

CDomain *g_World;

CDomain *GetWorld()
{
	return g_World;
}

void SetWorld(CDomain *w)
{
	g_World=w;
}

void CDomain::Init()
{
	InitPython();
	RegisterPyBaseInterfaceMethods();

	selectedObject=NULL;

	rootObject = new CGraphObject(this);
	rootObject->SetfeData(sptr<FRONTEND::CRenderAble>(new FRONTEND::CRenderAble(NULL, rootObject))); /// todo getfe? oder ganz weg?
}

void CDomain::OnSelectedObjectChange(CGameObject *_old, CGameObject *_new) 
{
	if (APPLICATION::CApplication::GetApplication()->GetFE()!=0)

	APPLICATION::CApplication::GetApplication()->GetFE()->SelectionChanged(_old,_new);
};

void CDomain::OnSelectedPlayerObjectChange(CGameObject *_old, CGameObject *_new)
{
};


void CDomain::RequestObjects(int num, long objectIDs[], sptr<CDomainCommand> &delaydCmd) 
{
	#pragma warning(push)	
	#pragma warning(disable:4200)
	#pragma pack(push)
	#pragma pack(1)
	struct TRequest {
		unsigned char num;
		long ids[];
	} *reqdata;
	#pragma pack(pop)
	#pragma warning(pop)	
	objMan->Add(delaydCmd);
	sptr<CDomainCommand> request = sptr<CDomainCommand>(new CDomainCommand(this));
	request->SetCommand(DOMAINCMD_REQUEST_OBJECT);

	request->SetParamLen((unsigned short)(sizeof(long)*num+sizeof(unsigned char)));
	reqdata = (TRequest*)malloc(request->GetParamLen());
	reqdata->num = num;
	memcpy(reqdata->ids,objectIDs,num*sizeof(long));
	request->SetParam(reqdata);
	request->SetUserdata(&delaydCmd);
	objMan->Add(request);
	request->SetSendToClientList(NULL);
	APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(request,delaydCmd->GetSendToClientList());
}

}