#ifndef DOMAIN_COMMAND_H
#define DOMAIN_COMMAND_H

#include "../objects/objects.h"

namespace DOMAIN
{
	class CDomainCommand : public CGameObject
	{
	protected:
		// Serializred data
		unsigned short int command;
		unsigned short int paramlen;
		void *param;

		// not serialized data (needed for reply)
		void *userdata;
	public:
		DECLARE_SERIALIZEABLE(CDomainCommand);
		inline CDomainCommand(CDomain *domain) : CGameObject(domain), param(NULL) 
		{	
			SetClassKey(GET_KEY(CDomainCommand));
		};
		inline CDomainCommand(CDomain *_domain, int _odid,long _id) : CGameObject(_domain, _odid,_id), param(NULL)
		{	
			SetClassKey(GET_KEY(CDomainCommand));
		};
		virtual ~CDomainCommand();

		virtual long GetSerializedSize();
		virtual long Serialize(GENERAL::CBuffer &buffer);
		virtual long DeSerialize(GENERAL::CBuffer &buffer);

		inline unsigned short int GetCommand() {return command;};
		inline unsigned short int GetParamLen() {return paramlen;};
		inline void *GetParam() {return param;};
		inline void *GetUserdata() {return userdata;};
		inline void SetCommand(unsigned short int _command) {command=_command;};
		inline void SetParamLen(unsigned short int _paramlen) {paramlen=_paramlen;};
		inline void SetParam(void *_param) {param=_param;};
		inline void SetUserdata(void *_userdata) {userdata=_userdata;};

//		virtual void Print(FILE *f,bool newline=true);
	};

}

#endif