#include "simpleobjectman.h"
#include <Winbase.h>

namespace DOMAIN
{

	CSimpleObjectManager::CSimpleObjectManager(CDomain *_dom) : CObjectmanager(_dom)
	{
		localidcnt=-1;
		globalidcnt=10000;
		CreateDescriptorMap();
	};

	CSimpleObjectManager::~CSimpleObjectManager()
	{
		TObjectMap::iterator it;

		CGameObject *go;
		while (!objects.empty())
		{
			TObjectMap::iterator it = objects.begin();
			go = &(it->second);
			objects.erase(it);
		}

		objects.clear();
		
		dynamicLists.clear();
//3		visibleObjects.clear();
		objectDescriptorMap.clear();
		descriptorNameIDMap.clear();

	}
    
	sptr<DOMAIN::CGameObject> CSimpleObjectManager::GetPtr(long _id)
	{
		TObjectMap::iterator it = objects.find(_id);
		return (it!=objects.end())?it->second:NULL;
	}

	sptr<DOMAIN::CGameObject> CSimpleObjectManager::GetRef(long _id)
	{
		return GetPtr(_id);
	}

	
	long CSimpleObjectManager::GetId(sptr<DOMAIN::CGameObject> _obj)
	{
		return _obj->GetID();
	}
	
	void CSimpleObjectManager::Add(sptr<DOMAIN::CGameObject> _obj)
	{
		static DOMAIN::CGameObject *o1, *o2, *o3;
		o1=o2;
		o2=o3;
		o3=&_obj;

		if (_obj->GetID()==0)
		{
			if (freelocalids.empty())
			{
				_obj->SetID(localidcnt--);
			}
			else
			{
				_obj->SetID(freelocalids.front());
				freelocalids.pop_front();

			}
		}
		_obj->SetDomain(domain);

		objects[_obj->GetID()]=_obj;
	}

	void CSimpleObjectManager::Release(sptr<DOMAIN::CGameObject> _obj)
	{
//		Release(_obj->GetID());
//		if (_obj->GetRefCount()==1)
//			ReleaseID(_obj->GetID());
//		_obj->ReleaseRef();
	}
	
	void CSimpleObjectManager::Release(long _id)
	{
/*		if (_id!=0)
		{
			objects.erase(_id);
			if (_id<0) freeids.push_back(_id);
		}*/
	}

/*	void CSimpleObjectManager::ReleaseID(long _id)
	{	
	}*/

	void CSimpleObjectManager::PrintDebug(char *st)
	{
		char out[128];
		if (strcmp(st,"numobj")==0)
		{
			sprintf(out, "Objectcount: %i\n", objects.size());
			OutputDebugStringA(out);
		}
		if (strcmp(st,"objs")==0) 
		{
			sprintf(out, "Objectcount: %i\n", objects.size());
			OutputDebugStringA(out);
			TObjectMap::iterator it;
			for (it=objects.begin();it!=objects.end();it++)
			{
			
				sprintf(out, "OID: %i Class: RefCnt: %i\n", it->second->GetID()/*, it->second->GetClassName()*/, it->second.GetRefCount());
				OutputDebugStringA(out);
			}
		}
	}

	sptr<GAME::CObjectDescriptor> CSimpleObjectManager::GetDescriptor(char *_name)
	{
		return GetDescriptor(GetDescriptorID(_name));
	}

	sptr<GAME::CObjectDescriptor> CSimpleObjectManager::GetDescriptor(int _id)
	{
		TObjectDescriptorMap::iterator it = objectDescriptorMap.find(_id);

		if (it!=objectDescriptorMap.end())
		{
			if (it->second.descriptor==NULL)
			{
				it->second.descriptor = new GAME::CObjectDescriptor();
				it->second.descriptor->Init((char*)it->second.name.data(),(char*)it->second.file.data());
			}

			return it->second.descriptor;
		}

		DOMAINTHROW("Obect Descriptor not found! - should NEVVER be reached!!!!!");
		return sptr<GAME::CObjectDescriptor>();
	}

	bool CSimpleObjectManager::CreateDescriptorMap()
	{
		char *filename = "items/shotgun.item";
		FILE *fp = morfOpenFile(filename,"r");
		if (!fp) return false;

		std::vector<std::string> tokens;
		char *token;
		char line [1024];

		while (fgets(line,1024,fp)!=NULL)
		{
			token = strtok(line," \n\t");
			while (token)
			{
				tokens.push_back(token);
				token = strtok(NULL," \n\t");
			}
		}	

		if (ferror(fp))
		{
			fclose(fp);
			return false;
		}

		fclose(fp);

		int level=0;

		for (std::vector<std::string>::iterator it = tokens.begin(); it!=tokens.end(); it++)
		{
			if (!stricmp("{",it->data()))
			{
				level++;
				continue;
			}
			if (!stricmp("}",it->data()))
			{
				level--;
				continue;
			}

			if (level==0) 
			{
				char *stnum = strtok((char*)it->data(),":");
				int num;
				if (stnum==NULL) continue;

				char *eptr;
				num = strtol(stnum,&eptr,0);
				if ((eptr==stnum) || (*eptr!='\0'))
					continue;

				char *name = strtok(NULL,"");
				if (name==NULL) continue;


				descriptorNameIDMap[name]=num;
				objectDescriptorMap[num]=TDescriptorNameFile(name,filename);
			}
			
		}

		return true;	
	}

	long CSimpleObjectManager::GetDescriptorID(char *name)
	{ 
		return descriptorNameIDMap.get(name);
	} 

	long CSimpleObjectManager::CreateGlobalId()
	{
		if (freeglobalids.empty())
			{
				return globalidcnt++;
			}
			else
			{
				long res = freeglobalids.front();
				freeglobalids.pop_front();
				return res;
			}
	}

	void CSimpleObjectManager::CleanUp()
	{
		TObjectMap::iterator it;
		it = objects.begin();
		while (it!= objects.end())
		{
//			sptr<DOMAIN::CGameObject> &go = it;
			if ((it->second.info->count==1) && (it->second->GetCanDelete()))
				it = objects.erase(it);
			else
				it++;
		}
	}
    


	



};