#ifndef SIMPLEOBJECTMAN_H
#define SIMPLEOBJECTMAN_H

#include <map>
#include <list>
#include <vector>

#include "../base/objectman.h"
#include "../objects/objects.h"


namespace DOMAIN
{
	class CSimpleObjectManager : public CObjectmanager
	{
	public:

		typedef enum {ALLLIST=0,VISIBLELIST=1};

		typedef morfmap<long, sptr<DOMAIN::CGameObject> > TObjectMap;
		typedef std::vector<CDomain::TObjectList> TDynamicLists;
		typedef morfmap<std::string, long> TDescriptorNameIDMap;
		struct TDescriptorNameFile 
		{ 
			TDescriptorNameFile() : name(), file(), descriptor() {};
			TDescriptorNameFile(const TDescriptorNameFile &assign) : name(assign.name), file(assign.file), descriptor(assign.descriptor) {};
			TDescriptorNameFile(std::string _name, std::string _file) : name(_name), file(_file), descriptor() {};

			std::string name,file; 
			sptr<GAME::CObjectDescriptor> descriptor;
		};
		typedef morfmap<long,TDescriptorNameFile > TObjectDescriptorMap;

	private:
		std::list<long> freelocalids;
		long localidcnt;

		std::list<long> freeglobalids;
		long globalidcnt;

		TObjectMap objects;
		TDynamicLists dynamicLists;
//3		CDomain::TObjectList visibleObjects;
		TObjectDescriptorMap objectDescriptorMap;
		TDescriptorNameIDMap descriptorNameIDMap;

	public:

		CSimpleObjectManager(CDomain *_dom);
		virtual ~CSimpleObjectManager();

		virtual sptr<DOMAIN::CGameObject> GetRef(long _id);
		virtual sptr<DOMAIN::CGameObject> GetPtr(long _id);

		long GetId(sptr<DOMAIN::CGameObject> _obj);
		void Add(sptr<DOMAIN::CGameObject> _obj);

		void Release(sptr<DOMAIN::CGameObject> _obj);
		void Release(long _id);

		//void ReleaseID(long _id);

		void PrintDebug(char *st = "objs");

//3
/*		inline void SetVisible(sptr<DOMAIN::CGraphObject> _obj) 
		{
			visibleObjects[_obj->GetID()] = _obj;
		}*/

		inline TObjectMap &GetAllList() { return objects;};

//3		inline CDomain::TObjectList &GetVisibleList() { return visibleObjects;};

		virtual sptr<GAME::CObjectDescriptor> GetDescriptor(char *_name);
		virtual sptr<GAME::CObjectDescriptor> GetDescriptor(int _id);

		virtual bool CreateDescriptorMap();
		virtual long GetDescriptorID(char *name);

		virtual long CreateGlobalId();
		virtual void CleanUp();
	};

}

#endif