#include "levelobjects.h"

namespace DOMAIN
{
	IMPLEMENT_SERIALIZEABLE_DOMAIN(DOMAIN::CLevelObject);
	IMPLEMENT_SERIALIZEABLE_DOMAIN(DOMAIN::CPhysicalLevelObject);
	IMPLEMENT_SERIALIZEABLE_DOMAIN(DOMAIN::CLevel) 
	
	CLevel::~CLevel()
	{
	}

	GENERAL::CVector3f CLevel::Trace(CPhysicalLevelObject *_obj,GENERAL::CVector3f _start, GENERAL::CVector3f _end)
	{
		return _end;
	}

	void CLevel::FitTo(GENERAL::CVector3f _direction) {}

	void CLevel::LevelObjectMoved(CLevelObject *_obj)
	{
	}

	void CLevelObject::SetLvl(CLevel *_lvl) 
	{
		lvl = _lvl; 
	};

	CLevelObject::~CLevelObject() 
	{
	}

/*	void CLevelObject::Assign(CGameObject *o)
	{
		
		CWorldObject::Assign(o);
		lvlId = ((CLevelObject*)o)->GetLvlId();
		lvl = 0;
	}*/
	
	long CLevelObject::GetSerializedSize()
	{
		return 
			CWorldObject::GetSerializedSize()+
			sizeof(long) ;
	}
	
	long CLevelObject::Serialize(GENERAL::CBuffer &buffer)
	{
		CWorldObject::Serialize(buffer);
		
		buffer.Write(&lvlId,sizeof(long));

		return buffer.GetPos();

	}
	
	long CLevelObject::DeSerialize(GENERAL::CBuffer &buffer)
	{
		CWorldObject::DeSerialize(buffer);

		lvlId =*(long*)buffer.Read(sizeof(long));

		return buffer.GetPos();
	}

	/***************** P H Y S I C A L 
	                     L E V E L
	                     O B J E C T  ****************************************/ 

	
	CPhysicalLevelObject::~CPhysicalLevelObject() 
	{
	}

	long CPhysicalLevelObject::GetSerializedSize()
	{
		return 
			CLevelObject::GetSerializedSize()+
			(sizeof(int) * 2) +  // collissionMode & movmentMode 
			(sizeof(float)*3) +  // mass, boundingRadius, stepHeight
			(GENERAL::GetSerializedSizeVector3f()*4);  // velocity, anglevelocity, boundingbox
	}

	long CPhysicalLevelObject::Serialize(GENERAL::CBuffer &buffer)
	{
		CLevelObject::Serialize(buffer);

		buffer.Write(&mass,sizeof(float));
		buffer.Write(&boundingRadius,sizeof(float));
		buffer.Write(&stepHeight,sizeof(float));
		buffer.Write(&collisionMode, sizeof(int));
		buffer.Write(&movementMode, sizeof(int));
		GENERAL::SerializeVector3f(velocity[ACT],buffer);
		GENERAL::SerializeVector3f(anglevelocity,buffer);
		GENERAL::SerializeVector3f(boundingBox.minV,buffer);
		GENERAL::SerializeVector3f(boundingBox.maxV,buffer);
/*		boundingBox = GENERAL::TBox(
			GENERAL::CVector3f(-13.218750,-1,-23.109375), 
			GENERAL::CVector3f(15.328125,14.093750,14.640625));*/



		return buffer.GetPos();
	}

	long CPhysicalLevelObject::DeSerialize(GENERAL::CBuffer &buffer)
	{
		CLevelObject::DeSerialize(buffer);

		mass =*(float*)buffer.Read(sizeof(float));
		boundingRadius =*(float*)buffer.Read(sizeof(float));
		stepHeight =*(float*)buffer.Read(sizeof(float));

		collisionMode =*(int*)buffer.Read(sizeof(int));
		movementMode =*(int*)buffer.Read(sizeof(int));
		
		GENERAL::DeSerializeVector3f(velocity[ACT],buffer);
		GENERAL::DeSerializeVector3f(anglevelocity,buffer);
		GENERAL::DeSerializeVector3f(boundingBox.minV,buffer);
		GENERAL::DeSerializeVector3f(boundingBox.maxV,buffer);

		return buffer.GetPos();
	}

	void CPhysicalLevelObject::CopyPDUto(char *data)
	{
		CLevelObject::CopyPDUto(data);
		TPDU *pdu = (TPDU*)data;
		pdu->velocity = velocity[PDU];
	}


	void CPhysicalLevelObject::CopyPDUfrom(char *data)
	{
		CLevelObject::CopyPDUfrom(data);
		TPDU *pdu = (TPDU*)data;
		velocity[PDU]=pdu->velocity;
		isInterpolating=false;
	}

	void CPhysicalLevelObject::SetPDU()
	{
		CLevelObject::SetPDU();
		velocity[PDU]=velocity[ACT];
	}

	int CPhysicalLevelObject::GetPDUSize()
	{
		return sizeof(TPDU);
	}

	void CPhysicalLevelObject::Print(FILE *f,bool newline)
	{
		CLevelObject::Print(f,newline);
	}

/*	void CPhysicalLevelObject::Assign(CGameObject *o)
	{
		CLevelObject::Assign(o);

		stepHeight = ((CPhysicalLevelObject*)o)->GetStepHeight();
		movementMode = ((CPhysicalLevelObject*)o)->GetMovementMode();
		collisionMode = ((CPhysicalLevelObject*)o)->GetCollisionMode();
		mass = ((CPhysicalLevelObject*)o)->GetMass();						
		boundingRadius = ((CPhysicalLevelObject*)o)->GetBoundingRadius();			
	}*/

	float CPhysicalLevelObject::GetPDUTreshHold()
	{
		return (velocity[PDU]-velocity[ACT]).abs2()*25.0f+CLevelObject::GetPDUTreshHold();
	}

	#define SMOOTHTIME 200

	ECollisionAction CPhysicalLevelObject::Collided(CVector3f pos, CVector3f normal)
	{
		return COLLISIONACTION_SLIDE;
	}

	void CPhysicalLevelObject::TimeStep(GENERAL::TGameTick dt)
	{
		if (!lvl) return;

		CLevelObject::TimeStep(dt);

		GENERAL::CVector3f newpos;

		if (GetID()==6000)
		{
			int bkl = 1;

		}
		
		if (movementMode==MOVEMENTMODE_GRAVITY)
		{
			if (velocity[ACT].y>-1000)
 				velocity[ACT].y -= 10;
			if (velocity[PDU].y>-1000)
				velocity[PDU].y -= 10;
		}



		if (doDeathReckoning)
		{
			if (timestamp[ACT]-timestamp[PDU]>=SMOOTHTIME)
			{
				if (isInterpolating) 
				{
//					pos[ACT]=pos[PDU];
//					dt+=timestamp[ACT]-(timestamp[PDU]+SMOOTHTIME);
				}

				if (velocity[ACT].abs2()>1.0f)
				{
					newpos = pos[ACT] + velocity[ACT]*((float)dt)/1000.0f;	
					pos[ACT]= (GetLvl())->Trace(this,pos[ACT], newpos);
					GetLvl()->LevelObjectMoved(this);
				}

//				pos[ACT] = pos[PDU];
				rotation[ACT] = rotation[PDU];
				velocity[ACT] = velocity[PDU];
				isInterpolating=false;
			} else {
				static GENERAL::CVector3f p0,p1;
				static GENERAL::CVector3f r0,r1;

				if (!isInterpolating)
				{
					r0 = rotation[ACT];
					r1 = rotation[PDU];
					p0 = pPatch.controlPoints[0] = pos[ACT];
					pPatch.controlPoints[1] = pos[ACT]+velocity[ACT]*((float)SMOOTHTIME)/1000.0f;
					p1 = pPatch.controlPoints[2] = pos[PDU]+velocity[PDU]*((float)SMOOTHTIME)/1000.0f;
					isInterpolating=true;
				}

				GENERAL::SCALAR t = ((float)(timestamp[ACT]-timestamp[PDU]))/SMOOTHTIME;
//				newpos = p0*(1-t)+p1*t;
				pPatch.Tesselate(newpos, t);
				
				if ((pos[ACT]-newpos).abs2()>1.0f)
				{
					pos[ACT]= GetLvl()->Trace(this,pos[ACT], newpos);
					GetLvl()->LevelObjectMoved(this);
				}

				rotation[ACT] = (r0*(1-t)+r1*t).Normal();

				velocity[ACT] = velocity[PDU];
			}

		} else {
			// controlling
 			newpos = pos[PDU] + velocity[PDU]*((float)dt)/1000.0f;	
			pos[PDU]= (GetLvl())->Trace(this,pos[PDU], newpos);

			if (velocity[ACT].abs2()>1.0f)
			{
				newpos = pos[ACT] + velocity[ACT]*((float)dt)/1000.0f;
				pos[ACT]= GetLvl()->Trace(this,pos[ACT], newpos);
				GetLvl()->LevelObjectMoved(this);
			}
		}
	}

	void CPhysicalLevelObject::MoveTo(GENERAL::CVector3f &_pos)
	{
		pos[ACT] = _pos;
		GetLvl()->LevelObjectMoved(this);
	}
	
	

	void CPhysicalLevelObject::Forward(float amount)
	
	{
		/*
		if (GetLvl()==0)
		{
			pos += rotation*amount;
		}
		else
		{
			pos = ((CQuakeBsp*)GetLvl())->TraceSphere(this,pos, pos+(rotation*amount));
		}
		*/
		

	}


	void CPhysicalLevelObject::LookX(float angle)
	{
		static float currentRotUp = 0.0f;
			currentRotUp +=angle;

		if ((currentRotUp>-1.0f) && (currentRotUp<1.0f))
			{
				GENERAL::CMatrix4f mat;
				GENERAL::CVector3f axis(rotation[ACT] * GENERAL::CVector3f(0.0f,1.0f,0.0f));

				axis.Normal();
				mat.SetRotate(angle,axis);
				rotation[ACT] = mat * rotation[ACT];
				rotation[ACT].Normal();
			}
	}

	void CPhysicalLevelObject::LookY(float angle)
	{
		GENERAL::CMatrix4f mat;
		mat.SetRotate(angle,GENERAL::CVector3f(0.0f,1.0f,0.0f));
		rotation[ACT] = mat * rotation[ACT];
		rotation[ACT].Normal();
	}

	void CPhysicalLevelObject::LookZ(float angle)
	{
	}

	
//	PY_GET_ACCESSOR_IMPL(CPhysicalLevelObject,GetVelocity,Vector3fToPython);
//	PY_SET_ACCESSOR_IMPL(CPhysicalLevelObject,SetVelocity,PythonToVector3f);
}
