#include "renderable.h"
#include "../../domain/objects/objects.h"

#include "frontend.h"


namespace FRONTEND
{

	CRenderAble *CRenderAble::selectedRenderAble;

	void CRenderAble::Init(sptr<CRenderAble> &_self)
	{
	}

	CRenderAble::~CRenderAble() 
	{
		if (isSelected)
			Deselect();
//		if (fe) delete fe;
	}

	bool CRenderAble::MouseMove(int x,int y,int z,TMouseButtons &buttons,TKeyStates &keys) 
	{
		return false;
	}

	bool CRenderAble::MouseDown(EMouseButton button, int x,int y,int z,TMouseButtons &buttons,TKeyStates &keys)
	{
		GENERAL::dprintf("RenderAble MouseDown button(%ld), objectID(%ld)\n",button,domainObj->GetID());
		return false;
	}

	bool CRenderAble::MouseUp(EMouseButton button, int x,int y,int z,TMouseButtons &buttons,TKeyStates &keys)
	{
		return false;
	}

	bool CRenderAble::MouseClick(EMouseButton button, int x,int y,int z,TMouseButtons &buttons,TKeyStates &keys)
	{
		return false;
	}

	void CRenderAble::ResourceLoaded(CFEResource *_res) {};

	void CRenderAble::Update(int _flags) {};

	void CRenderAble::Render(int _dt)
	{
		DOMAIN::CGraphObject::tChildsType::iterator it;
		for (it = domainObj->GetChilds().begin(); it != domainObj->GetChilds().end(); it++)
		{
			if ((*it)->GetfeData()!=NULL) (*it)->GetfeData()->Render(_dt);
		}
	}

	void CRenderAble::SetSelectMode(ERenderSelectMode _mode, int defaultName)
	{
		selectMode = _mode; 
		selectName = defaultName;

		DOMAIN::CGraphObject::tChildsType::iterator it;
		for (it=domainObj->GetChilds().begin();it!=domainObj->GetChilds().end();it++)
		{
			if ((*it)->GetfeData()!=0) (*it)->GetfeData()->SetSelectMode(_mode, defaultName);
		}
	} 

	void CRenderAble::Select()
	{
		if (selectedRenderAble!=NULL)
			selectedRenderAble->Deselect();

		selectedRenderAble = this;

		domainObj->GetDomain()->SetSelectedObject(domainObj);

		DOMAIN::CGameObject::selectedGameObject = domainObj; // dont need this anymore
		isSelected = true;
		
	}

	void CRenderAble::Deselect()
	{
		isSelected = false;
		selectedRenderAble = NULL;

		domainObj->GetDomain()->SetSelectedObject(NULL);
        
		DOMAIN::CGameObject::selectedGameObject = NULL; // dont need this anymore
	}


}