#include "resource.h"
#include "renderable.h"
#include "../../general/base/trace.h"

namespace FRONTEND
{
	CFEResource::CFEResource(CResourceManager *_resMan,char *_file, int _targetstatus)
	{
		ref = 1;
		//resId = _resId;
		fname = _file!=0?strdup(_file):NULL;
		resMan = _resMan;
		status = _targetstatus;
	}

	long CFEResource::ReleaseRef()
	{
		ref--; 
		if (ref==0) 
		{
			delete this; 
			return 0;
		} return ref;
	}

	CFEResource::~CFEResource() 
	{
		SAFE_FREE(fname);
	};

	void CFEResource::AddRenderableRef(sptr<CRenderAble> &_renderable)
	{
		if (_renderable!=NULL)
			renderAbleRefList.push(_renderable);
	}

	void CFEResource::CallResourceLoaded()
	{
		while (!renderAbleRefList.empty())
		{
			sptr<CRenderAble> ra=renderAbleRefList.front();
			renderAbleRefList.pop();
			ra->ResourceLoaded(this);
		}
	}


}