
#include "config.h"
#include "parser.h"
#include "morftools.h"
//#include <shlwapi.h>
//#include "trace.h"

CONFIG::CConfig CONFIG::g_config;

CONFIG::CConfig::CConfig()
{

	GENERAL::dprintf("Creating Config\n");


	Load();

	ServerAddress = "127.0.0.1";
	ServerListenPort = 12345;
	ServerListenAddress = "0.0.0.0";
	ServerListenBacklog = 10;
	GameDatabasePort=3306;
	GameDatabaseServer="195.230.62.226";
	GameDatabaseUser="gameserver";
	GameDatabasePassword="gameserver";
	GameDatabaseName="gameserver";
}

CONFIG::CConfig::~CConfig()
{
}

bool CONFIG::CConfig::LoadFromFile(FILE *f)
{
	GENERAL::dprintf("Loading Config \n");


	char	rrbuf[100];
	char*	key;
	char*	value;

	while (!feof(f))
	{
		fgets(rrbuf, 100, f);
		key = strtok(rrbuf,"=");
		value = strtok(0," \n");
        
		char *eptr;

		int i =strtol(value, &eptr, 0);
		if ((isspace(*eptr)) || (*eptr == '\0'))
		{
			ConfInt[key]=i;
		} else ConfString[key]=value;
	};

	return true;
}
bool CONFIG::CConfig::Load()
{
/*	FILE *f;

	

	if ((f = fopen("Config.txt","r")) == NULL)
	{
		fprintf(stdout, "unable to open config file! aborting...");
		fgetchar();
		exit(1);
	}
	else
	{
		LoadFromFile(f);
		fclose(f);
	}*/

	GENERAL::CParser parser;
	GENERAL::CParser::TNode::TChildren::iterator f,l,n;
	parser.LoadFromFile("Config.txt");

	GENERAL::dprintf("Parsing \n");


	// LoadConfig
	parser.GetNodes(parser.GetRoot(),"config",f,l);
	while (f!=l)
	{
		for (n=f->second->children.begin(); n!= f->second->children.end(); n++)
		{
			if (n->second->val!=NULL)
			{
				GENERAL::dprintf("Configvalue: %s = %s\n",n->first.data(),n->second->val);
				char *eptr;
				int i=strtol(n->second->val,&eptr,0);
				if ( (eptr!=n->second->val) && (*eptr=='\0') )
				{
					ConfInt[n->first] = i;
				} else ConfString[n->first]=n->second->val;
			}
		}
		f++;
	}

	// serverconf
	parser.GetNodes(parser.GetRoot(),"server",f,l);
	while (f!=l)
	{
		for (n=f->second->children.begin(); n!= f->second->children.end(); n++)
		{
			if (n->second->val!=NULL)
			{
				ServerConf[n->first]=n->second->val;
			}
		}
		f++;
	}

	// LoadResource
	ResPath.clear();
	parser.GetNodes(parser.GetRoot(),"resources",f,l);
	while (f!=l)
	{
		for (n=f->second->children.begin(); n!= f->second->children.end(); n++)
		{
			if (n->first=="search")
			{
				GENERAL::dprintf("Adding Resource Path: %s\n",n->second->val);
				ResPath.push_back(n->second->val);
			}
		}
		f++;
	}

	// linkids
	parser.GetNodes(parser.GetRoot(),"linkids",f,l);
	while (f!=l)
	{
		for (n=f->second->children.begin(); n!= f->second->children.end(); n++)
		{
			if (n->second->val!=NULL)
			{
				char *eptr;
				int i=strtol(n->second->val,&eptr,0);
				LinkIds[i]=n->first;
				GENERAL::dprintf("Adding Linkid: %i %s\n",i, n->first.data());
			}
		}
		f++;
	}

	// Load tag types
	parser.GetNodes(parser.GetRoot(),"tagtypes",f,l);
	while (f!=l)
	{
		for (n=f->second->children.begin(); n!= f->second->children.end(); n++)
		{
			if (n->second->val!=NULL)
			{
				char *eptr;
				int i=strtol(n->second->val,&eptr,0);
				TagTypes[n->first]=i;
				GENERAL::dprintf("Adding TagType: %15s = %d\n",n->first.data(),i);
			}
		}
		f++;
	}

	// Load Animation Ids
	AnimationIds.clear();
	parser.GetNodes(parser.GetRoot(),"animationids",f,l);
	while (f!=l)
	{
		for (n=f->second->children.begin(); n!= f->second->children.end(); n++)
		{
			if (n->second->val!=NULL)
			{
				char *eptr;
				int i=strtol(n->second->val,&eptr,0);
				AnimationIds[n->first]=i;
				GENERAL::dprintf("Adding AnimationId: %15s = %d\n",n->first.data(),i);
			}
		}
		f++;
	}

	// Load Model Commands
	ModelCommands.clear();
	parser.GetNodes(parser.GetRoot(),"modelcommands",f,l);
	while (f!=l)
	{
		for (n=f->second->children.begin(); n!= f->second->children.end(); n++)
		{
			if (n->second->val!=NULL)
			{
				char *eptr;
				int i=strtol(n->second->val,&eptr,0);
				ModelCommands[n->first]=i;
				GENERAL::dprintf("Adding ModelCommand: %15s = %d\n",n->first.data(),i);
			}
		}
		f++;
	}

	// Load ObjectActions
	ObjectActions.clear();
	parser.GetNodes(parser.GetRoot(),"objectactions",f,l);
	while (f!=l)
	{
		for (n=f->second->children.begin(); n!= f->second->children.end(); n++)
		{
			if (n->second->val!=NULL)
			{
				char *eptr;
				int i=strtol(n->second->val,&eptr,0);
				ObjectActions[n->first]=i;
				GENERAL::dprintf("Adding ObjectAction: %15s = %d\n",n->first.data(),i);
			}
		}
		f++;
	}

	// Load ObjectStatus
	ObjectStatus.clear();
	parser.GetNodes(parser.GetRoot(),"objectstatus",f,l);
	while (f!=l)
	{
		for (n=f->second->children.begin(); n!= f->second->children.end(); n++)
		{
			if (n->second->val!=NULL)
			{
				

				char *eptr;
				int i=strtol(n->second->val,&eptr,0);
				ObjectStatus[n->first]=i;

				/// @todo caseproblem behandeln
				GENERAL::dprintf("Adding Objectstatus: %15s = %d\n",n->first.data(),i);
			}
		}
		f++;
	}

	// actioncaptions
	parser.GetNodes(parser.GetRoot(),"objectactionscaptions",f,l);
	while (f!=l)
	{
		for (n=f->second->children.begin(); n!= f->second->children.end(); n++)
		{
			if (n->second->val!=NULL)
			{
				char *eptr;
				long i=strtol((char*)n->first.data(),&eptr,0);
				ObjectActionsCaptions[i]=n->second->val;
			}
		}
		f++;
	}


	GENERAL::dprintf("Done Parsing \n");


	return true;
}
