#ifndef CONFIG_H
#define CONFIG_H

#include <map>
#include <string>
#include <deque>
#include <vector>

namespace CONFIG
{

class CConfig
{
public:
	typedef std::deque<std::string> TStringList;

	CConfig();
	virtual ~CConfig();

	char	*ServerAddress;
	int		 ServerListenPort;
	char	*ServerListenAddress;
	int		 ServerListenBacklog;

	int		 GameDatabasePort;
	char	*GameDatabaseServer;
	char	*GameDatabaseUser;
	char	*GameDatabasePassword;
	char	*GameDatabaseName;

	bool	LoadFromFile(FILE *f);
	bool	Load();

	std::map<std::string, std::string>		ConfString;
	std::map<std::string, long>				ConfInt;

	std::map<int, std::string>				LinkIds;	
	std::map<std::string, long>				TagTypes;

	std::map<std::string, long>				AnimationIds;

	std::map<std::string, long>				ModelCommands;
	std::map<std::string, std::string>		ServerConf;
	
	std::map<std::string, long>				ObjectActions;
	std::map<std::string, long>				ObjectStatus;

	std::map<long , std::string>			ObjectActionsCaptions;
	


	


	TStringList								ResPath;

};

	extern CConfig g_config;
}



#endif