#ifndef MORFTOOLS_H
#define MORFTOOLS_H

#include <deque>
#include <map>

#include "serialize.h"
#include "morfmath.h"
#include "pyscripting.h"

namespace GENERAL
{
	#ifdef DEBUG_TO_CONSOLE
	extern std::deque<std::string> debugconsole;
	#endif

	int dprintf(const char * format, ...);
	FILE *morfOpenFile(char *filename,char *mode);
	char *morfFindFile(char *filename);
	bool IsInString(std::string strString, std::string strSubString);

	inline long GetSerializedSizeVector3f()
	{
		return 3*sizeof(float);
	};
	inline long SerializeVector3f(CVector3f &vec, CBuffer &buffer)
	{
		buffer.Write(&vec.x,sizeof(float));
		buffer.Write(&vec.y,sizeof(float));
		buffer.Write(&vec.z,sizeof(float));
		return 3*sizeof(float);
	};
	inline long DeSerializeVector3f(CVector3f &vec, CBuffer &buffer)
	{
		vec.x = *(float*)buffer.Read(sizeof(float));
		vec.y = *(float*)buffer.Read(sizeof(float));
		vec.z = *(float*)buffer.Read(sizeof(float));
		return 3*sizeof(float);
	};
	inline long SerializeVector4f(CVector4f &vec, CBuffer &buffer)
	{
		buffer.Write(&vec.x,sizeof(float));
		buffer.Write(&vec.y,sizeof(float));
		buffer.Write(&vec.z,sizeof(float));
		buffer.Write(&vec.w,sizeof(float));
		return 4*sizeof(float);
	};
	inline long DeSerializeVector4f(CVector4f &vec, CBuffer &buffer)
	{
		vec.x = *(float*)buffer.Read(sizeof(float));
		vec.y = *(float*)buffer.Read(sizeof(float));
		vec.z = *(float*)buffer.Read(sizeof(float));
		vec.w = *(float*)buffer.Read(sizeof(float));
		return 4*sizeof(float);
	};

//	GetSerializedSizeVector3<float> FGetSerializedSizeVector3();
}

#endif