#ifndef PARSER_H
#define PARSER_H

#include <map>
#include <string>
#include <deque>

namespace GENERAL
{
	class CParser
	{
	public:
		struct TNode
			{
				typedef std::multimap<std::string, TNode*> TChildren;

				inline TNode() : val(NULL)
				{};
				inline TNode(char *_val)
				{
					val=(_val==NULL)?NULL:strdup(_val);
				};

				char *val;

				TChildren children;
			};

	public:
		TNode root;

		virtual bool ParseNode(TNode *node, char *name, char *data);
	public:
		inline CParser() {};
		virtual ~CParser();

		virtual bool LoadFromFile(char *filename);
		inline TNode *GetRoot() {return &root;};

		inline void GetNodes(TNode *node, char *name, TNode::TChildren::iterator &first, TNode::TChildren::iterator &last)
		{
			std::pair<TNode::TChildren::iterator,TNode::TChildren::iterator> p;
			p = node->children.equal_range(name);

			first = p.first;
			last = p.second;
		}

/*		inline GetNodeNext(TNode *_root, TNode::TChildren::iterator &it, char *name)
		{
			while (it!=_root->children.end())
			{
				
				it++;
			}
		}*/

	};

}  // namespace

#endif