#ifndef TREE_H
#define TREE_H

#include <list>
#include <vector>
#include <algorithm>
//#include "trace.h"

namespace std
{
/*	template <class type>
		class treenode<type>;
*/
/*	template <class type> 
		struct treenodedata 
		{
			type data;
			treenode<type> *parent;
		};*/

	template <class type>
		class treenode : protected vector< treenode<type>* >
		{
//		friend class tree;
		public:
			typedef vector< treenode<type>* >::iterator iterator;
			iterator begin() {return vector< treenode<type>* >::begin();}
			iterator end() {return vector< treenode<type>* >::end();}

			treenode<type> *parent;
			type data;

			treenode(treenode<type> *_parent) 
				: vector< treenode<type>* >(),
				parent(_parent),
				data() {}
			treenode(treenode<type> *_parent, type _data) 
				: vector< treenode<type>* >(),
				parent(_parent),
				data(_data) {}
			treenode(treenode<type> *_parent, treenode *_node) 
				: vector< treenode<type>* >(_node),
				parent(_parent),
				data(node->data) {}

			virtual ~treenode()
			{
				vector< treenode<type>* >::iterator it;
				for (it=begin(); it!=end(); it++)
				{
					delete (*it);
				}
			}

			void push_back(type _data)
			{
				push_back(new treenode<type>(this,_data));
			}
			void push_back(treenode<type> *node)
			{
				vector< treenode<type>* >::push_back(node);
			}

			bool operator == (type _data)
			{
				return data==_data;
			}
		};



	template <class type>
		class tree : protected list< treenode<type>* >
		{
		public:
			virtual ~tree()
			{
				if (!empty())
					delete front();
			}
			iterator insert(iterator where, type data)
			{
				treenode<type>* tn=NULL;
				if (where==end())
				{
					tn=new treenode<type>(NULL,data);
				} else {
					tn=new treenode<type>((*where),data);
					(*where)->push_back(tn);
				}
				return list< treenode<type>* >::insert(end(),tn);
			}

			iterator find(type value)
			{
				iterator it;
				for (it=begin();it!=end();++it)
				{
					if ((*it)->data==value) return it;
				}
				return end();
			}

			typedef list< treenode<type>* >::iterator iterator;
			iterator begin() {return list< treenode<type>* >::begin();}
			iterator end() {return list< treenode<type>* >::end();}
		};

} // namespace
#endif