#ifndef MORFBASE_H
#define MORFBASE_H

#define MORFBASE_INCLUDED
#define DEBUG_TO_CONSOLE
#define DEBUG_TO_FILE "debugout.txt"

#ifdef _DEBUG
	#pragma comment (lib, "morfbased.lib")
#else
	#pragma comment (lib, "morfbase.lib")
#endif

//#include "../extern/profiler/profiler.h"

#include "general/base/morfmath.h"
#include "general/base/morfforward.h"
#include "general/base/morfmodules.h"
#include "general/base/morftools.h"
#include "general/base/error.h"
#include "general/base/parser.h"

#include "frontend/base/renderable.h"

#include "domain/base/domain.h"
#include "domain/objects/objects.h"
#include "domain/objects/levelobjects.h"
#include "domain/objects/domainlight.h"
#include "domain/objects/chatchannel.h"

#include "general/base/config.h"

#include "general/base/morftypes.h"

//#include "domain/implementation/logindata.h"
//#include "domain/implementation/chatdomain.h"
//#include "../_domain/server/objectdomain.h"


#include "domain/base/objectman.h"
#include "application/base/inputthread.h"
#include "application/base/application.h"
#include "general/base/tick.h"
#include "frontend/base/frontendtypes.h"
#include "frontend/base/frontend.h"

#include "network/base/clientinfo.h"
#include "network/base/network.h"

#include "domain/implementation/simpleobjectman.h"
#include "domain/implementation/domaincommand.h"

#include "general/base/smartpointer.h"
#include "game/implementation/gamefsm.h"



using namespace GENERAL;



#undef MORFBASE_INCLUDED

namespace GENERAL
{
	void RegisterMorfBaseClasses();
	void RegisterPyBaseInterfaceMethods();
}

#endif


