#ifndef NETWORK_H
#define NETWORK_H

#include <windows.h>
#include <list>
//#include "../implementation/serversocket.h"

#include "../../general/base/morfforward.h"
#include "../../general/base/serialize.h"
#include "../../general/base/smartpointer.h"

namespace NETWORK
{
	class networkexception : public exception
	{
	public: 
		inline networkexception(char *what) : exception(what) {}
	};

	#define NETTHROW(x) throw networkexception(x)

	class CClientInfo;
/*	class CClientInfo : public GAME::CSerializeableObject 
	{
	};
*/

//	typedef _TClientInfoList : public std::list<CClientInfo*> 
//	{} TClientInfoList;
//	typedef TClientInfoList *PClientInfoList;

	/** Abstract Baseclass for the network Interface
	*/
	class CNetwork
	{
	public:
		DOMAIN::CDomain *domain;

		inline CNetwork(DOMAIN::CDomain *_domain) : domain(_domain) {};

		/** virtual Destructor are nesecary
		*/
		virtual ~CNetwork();

		/** Initializes the Networkclass
		*	\param listen Networkclass should act as server
		*/
		virtual void Init(bool listen) = 0;
		/** Deinitializes the Network and shutdown all connections
		*/
		virtual void Done() = 0;

		/** Connect to a the server
		*/
		virtual void Connect() = 0;
/*		virtual void Disconnect(char *ip,long port) = 0;*/

		/** Push a Object to the Outgoing list
		*	\param o the object to be pushed
		*
		*	o will be serialized, dipatched and sent to all clients witch need
		*	the Object.
		*/
		virtual void PushObject(GENERAL::sptr<GENERAL::CSerializeableObject> o, PClientInfoList destination) = 0;

		/** Normaly Networkclasses are multi threaded
		*	Call this function to prevent the networkclasse to access to any gamedata
		*/
		virtual void Lock(DWORD time=INFINITE) = 0;

		/** Normaly Networkclasses are multi threaded
		*	Call this function to reallow the access to the gamedata
		*/
		virtual void Unlock() = 0;
	};

/*	CNetwork *GetNetwork();
	void SetNetwork(CNetwork *network);*/
}

#endif