#ifndef CHATWORLD_H
#define CHATWORLD_H
#include <list>
#include <map>
#include <string>

#include <morfbase.h>
#include <morfmath.h>

namespace DOMAIN 
{

	class CChatDomain : public CDomain
	{
	protected:
		struct TIncomingObject
		{
			GENERAL::CBuffer *buffer;
			NETWORK::PClientInfoList from;

			inline TIncomingObject(GENERAL::CBuffer* _buffer,NETWORK::PClientInfoList _from) : buffer(_buffer), from(_from) {};
			inline TIncomingObject(const TIncomingObject &o) : buffer(o.buffer), from(o.from) {};
		};

		typedef std::list<TIncomingObject> TObjectList;
		typedef std::list<sptr<GENERAL::CSerializeableObject> > TNetworkEventList;

	private:
		TNetworkEventList networkEvents;
		TObjectList incomingObjects;

		bool isserver;
		bool shouldTerminate;
		char *name;

		//CObjectmanager *&objMan;
	protected:

		std::map<std::string,std::string> userPassMap;  // tempororay solution
		bool AuthUser(char *name, char *password);

		CDomain::TConsoleData consoleData; // remove this
	public:
		inline static CChatDomain *GetDomain() {return (CChatDomain*)APPLICATION::CApplication::GetApplication()->GetDomain();};

		// interface nach CNetwork 
		virtual void pushIncomingNetwork(GENERAL::CBuffer *o,NETWORK::PClientInfoList _from);
		virtual void pushNetworkEvent(sptr<GENERAL::CSerializeableObject> o);

		CChatDomain(bool _isserver);
		virtual ~CChatDomain();

		void handleNetwork();
		virtual void handleNetworkObject(sptr<GENERAL::CSerializeableObject> &so);
		virtual void updateObject(GENERAL::CBuffer &buffer, sptr<CGameObject> go, NETWORK::PClientInfoList from);

		virtual void execute();
		
		virtual bool ShouldTerminate();
		virtual void Terminate();

		virtual void Init();
		inline CSimpleObjectManager *GetObjMan() {return (CSimpleObjectManager*)objMan;}

		inline char *getName() { return name; };
		void SetName(char *_name);

	// methods called by the Frontend
		virtual CDomain::PConsoleData GetConsoleData();
		virtual PObjectList GetVisibleObjects(); // remove this - done via GetRoot

		

	};


}

#endif