#include "logindata.h"



#include <morfbase.h>

#include <trace.h>

using namespace GENERAL;

namespace DOMAIN 
{
	IMPLEMENT_SERIALIZEABLE(CLoginData)

	CLoginData::CLoginData() : CSerializeableObject(), name(NULL), password(NULL) 
	{
		SetClassKey(GET_KEY(CLoginData));
	}

	CLoginData::CLoginData(char *_name,char *_password)
	{
		SetClassKey(GET_KEY(CLoginData));
		name = strdup(_name);
		password = strdup(_password);
	}
	
	CLoginData::~CLoginData()
	{
		SAFE_FREE(name);
		SAFE_FREE(password);
	}

	long CLoginData::GetSerializedSize()
	{
		if ((name==NULL) || (password==NULL))
			DOMAINTHROW("Cannot serialize with no name or password defined");

		return (long)(
			CSerializeableObject::GetSerializedSize()+
			strlen(name)+strlen(password)+2*sizeof(long));
	}

	long CLoginData::Serialize(CBuffer &buffer)
	{
		CSerializeableObject::Serialize(buffer);

		long len=(long)strlen(name);
		buffer.Write(&len,sizeof(len));
		buffer.Write(name,len);

		len=(long)strlen(password);
		buffer.Write(&len,sizeof(len));
		buffer.Write(password,len);

		return buffer.GetPos();
	}

	long CLoginData::DeSerialize(CBuffer &buffer)
	{
		if (name!=NULL) delete [] name;
		if (password!=NULL) delete [] password;

		CSerializeableObject::DeSerialize(buffer);

		long len=*(long*)buffer.Read(sizeof(len));
		name=new char[len+1]; name[len]='\0';
		memcpy(name,buffer.Read(len),len);

		len=*(long*)buffer.Read(sizeof(len));
		password=new char[len+1]; password[len]='\0';
		memcpy(password,buffer.Read(len),len);

		return buffer.GetPos();
	}

	void CLoginData::Print(FILE *f,bool newline)
	{
		CSerializeableObject::Print(f,false);
		fprintf(f,"Name: %s, Password: %s",name,password);
		if (newline) fprintf(f,"\n");
	}
}