#include "serverobjectdomain.h"

#include <string>

namespace DOMAIN 
{
	GENERAL::CVector3f startingPos;

	CObjectDomain::~CObjectDomain()
	{
		allUsers.ReleaseRef();
	}


	void CObjectDomain::AddFoe(int odId, CVector3f pos)
	{
		static int foeID = 10000;

		sptr<CQuakeBsp> bsp = objMan->GetPtr(3);

		sptr<CMD3Object> co = sptr<CMD3Object>(new DOMAIN::CCharacterObject(
				this,
				odId,
				foeID++, 
				&bsp,
				//GENERAL::CVector3f(-739.0f, -298.0f, 170.0f),
//				GENERAL::CVector3f(-700.0f,23.0f,453.0f)
/*test6*/		pos,
//				startingPos,
				GENERAL::CVector3f(0.5f,0.5f,-1.0f),
				GENERAL::CVector3f(0.2f,0.2f,0.2f),
				1.0f, 1.0f, GENERAL::TBox(),
				GENERAL::CVector3f(0.0f,0.0f,0.0f)
				));

//		objMan->Add(co);


		co->Load();
		co->SetMovementMode(MOVEMENTMODE_GRAVITY);
		bsp->AddChild(co);
		co->AddLink(1,-28); 
		co->AddLink(4,-29); 
		co->AddLink(2,-30);
		co->SetControl();
		co->SetFSMState(2);
		co->SetSendToClientList(&allUsers);
		co->SetBoundingRadius(5);
		co->GetBoundingBox().minV = GENERAL::CVector3f(-13.218750,-3,-23.109375);
		co->GetBoundingBox().maxV = GENERAL::CVector3f(15.328125,14.093750,14.640625);

		objMan->Add(co);
	}

#define CREATE_OBJECTS

	void CObjectDomain::Init()
	{
		CChatDomain::Init();

//		CallScript("testmodule","forward","f",100.0);

	//	GAME::CGameFSM gfsm;

		sptr<CQuakeBsp> bsp;

		//objMan = (CSimpleObjectManager*)APPLICATION::CApplication::GetApplication()->GetObjectMan();
		//if (!objMan) objMan = new CSimpleObjectManager(this);

		char levelinfo[128];
		char *token, *eptr;
		strcpy(levelinfo,CONFIG::g_config.ServerConf["Level"].data());


		token=strtok(levelinfo,":");
		eptr = strtok(NULL,"");

		bsp = sptr<CQuakeBsp>(new CQuakeBsp(this,0,3,token));
		objMan->Add(bsp);
		bsp->Load();

		bsp->CreateOwnedChatChannel();
		long cc = bsp->GetOwnedChatChannel();
		objMan->GetPtr(cc)->SetSendToClientList(&allUsers);

		bsp->SetControl();

		startingPos.x = (float)strtod(eptr,&eptr);
		startingPos.y = (float)strtod(eptr+1,&eptr);
		startingPos.z = (float)strtod(eptr+1,&eptr);
	
//		bsp = new CQuakeBsp(3,"data/T8dm6.bsp");
//		bsp = new CQuakeBsp(3,"data/q3dm1.bsp");
//		bsp = new CQuakeBsp(3,"data/test2.bsp");

//		bsp = new CQuakeBsp(3,"data/chiro/maps/chiropteradm.bsp");

		rootObject->AddChild(bsp);
		rootObject->CreateOwnedChatChannel();
		cc = rootObject->GetOwnedChatChannel();
		objMan->GetPtr(cc)->SetSendToClientList(&allUsers);

#ifdef CREATE_OBJECTS
		sptr<CMD3Object> co= sptr<CMD3Object>(new DOMAIN::CWeapon(
						this,
						objMan->GetDescriptorID("items/weapons/railgun"),
						26, &bsp,
///*q3dm0*/				GENERAL::CVector3f(690.0f,12.0f,-2100.0f),
/*qfrag*/				GENERAL::CVector3f(-630.0f, -370.0f, 750.0f),
///*test6*/				GENERAL::CVector3f(459.0f, -3.0f, 54.0f),
						GENERAL::CVector3f(0.0f,0.0f,-1.0f),
						GENERAL::CVector3f(1.0f,1.0f,1.0f),
						1.0f, 1.0f, GENERAL::TBox(),
						GENERAL::CVector3f(0.0f,0.0f,0.0f)
						));
		co->Load();
		co->SetMovementMode(MOVEMENTMODE_FLOATING);
		bsp->AddChild(co);

		co->AddLink(1,-201); // rootnode laralower
		co->SetControl();
		objMan->Add(co);		
	
		co= sptr<CMD3Object>(new DOMAIN::CWeapon(
						this,
						objMan->GetDescriptorID("items/weapons/granadel"),
						31, &bsp,
///*q3dm0*/				GENERAL::CVector3f(690.0f,12.0f,-2100.0f),
/*qfrag*/				GENERAL::CVector3f(-290.0f,-110.0f,0.0f),
///*test6*/				GENERAL::CVector3f(-5.0f, 52.0f, 294.0f),
						GENERAL::CVector3f(0.0f,0.0f,-1.0f),
						GENERAL::CVector3f(1.0f,1.0f,1.0f),
						1.0f, 1.0f, GENERAL::TBox(),
						GENERAL::CVector3f(100.0f,0.0f,0.0f)
						));
		co->Load();
		co->SetMovementMode(MOVEMENTMODE_FLOATING);
		bsp->AddChild(co);
		co->AddLink(1,-203); // rootnode laralower
		co->SetControl();
		objMan->Add(co);

		co=sptr<CMD3Object>(new DOMAIN::CWeapon(
						this,
						objMan->GetDescriptorID("items/weapons/shotgun"),
						27, &bsp,
///*q3dm0*/				GENERAL::CVector3f(687.0f,65.0f,-100.0f),
/*qfrag*/				GENERAL::CVector3f(670.0f, -500.0f, 640.0f),
///*test6*/				GENERAL::CVector3f(560.0f, 92.0f, -552.0f),
						GENERAL::CVector3f(0.0f,0.0f,-1.0f),
						GENERAL::CVector3f(1.0f,1.0f,1.0f),
						1.0f, 1.0f, GENERAL::TBox(),
						GENERAL::CVector3f(0.0f,0.0f,0.0f)
						));
		co->Load();
		co->SetMovementMode(MOVEMENTMODE_FLOATING);
		bsp->AddChild(co);
		co->AddLink(1,-200); // rootnode laralower
		co->SetControl();
		objMan->Add(co);


		co=sptr<CMD3Object>(new DOMAIN::CWeapon(
						this,
						objMan->GetDescriptorID("items/weapons/lasergun"),
						30, &bsp,
///*q3dm0*/				GENERAL::CVector3f(687.0f,65.0f,-100.0f),
/*qfrag*/				GENERAL::CVector3f(500.0f, -240.0f, 110.0f),
///*test6*/				GENERAL::CVector3f(8.0f, -11.0f, -12.0f),
						GENERAL::CVector3f(0.0f,0.0f,-1.0f),
						GENERAL::CVector3f(1.0f,1.0f,1.0f),
						1.0f, 1.0f, GENERAL::TBox(),
						GENERAL::CVector3f(0.0f,0.0f,0.0f)
						));
		co->Load();
		co->SetMovementMode(MOVEMENTMODE_FLOATING);
		bsp->AddChild(co);
		co->AddLink(1,-202); // rootnode laralower
		co->SetControl();
		objMan->Add(co);

		co = sptr<CMD3Object>(new DOMAIN::CCharacterObject(
						this,
						objMan->GetDescriptorID("items/weapons/armor_upper"),
						28, &bsp,
///*q3dm0*/				GENERAL::CVector3f(670.0f,-37.0f,-700.0f),
/*qfrag*/				GENERAL::CVector3f( -100.0f, -210.0f,1680.0f),
///*test6*/				GENERAL::CVector3f(-542.0f, 92.0f, 551.0f),
						GENERAL::CVector3f(0.0f,0.0f,-1.0f),
						GENERAL::CVector3f(1.0f,1.0f,1.0f),
						1.0f, 1.0f, GENERAL::TBox(),
						GENERAL::CVector3f(0.0f,0.0f,0.0f)
						));
		co->Load();
		co->SetMovementMode(MOVEMENTMODE_FLOATING);
		bsp->AddChild(co);
		co->AddLink(1,-17); 
		co->SetControl();
		objMan->Add(co);  

		co = sptr<CMD3Object>(new DOMAIN::CCharacterObject(
						this,
						objMan->GetDescriptorID("items/weapons/armor_lower"),
						29, &bsp,
///*q3dm0*/				GENERAL::CVector3f(672.0f,26.0f,-1300.0f),
/*qfrag*/				GENERAL::CVector3f(-1200.0f, -200.0f, 480.0f),
///*test6*/				GENERAL::CVector3f(-450.0f, -3.5f, -231.0f),
						GENERAL::CVector3f(0.0f,0.0f,-1.0f),
						GENERAL::CVector3f(1.0f,1.0f,1.0f),
						1.0f, 1.0f, GENERAL::TBox(),
						GENERAL::CVector3f(0.0f,0.0f,0.0f)
						));
		co->Load();
		co->SetMovementMode(MOVEMENTMODE_FLOATING);
		bsp->AddChild(co);
		co->AddLink(1,-16); // rootnode laralower
		co->SetControl();
		objMan->Add(co);

		long blu = objMan->GetDescriptorID("character/lucy");

		co = sptr<CMD3Object>(new DOMAIN::CCharacterObject(
				this,
				objMan->GetDescriptorID("character/lucy"),
				50, 
				&bsp,
				//GENERAL::CVector3f(-739.0f, -298.0f, 170.0f),
				GENERAL::CVector3f(-700.0f,23.0f,453.0f),
///*test6*/		GENERAL::CVector3f(-438.0f, -3.5f, -146.0f),
//				startingPos,
				GENERAL::CVector3f(0.5f,0.5f,-1.0f),
				GENERAL::CVector3f(1.0f,1.0f,1.0f),
				1.0f, 1.0f, GENERAL::TBox(),
				GENERAL::CVector3f(0.0f,0.0f,0.0f)
				));
//		objMan->Add(co);


		co->Load();
		co->SetMovementMode(MOVEMENTMODE_GRAVITY);
		bsp->AddChild(co);
		co->AddLink(1,-13); 
		co->AddLink(4,-14); 
		co->AddLink(2,-15);
		co->SetControl();
		co->SetFSMState(2);
		co->SetSendToClientList(&allUsers);
		objMan->Add(co);


		co->CreateOwnedChatChannel();
		cc = co->GetOwnedChatChannel();
		objMan->GetPtr(cc)->SetSendToClientList(&allUsers);


		for (int i=0; i<5; i++)
		{
			AddFoe(objMan->GetDescriptorID("character/spider"),CVector3f(-355.0f,-500.0f,1270.0f));
			AddFoe(objMan->GetDescriptorID("character/spider"),CVector3f(500.0f, -240.0f, 110.0f));
		}

#endif
//		CVector3f vec(1,2,3);
//		CallScript("testmodule","forward","gi",&co,50);
		
//		CallScript("playercharacter","feetwalking_enter","g",NULL);

//		CGameObject *bluarg = &objMan->GetPtr(cc);
	}

	void CObjectDomain::execute()
	{
		Sleep(10);
		static double toang=0.0;
		CChatDomain::execute();

		TGameTick currentTick;
		TGameTick deltaTick;

		currentTick = APPLICATION::CApplication::GetApplication()->GetTicker().getTick();
		deltaTick = APPLICATION::CApplication::GetApplication()->GetTicker().getDeltaTick();


		DOMAIN::CSimpleObjectManager::TObjectMap &allMap=GetObjMan()->GetAllList();
		DOMAIN::CSimpleObjectManager::TObjectMap::iterator it;

		for (it=allMap.begin();it!=allMap.end();it++)
		{
			sptr<CGameObject> go=it->second;
			if (go->GetID()<=0) continue;

//			go = objMan->GetRef(1);
			go->TimeStep(deltaTick);
			if (go->IsControled() && (go->GetID()>0))
			{
				if (go->GetPDUTreshHold()>1.0f)
				{
//					dprintf("PDU sent!\n");
					CDomainCommand *doc=new CDomainCommand(this);
					doc->SetCommand(DOMAINCMD_PDU);
					doc->SetID(go->GetID());

					int pdusize = go->GetPDUSize();
					doc->SetParamLen(pdusize);
					char *data = (char*)malloc(pdusize);
					go->SetPDU();
					go->CopyPDUto(data);
					doc->SetParam(data);
	
					APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(doc,go->GetSendToClientList());
//1					doc->ReleaseRef();
				}
			}

/*			if ((go->GetSendToClientList()!=0) && ((currentTick-go->GetLastPush())>500))
			{
				go->SetTimeStamp(currentTick);
				APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(go,go->GetSendToClientList());
			}*/
		}


/*		go = objMan->GetRef(2);
		go->TimeStep(deltaTick);
		if ((currentTick-go->GetLastPush())>500)
			APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(go,go->GetSendToClientList());*/
			
		TUserInfoList::iterator uit;
		for (uit=userInfoList.begin(); uit!=userInfoList.end(); uit++)
		{
			if //((uit->second->hasReceivedAllData) && 
				((uit->second->nextping<currentTick))
			{
				Ping(*uit->second);
			}
		}

		GetObjMan()->CleanUp();
	}

	void CObjectDomain::PushGameObject(sptr<CGameObject> &go, NETWORK::PClientInfoList sendTo)
	{
		APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(go,sendTo);

		std::vector<sptr<CGameObject> > pushBefore;
		std::vector<sptr<CGameObject> >::iterator pbit;

		go->GetSerializeObjectsBefore(pushBefore);
		for (pbit=pushBefore.begin(); pbit!=pushBefore.end(); pbit++)
		{
			PushGameObject(*pbit, sendTo);
		}
	}

	void CObjectDomain::PushAllTo(NETWORK::PClientInfoList sendTo)
	{
		DOMAIN::CSimpleObjectManager::TObjectMap &allMap=GetObjMan()->GetAllList();
		DOMAIN::CSimpleObjectManager::TObjectMap::iterator it;

		for (it=allMap.begin(); it!=allMap.end(); it++)
		{
			if (it->second->GetID()>0)
			{
				CGameObject *blu = &it->second; 
				APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(it->second,sendTo);
			}
		}	
	}

	void CObjectDomain::PushLevelTo(sptr<CLevel> &lvl, NETWORK::PClientInfoList sendTo)
	{
//		APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(lvl,sendTo);
		PushGameObject((sptr<CGameObject>)lvl,sendTo);
		DOMAIN::CGraphObject::tChildsType::iterator it;
		for (it=lvl->GetChilds().begin();it!=lvl->GetChilds().end();it++)
		{
			if ((*it)->GetID()>0)
			{
				long blu = (*it)->GetID();
				PushGameObject((sptr<CGameObject>)*it,sendTo);
//				APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(*it,sendTo);
			}
		}

	}


	sptr<CGameObject> CObjectDomain::CreateUserObject(TUserInfo *ui)
	{
		static long id=6000;

		sptr<CLevel> bsp = objMan->GetRef(3);

		sptr<CMD3Object> to = sptr<CMD3Object>(new DOMAIN::CCharacterObject(
				this,
				objMan->GetDescriptorID("character/player"),
				id++, 
				&bsp,
				startingPos,
//	/* q3dm1  */GENERAL::CVector3f(650.0f,50.0f,-650.0f),
//	/* q3dm0  */GENERAL::CVector3f(410, 24, 262),
//  /* q3dm15 */GENERAL::CVector3f(-688, -40,-592),
//	/* test2  */GENERAL::CVector3f(0.0f,0.0f,0.0f),
				GENERAL::CVector3f(0.0f,0.0f,-1.0f),
				GENERAL::CVector3f(1.0f,1.0f,1.0f),
				1.0f, 1.0f, GENERAL::TBox(),
				GENERAL::CVector3f(0.0f,0.0f,0.0f)
				));
		to->SetFSMState(2);

		bsp->AddChild(to);

//		to->AddLink(1,-4); // rootnode laralower
//		to->AddLink(4,-5); // torso    laraupper 
//		to->AddLink(2,-6); // head     larahead
		to->AddLink(1,-1); 
		to->AddLink(4,-2); 
		to->AddLink(2,-3); 
/*		to->AddLink(1,-28); 
		to->AddLink(4,-29); 
		to->AddLink(2,-30); */
//		to->AddLink(1,-13); 
//		to->AddLink(4,-14); 
//		to->AddLink(2,-15); 
//		to->AddLink(5,-200); // head     larahead
		to->SetDeathReckoning();
		to->SetMovementMode(MOVEMENTMODE_GRAVITY);
		to->SetCollisionMode(COLLISIONMODE_BOX);
		objMan->Add(to);

		((sptr<CCharacterObject>)to)->GetStats()->SetKiType(0);

		to->SetSendToClientList(&allUsers);
		to->SetPDU();
		// local id is given (not good)

		ui->controllingObject=to;

		return to;
	}

	void CObjectDomain::handleDomainCommand(sptr<CDomainCommand> cmd)
	{
		switch (cmd->GetCommand())
		{
		case DOMAINCMD_GOTCONTROLLOBJECT:
			{
			}
			break;
		case DOMAINCMD_KILLED:
			{
				sptr<CGameObject> go = objMan->GetRef(cmd->GetID());
				
				if (go->IsControled())
				{
					if (ISOFTYPE(go,CCharacterObject))
					{
						((CCharacterObject*)&go)->SetHealth(0);
						((CCharacterObject*)&go)->GetBoundingBox().minV.y -= 5;
						((CCharacterObject*)&go)->MoveTo(((CCharacterObject*)&go)->GetPos()+CVector3f(0.0f,6.0f,0.0f));
					}
				}
			}
		case DOMAINCMD_PINGREPLAY: // pingReply
			{
				// unsafe cast
				sptr<CDomainCommand> request = objMan->GetRef(cmd->GetID());
				request->SetCanDelete(true);

				struct TPingReplyData {
					GENERAL::TGameTick senttick;
					GENERAL::TGameTick clienttick;
				} *prd = (TPingReplyData*)cmd->GetParam();

				GENERAL::TGameTick currenttick=APPLICATION::CApplication::GetApplication()->GetTicker().getTick();
				GENERAL::TGameTick pingtime=currenttick-prd->senttick;

				dprintf("Ping reply %ld ticks",pingtime);
				dprintf(", client tick %ld ticks\n",prd->clienttick);

				TUserInfo *ui = (TUserInfo*)request->GetUserdata();

				// calcuate avg pingtime
				if (ui->avgpingtime==(GENERAL::TGameTick)-1)
				{
					ui->avgpingtime=pingtime;
					for (int i=0; i<16; i++)
					{
						ui->pingtime[i]=pingtime;
					}
				} else {
					ui->lastpingNum++;
					ui->lastpingNum&=0x0f;
					ui->pingtime[ui->lastpingNum]=pingtime;

					ui->avgpingtime=0;
					for (int i=0; i<16; i++)
					{
						ui->avgpingtime+=ui->pingtime[i];
					}
					ui->avgpingtime>>=4;  // divide by 16
				}

				// check whether time should be synchonized
				GENERAL::TGameTick deltaTime=(prd->senttick+(pingtime>>1))-prd->clienttick;
				deltaTime=deltaTime<0?-deltaTime:deltaTime;
				//fprintf(stdout,"dt: %ld\n",deltaTime);
				if ((deltaTime>30) && (pingtime<=ui->avgpingtime*2))
				{
					SynchTime(*ui);
				}

				objMan->Release(request);
			}
			break;

		case DOMAINCMD_PDU:
			{
				sptr<CGameObject> go = objMan->GetRef(cmd->GetID());
				
				if (!go->IsControled())
				{
					if (go->GetPDUSize()==cmd->GetParamLen())
					{
						go->CopyPDUfrom((char*)cmd->GetParam());
					}
				}

				APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(cmd,&allUsers);
			}
			break;
		case DOMAINCMD_OBJECTACTION_REQUEST:
			{
				TDomainObjectAction *act = (TDomainObjectAction*)cmd->GetParam();
				sptr<CGameObject> go = objMan->GetRef(act->sourceObj);
				if (go!=NULL)
				{
					go->HandleDomainObjectActionRequest(cmd);
				} 
				else
				{
					/// @todo handle error
				}
			}
			break;
		case DOMAINCMD_OBJECTACTION_REPLY:
			{
				TDomainObjectAction *act = (TDomainObjectAction*)cmd->GetParam();
				sptr<CGameObject> go = objMan->GetRef(act->sourceObj);
				if (go!=NULL)
				{
					go->HandleDomainObjectActionReply(cmd);
				} 
				else
				{
					/// @todo handle error
				}
			}
			break;
		case DOMAINCMD_REQUEST_OBJECT:
			{
				#pragma warning(push)	
				#pragma warning(disable:4200)
				#pragma pack(push)
				#pragma pack(1)
				struct TRequest {
					unsigned char num;
					long ids[];
				} *reqdata = (TRequest*)cmd->GetParam();
				#pragma pack(pop)
				#pragma warning(pop)	
				for (int i=0; i<reqdata->num; i++)
					PushGameObject(objMan->GetPtr(reqdata->ids[i]),cmd->GetSendToClientList());
				
				//sptr<CDomainCommand> reply = sptr<CDomainCommand>(new CDomainCommand(this));
				cmd->SetCommand(DOMAINCMD_REQUEST_OBJECT_REPLY);
				cmd->SetParamLen(0);
				free(cmd->GetParam());
				cmd->SetParam(NULL);
				APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(cmd,cmd->GetSendToClientList());
			}
			break;
		}
	}


	void CObjectDomain::handleNetworkObject(sptr<GENERAL::CSerializeableObject> &so)
	{
		if (so->GetClassKey()==GET_KEY(NETWORK::CNetworkEvent))
		{
			sptr<NETWORK::CNetworkEvent> ne = so;
			switch (ne->GetTyp())
			{
			case NETWORK::CNetworkEvent::NEWCONNECTION:
				{
					TUserInfo *ui = new TUserInfo;
					ui->sendToUserList = new NETWORK::TClientInfoList();
					ui->sendToUserList->clear();
					ui->sendToUserList->push_back(ne->GetClientInfo());
					ui->isAuth=false;
					ui->hasReceivedAllData=false;
					ui->controllingObject=NULL;
					ui->username=NULL;
					ui->avgpingtime=-1;
					ui->lastpingNum=15;

					userInfoList[&ne->GetClientInfo()]=ui;
					Ping(*ui);
				}
//1				ne->ReleaseRef();
				break;
			case NETWORK::CNetworkEvent::CONNECTIONRESET:
			case NETWORK::CNetworkEvent::CONNECTIONSHUTDOWN:
				{
					TUserInfo *ui = userInfoList[&ne->GetClientInfo()];
					ui->sendToUserList->ReleaseRef();
//1					if (ui->controllingObject)
//1						ui->controllingObject->ReleaseRef();
					delete ui;
					allUsers.remove(ne->GetClientInfo());
					userInfoList.erase(&ne->GetClientInfo());
				}
				break;

			default:
				CChatDomain::handleNetworkObject(so);
			}
		} else if (so->GetClassKey()==GET_KEY(DOMAIN::CLoginData))
		{
			TUserInfo *ui = userInfoList[&so->GetSendToClientList()->front()];
			sptr<DOMAIN::CLoginData> ld=so;
			if (AuthUser(ld->name,ld->password))
			{
				ui->isAuth=true;
				ui->username=strdup(ld->name);
				allUsers.push_back(ui->sendToUserList->front());

				CreateUserObject(ui);
//				PushAllTo(ui->sendToUserList);
				PushLevelTo(
					(sptr<CLevel>)objMan->GetPtr(ui->controllingObject->GetLvl()->GetID()),
					ui->sendToUserList);
				PushGameObject((sptr<CGameObject>)ui->controllingObject,&allUsers);

				CDomainCommand *cd = new CDomainCommand(this);
				cd->SetCommand(1);
				cd->SetParamLen(sizeof(long));
				long *id = (long*)malloc(sizeof(long));
				*id=ui->controllingObject->GetID();
				cd->SetParam(id);
				APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(cd,ui->sendToUserList);
//1				cd->ReleaseRef();
			} else {
				so->GetSendToClientList()->front()->Shutdown();				
			}

//1			so->ReleaseRef();
		} else if (ISOFTYPE(so,DOMAIN::CGameObject))
		{
			if (so->GetClassKey()==GET_KEY(DOMAIN::CDomainCommand))
			{
				handleDomainCommand(so);
//1				so->ReleaseRef();
			} else {
				sptr<CGameObject> goOM = objMan->GetRef(((DOMAIN::CGameObject*)&so)->GetID());
				if (goOM!=NULL)
				{
		//			goOM->Assign((DOMAIN::CGameObject*)so);

					APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(goOM,goOM->GetSendToClientList());
					so->Print(stdout);
//1					so->ReleaseRef();
				} else {
					CChatDomain::handleNetworkObject(so);
				}
			}
		} else CChatDomain::handleNetworkObject(so);
	}

	void CObjectDomain::Ping(TUserInfo &ui)
	{
		sptr<CDomainCommand> dc = sptr<CDomainCommand>(new CDomainCommand(this));
		dc->SetCommand(2);
		dc->SetParamLen(sizeof(GENERAL::TGameTick));
		GENERAL::TGameTick *tick = (GENERAL::TGameTick*)malloc(sizeof(GENERAL::TGameTick));
		dc->SetParam(tick);
		dc->SetSendToClientList(NULL);
		dc->SetUserdata(&ui);
		dc->SetCanDelete(false);
		objMan->Add(dc);
		*tick = APPLICATION::CApplication::GetApplication()->GetTicker().getTick();
		ui.nextping=*tick+5000;

		APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(dc,ui.sendToUserList);
//1		dc->ReleaseRef();
	}

	void CObjectDomain::SynchTime(TUserInfo &ui)
	{
		struct TSynchTimeData {
			GENERAL::TGameTick servertick;
			GENERAL::TGameTick avgpingtime;
		} *std = (TSynchTimeData*)malloc(sizeof(TSynchTimeData));

		CDomainCommand *dc = new CDomainCommand(this);
		dc->SetCommand(DOMAINCMD_SYNCHTIME);
		dc->SetParamLen(sizeof(TSynchTimeData));
		dc->SetSendToClientList(NULL);
		dc->SetParam(std);
		std->servertick  = APPLICATION::CApplication::GetApplication()->GetTicker().getTick();
		std->avgpingtime = ui.pingtime[ui.lastpingNum];

		APPLICATION::CApplication::GetApplication()->GetNetwork()->PushObject(dc,ui.sendToUserList);
//1		dc->ReleaseRef();
	}

}


